'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 26 March 2005 at 10:53:15 pm'!
"Change Set:		MutantPrefab
Date:			25 March 2005
Author:			Chris Reuter <cgreuter@csclub.uwaterloo.ca>

This is a mangled version of the Prefab widget set.  Do not use this for
anything other than the GUI for Quest For Pants.  You can get a more
stable version of Prefab from SqueakMap or my website at www.blit.ca.

This file is released under the terms of the Squeak license.


"


!

Object subclass: #IconPanelEntry
	instanceVariableNames: 'icon text tag element '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!IconPanelEntry commentStamp: 'cr 7/20/2003 20:30' prior: 0!
This is a data structure holding information associated with icon panel entries.

!

Morph subclass: #ClippedImageMorph
	instanceVariableNames: 'form '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!ClippedImageMorph commentStamp: '<historical>' prior: 0!
I am a morph that displays an image.  If I'm smaller than the image, I display only
a part of it, centered.!

TextMorph subclass: #HookedTextMorph
	instanceVariableNames: 'hooks hookTarget dropKeys focusHook anyKeyHook '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!HookedTextMorph commentStamp: 'cr 4/9/2002 23:04' prior: 0!
This is a kind of TextMorph intended to be used by instances of PrefabEntry and PrefabEdit to display text.
In addition to displaying text and allowing it to be edited, it also notifies its owner when certain
things happen, e.g. a key-press.  That is, it provide hooks to common editing events.

It's an ugly hack on top of TextMorph but the only other way to do it that I can think of involves
writing a more Prefab-friendly version of TextMorph.  (Anyone looking for an interesting project?)

!

Object subclass: #OrientationAdjuster
	instanceVariableNames: 'client orienter orientation '
	classVariableNames: 'OrientationTranslation '
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!OrientationAdjuster commentStamp: 'cr 1/25/2003 16:05' prior: 0!
This class implements the transformations that need to be done on Prefabs that can have
both horizontal and vertical orientations.  It queries the object's orientation and adjusts values
accordingly.  Input values should be given with the assumption that the orientation is #vertical.
Instances will either return the (possibly) adjusted value or may function as a wrapper for certain
messages and just pass it on to the Prefab itself after making the appropriate adjustments.

More to come:

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2


The transformation(s) this does basically shifts between the existing coordinate set and
one where the display has been turned on its side and the origin moved to the new
top-left corner, i.e. a rotation of -90 degrees.

Thus, it is not safe to combine actual screen coordinates with rotated (i.e. "logical")
coordinates and expect the result to make sense.

!

Object subclass: #PositionalBinding
	instanceVariableNames: 'window widget topDist botDist leftDist rightDist '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!PositionalBinding commentStamp: '<historical>' prior: 0!
This class's instances maintain a list of which edges of an associated Prefab widget are to be fixed
relative to the right or bottom edges of its manager and can calculate the bounds of the widget given 
the managers bounds.

This class is used exclusively by FixedDistanceResizer.!

RectangleMorph subclass: #Prefab
	instanceVariableNames: 'foregroundColor tag minSize maxSize tabKey hasFocus '
	classVariableNames: 'Bitmaps '
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!Prefab commentStamp: '<historical>' prior: 0!
This is the abstract base class for all Prefabs.  It implements the common API for all Prefabs.

Prefabs are widgets designed to simplify the writing of conventional user interfaces.  Each is a common
GUI object with a simple and consistant (I hope) interface.  Furthermore, they provide a means to generate
source code to recreate their layout.

Unless you are working on the Prefab system itself, you should only ever need to send a Prefab instance
a message in one of the API categories.  (And if you need to do something that isn't provided by the API,
add it and send me (cgreuter@csclub.uwaterloo.ca) a change set.)


Here's the minimal manual:

        0) Go to a Morphic world
        1) From the "New Morph...">"Prefab" menu, create a PrefabConstruction.
                Resize it as desired.
        2) Create whichever control you want from the Prefab menu.  (Avoid
                "Prefab-Support" and "Prefab-Examples").
        3) If the control isn't purely decorative, use the "Set Tag" menu item
                to give it a unique identifier.  This gets turned into a Symbol.
        4) Resize, recolor, or otherwise configure the control as you see fit
                using the various main menu options.
        5) Drop the control onto the PrefabConstruction.
        6) Repeat steps 2-5 until bored.
        7) From the PrefabConstruction's menu, select "Construction Menu" > 
                "Display Construction Source".  This will open up a workspace containing
                the source code that recreates the GUI layout.
        8) Paste the source code wherever convenient.  This may be a subclass of
                PrefabManager if convenient.  However, the argument passed to the
                method must be a PrefabManager.
        9) To add semantic actions or otherwise programmatically tweak individual
                controls, use PrefabManager>>clientWithTag: with the tag as
                argument.  The tag must be a symbol.  This is a bit slow so you might
                want to store reference to often-referenced controls in an instance variable.
                
                You should only need to use those methods in the API categories to modify
                Prefab controls.

To edit an existing dialog:

        Calculator new buildOn: (PrefabConstruction new openInWorld)    

(Substitute your creation for "Calculator").

To give a PrefabManager a title bar, use #newInSystemWindow or #newInSystemWindowNamed:.

E.g. "Calculator newInSystemWindowNamed: 'My Calculator'.")



!

Prefab subclass: #IconPanelElement
	instanceVariableNames: 'picture text textPartWidth textPositionWord panelEntry '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!
Prefab subclass: #PrefabCheckButton
	instanceVariableNames: 'switch label selectResponse deselectResponse keyDown '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabCheckButton commentStamp: '<historical>' prior: 0!
This class implements labeled buttons that can be checked on unchecked by clicking.  The interface
is identical to that of PrefabButton except that you can assign separate actions to the
button's selection and deselection and query instances at any time as to whether they are
selected and/or set their selection.

See the class comment of PrefabResponse for an explanation of how callbacks work.

!

Prefab subclass: #PrefabEdit
	instanceVariableNames: 'text textTransform vScrollBar scrollPosition selection lastKillIndex font '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabEdit commentStamp: '<historical>' prior: 0!
This class implements a simple text editor.  It's not a *good* text editor, mind you, but it
does edit text and lets you scroll around a bit and it's easy to hook into your code.

(If you happen to fix any of its many deficiencies, send me a change set.).

!

Prefab subclass: #PrefabEntry
	instanceVariableNames: 'text textTransform returnResponse font '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabEntry commentStamp: '<historical>' prior: 0!
This class implements a minimal 1-line text entry widget, suitable for editing a small amount
of text such as a file name or user-id.  It also allows you to associate an action with
the return key.

Its height is fixed to one line of text.

Note: Due to HookedTextMorph not being particularly good, there's a (theoretically very large)
upper limit on how many characters can be put in such a widget before the text becomes
invisible due to the HookedTextMorph's attempts at wrapping the line.  Don't try to put a copy
of War And Peace in one of these.
!

Object subclass: #PrefabFileSelector
	instanceVariableNames: 'window dirField filenameField maskField fileScroller filePane '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Components'!

!PrefabFileSelector commentStamp: 'cr 8/4/2003 23:15' prior: 0!
Beginnings of a file selector.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

Prefab subclass: #PrefabFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabFrame commentStamp: '<historical>' prior: 0!
This class implements a rectangular region with an optional decorative border.  It may be used
to hold other Prefab widgets, although they continue to be managed by the instance's Manager.

PrefabFrames have two uses: 1) they look pretty and 2) they can be used to group PrefabRadioButtons
so that you can put multiple sets of them on one Manager.

The border may be raised, sunken or flush.


!

Prefab subclass: #PrefabIconPanel
	instanceVariableNames: 'entries rowLength elementPadding font iconExtent maxCharsDisplayed elementLayout multipleSelect selectedItems selectionColor doubleClickResponse selectResponse '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!
Object subclass: #PrefabKeystroke
	instanceVariableNames: 'charValue ctrl alt '
	classVariableNames: 'CharCodes CharNames '
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!PrefabKeystroke commentStamp: 'cr 1/9/2004 21:40' prior: 0!
This class implements a data structure representing a keystroke.  It contains the character value and modifiers. Instances can be created from a string description of the keystroke and can regenerate this description as necessary.  This is useful for providing an easy way to specify keyboard shortcuts.

For example, the following doIt creates a PrefabKeystroke for the PC 3-finger salute:

	PrefabKeystroke fromDescriptionString: 'CTRL+ALT+\8'

Alternately, you could get it like this:

	Character backspace asPrefabKeystroke withCtrlAlt

Structure:
 charValue 		SmallInteger 	-- The ASCII (or whatever) code of the character
 ctrl			Boolean			-- A flag indicating if the control key was pressed
 alt				Boolean			-- A flag indicating if the alt (or Command) key was pressed.

This class assumes that alt and command are the same thing.  This may or may not be correct on
all platforms.

 !

Prefab subclass: #PrefabLabel
	instanceVariableNames: 'labelMorph labelMorphMaxSize orientation imageID font '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabLabel commentStamp: '<historical>' prior: 0!
This class implements a label widget.  Labels are non-interactive widgets that display
either text or a picture.  If text, a string or Text may be used as input (but style information
is currently ignored).  Images may be given as a form, the name of an image file or
an entry in the Prefab image library.!

PrefabLabel subclass: #PrefabButton
	instanceVariableNames: 'response clickedIn action '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabButton commentStamp: '<historical>' prior: 0!
A prefab button.  It may contain a textual label or a bitmap just like a PrefabLabel.

Behaviour when pressed is determined by methods #action:, #args: and #target:.  See the
comment for PrefabResponse for an explanation of how this works.!

Prefab subclass: #PrefabListBox
	instanceVariableNames: 'transform items scrollPosition elementHeight indices selection selectionMode selectColor selectForeground vScrollBar selectResponse disabledForeground customForegrounds disabledColor disabled customBackgrounds font '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabListBox commentStamp: 'cr 4/15/2002 00:25' prior: 0!
This class implements a standard list-box widget.

In addition to providing a scrollable list, it allows you to associate an action with an item being
selected and to choose between allowing and disallowing multiple selections.

Entries in the list box must be a two-element array containing a string as its first element and an
arbitrary object as its second.  (You can get away with just giving it a string, in which case it will
treat it as an array containing two references to the same string.)  The string is what is displayed
in the associated listbox slot.  When accessing the listbox with the #at: method, this pair is what
is returned.  However, actions set with #actionClicked: receive only the second object as an argument.

PrefabListBoxes implement a very, very tiny subset of the interface to OrderedCollection as a means of 
adding or removing elements.  

A PrefabScrollBar can easily be plugged into it via the #vScrollBar: method.  

=== INTERNALS:

This class has the following instance variables:

	transform				TransformMorph	-- The transform that makes the elements move

	items					OrderedCollection	-- Contents of the listbox.  Each item is a pair of the
                                                             form {morph. aPairOrString second}.
	indices					IdentityDictionary	-- Mapping of element morph to index in 'items'.

	scrollPosition
	elementHeight
	selection				IdentitySet			-- Collection of selected elements (the morphs themselves)
	disabled					IdentitySet			-- Collection of disabled elements (the morphs themselves)
	selectionMode
	selectColor
	selectForeground

These hold the colours of items which have had them changed.  The dictionary is there to allow us to
restore the colour after a selection or disabling.

	customForegrounds		IdentityDictionary	-- Mapping of morph to default foreground color if it differs
                                                             from self foregroundColor.
	customBackgrounds		IdentityDictionary	-- Mapping of morph to default color if it differs from
                                                             self foregroundColor.

	disabledColor
	disabledForeground
	vScrollBar
	selectResponse
	font

To do: Some of this state should really be factored into another class.  In particular, information associated with
an entry (e.g. custom colors, selection, etc. should go into one class which will keep the invariants straight.)

!

Prefab subclass: #PrefabManager
	instanceVariableNames: 'resizer title frameColor beingResized focusColor tabOrder forceConstruction shortcuts '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Managers'!

!PrefabManager commentStamp: '<historical>' prior: 0!
This class implements the main window for a Prefab dialog.  It owns the various widgets
and also contains a PrefabResizer whose job it is to rearrange the widgets when the window
(i.e. a Manager) is resized.

Widgets owned and managed by a manager are called "clients".  (This relationship is more or
less the same as the master-slave relationship in Tk.  I changed the terminology because
I read too much Dilbert.)

A subclass, PrefabConstruction, provides drag+drop and source code generation.

!

PrefabManager subclass: #Calculator
	instanceVariableNames: 'display clearFirst '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Examples'!

!Calculator commentStamp: 'cr 4/27/2003 07:37' prior: 0!
This is a simple little calculator as can be found with any GUI from the early eighties on.  It's
not particularly useful but it looks nice and illustrates the RubberSheetResizer and how to hook
behaviour into the various GUI components.

Note: This is a subclass of PrefabManager, which I've since concluded is a Bad Idea.  At some point,
I'll change that--for the moment, do as I say, not as I do.

!

PrefabManager subclass: #EditorFrame
	instanceVariableNames: 'editor scroller '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Examples'!

!EditorFrame commentStamp: 'cr 4/27/2003 07:37' prior: 0!
A widget containing a PrefabEditor.  Demonstrates the use of the FixedDistanceResizer.  Doesn't
actually do anything useful.

Note: This is a subclass of PrefabManager, which I've since concluded is a Bad Idea.  At some point,
I'll change that--for the moment, do as I say, not as I do.

!

SystemWindow subclass: #PrefabManagerWrapper
	instanceVariableNames: 'client '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!PrefabManagerWrapper commentStamp: '<historical>' prior: 0!
This is a subclass of SystemWindow designed specifically to contain a single PrefabManager (or subinstance
thereof) in a manner compatible with the requirements of a Prefab construction.  Currently, this comes
down to preserving the Manager's current extent, restricting user resises to what it can tolerate and
resizing the Manager when the window is resized.
!

PrefabManager subclass: #PrefabMiddleManager
	instanceVariableNames: 'atomic '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Wrappers'!

!PrefabMiddleManager commentStamp: 'cr 12/9/2001 19:32' prior: 0!
Note to self:

	I think this class is probably useful as a base for complex, reusable GUI assemblies.  Therefore, it should
not allow construction since any instance (or subinstance) will be using a canned #buildOn: method.

Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

Prefab subclass: #PrefabMorphHolder
	instanceVariableNames: 'client clientResizePolicy '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabMorphHolder commentStamp: 'cr 7/17/2003 22:31' prior: 0!
PrefabMorphHolders are Prefab controls which each hold a single non-Prefab morph.  They
provide an interface between arbitrary Morphs and the Prefab system.  At the moment, this
consists solely of resizing and repositioning the client Morph when the Holder is resized.

There are two supported resize policies:

	#clientIgnored	-- Client size remains unchanged; client remains centered.
	#clientStretched -- Client is resized to fit the inner bounds of the Holder.

You may need to use #minSize: and #maxSize to prevent errors or ugliness, depending on the
tolerances of the client.

The relationship between a PrefabMorphHolder and its client must be hand-coded apart from
GUI construction.  Generally, you'll need to tag the Holder, then install the client after the
interface has been constructed with #buildOn:.

Examples:

	"Create a Holder holding a Flasher:"
	PrefabMorphHolder new client: Flasher new; openInWorld.

	"Create a Holder holding a Flasher which is resized to fit:"
	PrefabMorphHolder new client: Flasher new; clientResizePolicy: #clientStretched; openInWorld.



==Internals:

Structure:
 client					Morph	-- The client morph
 clientResizePolicy		Symbol	-- A flag indicating how the client should be treated when
								   the size changes.

(Note: This class will likely grow as I better understand the problem set.)

!

PrefabCheckButton subclass: #PrefabRadioButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabRadioButton commentStamp: '<historical>' prior: 0!
This class implements a radio button.  Radio buttons are like check buttons except that
only one button in a particular group can be selected at any one time.  A group is determined
by morph ownership.  That is, all PrefabRadioButtons owned by one morph are considered
the group.  If you want to have a bunch of independent groups of radio buttons on the
same window, put PrefabFrames in the manager and drop the radio buttons in the frame.
(If you don't like having frames, just make them the same color as the Manager and give them
flush borders--nobody will notice.)

See the class comment of PrefabResponse for an explanation of how callbacks work.

!

Object subclass: #PrefabResizer
	instanceVariableNames: 'parcels window '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Resizing'!

!PrefabResizer commentStamp: '<historical>' prior: 0!
This class retains a list of clients belonging to a Manager as well as their positions and does
real-estate management for them.  In particular, it resizes and repositions the clients
when the manager is resized. Subclasses implement different policies.  This one implements
the default--do nothing.  It works OK on non-resizable dialogs but if you want a dialog
that can be resized, use a RubberSheetResizer or FixedDistanceResizer.

It is the programmer's responsibility to set the Manager's maximum and minimum sizes to
something reasonable.  It's possible to get ugliness or divide by zero errors if you let the user
make a window too small.
!

PrefabResizer subclass: #FixedDistanceResizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Resizing'!

!FixedDistanceResizer commentStamp: '<historical>' prior: 0!
This class implements a semi-intelligent way of allowing windows to be resized by letting
the programmer fix the positions of some vertices relative to the right or bottom edges of the
Manager.

For example, an EditorFrame contains a PrefabFrame full of buttons, a PrefabEdit and
a PrefabScrollbar.  (To take a look at it, evaluate this:

	EditorFrame newInSystemWindow

) 

<more details go here.>

Thanks to Kannan Vijayan for giving me the original idea for this (which he got from Visual
Basic.)!

Object subclass: #PrefabResponse
	instanceVariableNames: 'action target args '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!PrefabResponse commentStamp: '<historical>' prior: 0!
This class implements the basic callback mechanism for Prefab widgets.  When sent the message 
#invoke or #invokeWith: (or variants thereof), it does something--either sends a message to an object
or evaluate a block, possibly with arguments.  It attempts to be as tolerant as possible.  For example, if
invoked before an action has been assigned, nothing happens.

Typically, a Prefab will provide three methods named #action*:, #args*: and #target*: (where * may be
some other series of letters--or not.)  These typically just do calls the corresponding methods in a
PrefabResponse.  When an event occurs, the widget sends its PrefabResponse the message #invoke (or
some variant thereof) causing an action to be performed.

There are two ways in which an action may be assigned to a PrefabResponse (and, by extension, a Prefab.)
The first is to send #action: with a block context as the argument.  The second is to make the argument
a message name and send #target: with the (non-nil) object that should receive the message when the 
event occurs.  In either case, you can use #args: to set one or more additional arguments to hand off 
to the block or method invocation.  Make sure that your method or block accepts the right number 
of arguments or else you'll be facing the debugger.

Responses attempt to be smart about how they pass arguments.  If the action (i.e. block or message)
requires the same number of arguments as are available, the args are passed on per formal parameter.
If the action requires one argument and more are available however, the args are bundled into an array
and the array passed as the whole argument.  Otherwise, an error occurs.

Note: You should not need to create or otherwise deal with PrefabResponses unless you are hacking on
Prefab itself, rather than just using it.

!

Prefab subclass: #PrefabScrollBar
	instanceVariableNames: 'slider sliderShadow orientation forwardButton backwardButton response ratio stepSize cnhDirection ignoreSteps fractionalPosition '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabScrollBar commentStamp: 'cr 5/4/2002 05:40' prior: 0!
This class implements a Prefab-style scroll bar.  These can be oriented both horizontally
and vertically.

The easiest way to use a scrollbar is simply to pass it to a PrefabEdit or PrefabListBox via
their #vScrollBar: message.  However, you can also take manual control of a scroll bar with
the API.

=== INTERNALS:

This class has the following instance variables:

	slider					RectangleMorph		-- The slider
	sliderShadow			RectangleMorph		-- The bit where the slider used to be when dragged.
	orientation				Symbol				-- Orientation of the bar, either #horizontal or #vertical
	forwardButton			PrefabButton		-- The up/left button.
	backwardButton			PrefabButton		-- The down/right button.
	response				PrefabResponse		-- The Response which is invoked whenever the position
												   changes.
	ratio					Float				-- The ratio of slider length to slider trough length.
	fractionalPosition		Float				-- The position of the slider within its range of movement,
												   normalized to a number between 0.0 and 1.0.  (This used
												   to just be calculated from the slider position but it turns out
												   not to work if the increment is too small.  The movement gets
												   lost to rounding.)
	stepSize					Float				-- Amount by which to change the slider position when one of 
												   the buttons is pressed, stored as a fractional difference (i.e.
												   the amount to add to fractionalPosition.)
	cnhDirection			Float				-- Amount by which to adjust fractionalPosition during click-and-
												   hold dragging.
	ignoreSteps				Integer				-- Number of Morphic steps (i.e. sends of the #step method) to
												   wait before starting to move the slider.  This is so that click-
												   and-hold dragging will be nicely delayed for a bit so that the
												   user doesn't do it accidentally.



	!

PrefabMiddleManager subclass: #PrefabScrollableWrapper
	instanceVariableNames: 'scroller payload '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Wrappers'!

!PrefabScrollableWrapper commentStamp: 'cr 9/1/2002 03:59' prior: 0!
PrefabScrollableWrapper is an abstract base class for implementing droppable components consisting
of some scrollable Prefab (currently a ListBox or Edit) with a vertical scrollbar attached.  These are
handy when trying to mix resize policies.  For example, you can drop one into a PrefabSlicedFrame
and the whole thing will be show up in the generated source (I hope).

Subclasses of PrefabScrollableWrapper are MiddleManagers containing a vertical scrollbar and
some other Prefab.  The scrollbar is on the left side, expands vertically but stays the same width.  The
other Prefab expands to fill the remaining space.

You can create a subclass easily--just override the method #payloadClass.  The payload must respond
to #vScrollBar: in the expected way.

To do: provide a way to adjust the width of the scrollbar.!

PrefabScrollableWrapper subclass: #PrefabEditScrollableWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Wrappers'!
PrefabScrollableWrapper subclass: #PrefabListBoxScrollableWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Wrappers'!
PrefabManager subclass: #PrefabScrollingManager
	instanceVariableNames: 'contentTransform hScrollBar vScrollBar extentPadding '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Managers'!

!PrefabScrollingManager commentStamp: 'cr 6/8/2003 22:00' prior: 0!
This is a Manager which, rather than resizing its contents, allows the user to scroll around the
screen if necessary.  It will display scrollbars when required to.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

Prefab subclass: #PrefabSeparator
	instanceVariableNames: 'adjuster orientation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab'!

!PrefabSeparator commentStamp: '<historical>' prior: 0!
This class implement a separator.  This is a simple Prefab that displays a horizontal or vertical ridge or groove in order to provide a visual separator between visual elements.

Note that foreground color is ignored for inset separators.  This is probably a feature.
!

PrefabManager subclass: #PrefabSlicedFrame
	instanceVariableNames: 'orientation clients clientList adjuster minSlice '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Managers'!

!PrefabSlicedFrame commentStamp: 'cr 7/14/2002 23:48' prior: 0!
Frame containing several areas whose size (and contents) can be adjusted by moving around sliders.

Bugs:

	It doesn't correctly handle the case where resizing a slice makes it bigger than the maxSize of the object
contained therein.  It *does* handle the converse, however.

=== INTERNALS:

This class has the following instance variables:

Structure:
 orientation		Symbol			-- One of #horizontal or #vertical--the orientation of the slices.  More
                                         specifically, it's the orientation of the dividing lines, so an
                                         instance with orientation #horizontal has the sub-windows placed
                                         vertically but separated with horizontal dividers.
 clients			OrderedCollection-- The list of clients.  This also contains the separators.
 minSlice		Integer			-- The minimum size of a slice.

!

PrefabResizer subclass: #RubberSheetResizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Resizing'!

!RubberSheetResizer commentStamp: '<historical>' prior: 0!
This is a PrefabLayout that moves and stretches the clients so that they are always the
same size *relative* to the manager's size--that is, they stretch or shrink to match
the window's size.  This is occasionally useful, but frankly, it almost always sucks.
You will usually want to use a FixedDistanceResizer instead.

Internally, parcels are stored as fractional sizes on a rectangle of size 0@0 extent: 1@1.
For example, a parcel occupying the top-left quarter of the manager will be stored
as 0@0 extent (1/2)@(1/2).

!

Prefab subclass: #SliceDivider
	instanceVariableNames: 'lineWrapper knobWrapper orientation adjuster '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!
RectangleMorph subclass: #SliceDividerKnob
	instanceVariableNames: 'orientation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!SliceDividerKnob commentStamp: 'cr 11/9/2002 22:43' prior: 0!
This is a simple rectangle with a nice border to be used as the knob in a SliceDivider.
It also implements the #orientation protocol so that it can be used with an OrientationAdjuster.
!

PrefabLabel subclass: #SlicePlaceholder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!SlicePlaceholder commentStamp: 'cr 1/4/2002 02:36' prior: 0!
This class is a simple ugly panel that fills a slot in a PrefabSlicedFrame and gets replaced by whatever is dropped on it.  This here because managers in slots will often grab dropped objects themselves, rather then letting the SlicedFrame place it in its own slot.


!

Object subclass: #SlicedFrameClientList
	instanceVariableNames: 'frame clients separators '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!SlicedFrameClientList commentStamp: 'cr 11/11/2002 00:00' prior: 0!
Class containing all the clients of a PrefabSlicedFrame.  It's "duties" are:

	1) Maintain the order (top to bottom) of the clients
	2) Automatically insert and remove separators as necessary.
	3) Hide the presence of separators unless explicitly asked for.
	4) Automatically allocate OrientationAdjusters for the clients and separators

Notes to self:

	-The separator belongs to the client below it.  This means that only the first client does not have an associated
	 separator.



Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

PrefabButton subclass: #SwitchElement
	instanceVariableNames: 'otherColor isClicked toggleMode unclickedColor highlightColor clickedColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!SwitchElement commentStamp: 'cr 3/24/2002 00:05' prior: 0!
In a check- or radio-button, this class implements the actual button part of it, (as opposed to the label part on
the right).  Used by PrefabRadioButton and PrefabCheckButton.

This is pretty icky.!

Object subclass: #TabOrder
	instanceVariableNames: 'tabOrder manager '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!TabOrder commentStamp: 'cr 7/7/2004 21:47' prior: 0!
This object keeps a list of clients to be tabbed through and keeps track of the current one.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.


==================================

This goes here for now:


I really don't like the current plan.  Ideally, I'd like to stay as close to what the system does and still
get the behaviour I want.

What I know about the system so far:

	It looks like most morphs grab the focus on #mouseEnter.  That is, focus happens when the Morph decides it
	wants it.

	#hasFocus doesn't get used to determine the focus--it's up to the morph to implement it correctly.  It's there to
	tell you whether the current morph has the focus.

	Focus is determined by the hand and set with #newKeyboardFocus:.

	When focus changes (via #newKeyboardFocus:), the gainer and loser both receive #keyboardFocusChange:

	It appears to be safe to set the focus to a new Morph from #newKeyboardFocus: when it's given a true.  False
	may also be okay, but we don't need that.

What I need:

	click-to-focus behaviour at the top level.

	Moving the focus from Prefab to Prefab by hitting the tab key or the like.

	Pressing buttons, etc., with the keyboard.

	The perception of atomicity.  That is, when a Prefab (e.g. a TextEdit) has sub-components, one of which
	needs the focus, it appears to the user that the outermost component has the focus.
	(Hmmm.  What if we just always make the outer element have focus and pass on the keyboard events?)

	Developer-settable keystroke events associated with the toplevel window.  In real life, these and tabbing tend
	to not go together very often, but I'd still like them to both be available.
	(Idea: the Manager owns the shortcuts, prefabs pass uneaten keystrokes back to the owner?)

	Focus memory.  That is, if a toplevel loses, then regains focus, the client that had focus when it was lost
	gets it back.

	Tabbing order defaults to something reasonable but may be overridden.

What I Currently have:

	PrefabKeystroke class provides a data structure to hold an individual keystroke.
	
	TabOrder class holds the list of items to be tabbed through.  (Will probably need to be fixed).

	#tabKey API methods.

	implementation of #keyboardFocusChange: and #hasFocus in Prefab.

	abstract method #showFocus: which changes the Prefab's appearance to make it look focussed.

	#anyKeyHook: (HookedTextMorph) and #tryAsShortcut to let the manager poach keystrokes from edit widgets.

	#takeFocusOn: method to set the focus to the receiver's active element

	#hasLogicalFocus to indicate the component has the focus *somewhere* within itself.  

	#neverGetsFocus, #wantsFocus tests in Prefab.

	All focus-switching is done by tabbing.








==============================================================

Keyboard Focus Rules:

***See Update Below***

	1)	Any client can grab the focus for itself.

		The toplevel manager may take the focus away and hand it to another client.

		The toplevel manager gets to poach keystrokes from any of its clients to use as
		shortcuts.

		The client gets to choose which key (if any) will prompt the manager to pass the
		focus on to the next client.  (By default, this will be the tab key, but it's changable.
		Also, some clients need the tab (e.g. editors) and may default to something else.)

	3)	Clients may decline the focus by returning false from #wantsFocus.  Managers are excepted
		from this: they never get the focus unless they are the toplevel but when they are, they *must*
		accept it gracefully.  Managers should implement #wantsFocus in accordance with this policy.
		The easiest thing to do is just have them always return true.

	4)	Client classes may reject the focus outright by implementing #neverGetsFocus to return true.  This
		may not change once the instance has been created.  (i.e. this is an attribute of the class, NOT
		the instance.)  Implementations of #wantsFocus must honour this.

	5)	The app. developer should be able to manually set and alter the tabbing order.

	6)	A client will typically get the focus (unless it doesn't want it) when clicked.

	7)	Tabbing from a client not in the tab order advances to the next client in the tab order.

	8)	The message #hasLogicalFocus is similar to #hasFocus but is granular at the Prefab level.



Notes:

	Prefabs that can be disabled need to handle keyboard events gracefully even when disabled.  Otherwise,
there could be race conditions where a Prefab is disabled between the call to wantsFocus and the arrival of the
keystroke event.


Update:

I took another look at this and I'm having trouble figuring out what I was thinking before.  
This is always a bad sign.  

I suspect that I was confused as to the roles of the various components here, so here's my take
on how things should be:

	We want:
		-default click-to-focus behaviour
		-the ability to move the focus within a window using the tab key
		-global (within the main window) keyboard shortcuts.

	Morphic offers:
		-click-to-focus at the SystemWindow level
		-focus-follows-mouse everywhere else (?)

	I *think* there's no easy way to make Morphic do things differently, so the way it should
	(and maybe does?) work is:

		1) We ignore (as much as possible) the system focus and instead implement a
			logical focus.  This is relative to that window only. (i.e. every toplevel manager
			maintains its own logical focus that only takes effect when that Manager's window
			is selected.)

		2) All Prefabs will accept all keystroke events.

		3) If a Manager contains clients that will accept keystrokes, one of them MUST
			have the logical focus.

		4) When a Prefab receives a keystroke, it hands it off to its toplevel Manager.  The
			Manager first checks it to see if it's been registered as a global shortcut and if so,
			activates the associated Response.  If not, it searches for the client with the logical
			focus and the keystroke event to it.  If there is none, it drops the event.




==================
Old:

	1) The top-level Manager controls the focus.  By which I mean, it a) controls tabbing and
		also may poach keystrokes from any client.
		(Question: what about atomic middle-managers?)

		(For the moment, have each morph ask its manager on each keystroke.  If this is
		too slow, make that switchable by the Manager.  (Check this on Pentium or worse.).)  

	2a) In addition to this, all clients which accept keystrokes should implement a user-settable keystroke
		which will cause it to signal the manager to advance the focus to the next client.  This is typically
		the tab key.  Relinquishing is done by sending the manager the message: #advanceFocusToNext.
		Setting this to 'nil' will disable this capability.
!

Object subclass: #TabbingTest
	instanceVariableNames: 'morph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Experiments'!
Object subclass: #TempNameSet
	instanceVariableNames: 'names lastGen '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Support'!

!TempNameSet commentStamp: 'cr 12/9/2001 20:35' prior: 0!
This class will generate a unique (for its instance) temp. variable name, return it and on request, produce a string containing the declarations of them.

Structure:
 names			Set 	      -- Set of all names generated so far
 lastGen			Integer   -- The numeric part of the last generated name.

Generated symbols are of the form "tempXXX" where XXX is an integer.!

PrefabManager subclass: #TestWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Prefab-Examples'!

!TestWidget commentStamp: 'cr 4/27/2003 07:38' prior: 0!
This is the beginning of a complex widget which is supposed to exercise most of the system in one go,
Perhaps this is optimistic.

Note: This is a subclass of PrefabManager, which I've since concluded is a Bad Idea.  At some point,
I'll change that--for the moment, do as I say, not as I do.

!

ImageReadWriter subclass: #XPMReadWriter
	instanceVariableNames: 'width height numColors colorMap symbolicColors charsPerPixel hotspot hasExtension extension varName writeColorMap '
	classVariableNames: 'RGBNames '
	poolDictionaries: ''
	category: 'Graphics-Files'!

!XPMReadWriter commentStamp: 'cr 4/27/2003 02:29' prior: 0!
This class implements a reader and writer for XPM-style files.

XPM is a simple text-based image format suitable for small images such as icons.
It's parsable by a C compiler (*really* useful here, I know), capable of being modified
and viewed (if you squint a bit) with an ordinary text editor, and supports transparency.
Of course, there's no compression whatsoever, so it's not the ideal format for big images.

All of the non-image parts of XPM (hotspot, symbolic colors, extensions) are supported but
not well tested.  You can get at them via accessors before writing or after reading.

Note that since XPM files tend to use Unix-style line-end conventions, you may wish to
use CrLfFileStream under non-Macintosh environments.  If not, you will need to be
careful about that.  It should work on data with incorrect newline characters but it hasn't
been tested on it.

XPM documentation (and C libraries) are available in the contrib section of the standard
X11 distribution at, e.g., ftp://ftp.x.org/contrib/libraries.
!


!Character methodsFor: 'testing' stamp: 'cr 1/23/2000 18:47'!
isPrintable
	"Answer whether this character is printable."
	^value >= 32 and: [value < 127].! !

!Character methodsFor: 'Prefab-conversion' stamp: 'cr 3/3/2002 21:12'!
asPrefabKeystroke
	^PrefabKeystroke fromCharacter: self.! !


!Color methodsFor: 'printing' stamp: 'cr 9/29/1999 22:42'!
x11ColorString: detail
	"Return a string containing a valid X11 name for this color.  This is a string of the
	 form '#rgb', '#rrggbb', or '#rrrrggggbbbb' where r, g and b are sequences of hex
	 digits holding red, green and blue values.  'detail' is the number of digits required
	 and must be 1, 2, 3 or 4."
	| maxRgbVal result hexVal |
	
	"Paranoia"
	(detail < 1 or: [detail > 4])
		ifTrue: [self error: 'X11 color strings must be 1 to 4 digits per color.'].

	maxRgbVal := (1 << (detail * 8)) - 1.
	
	result := WriteStream on: (String new: 20).
	result nextPut: $#.

	{self red. self green. self blue} do: [ :i |
		hexVal := (i * maxRgbVal) asInteger hex8.

		"Trim off leading 16r and unnecessary digits."
		hexVal := hexVal copyFrom: 8 + (4 - detail) to: hexVal size.
		result nextPutAll: hexVal.
	].

	^result contents.! !


!IconPanelEntry methodsFor: 'initialization' stamp: 'cr 7/20/2003 20:29'!
icon: i text: txt tag: tg
	icon := i.
	text := txt.
	tag := tg.
! !

!IconPanelEntry methodsFor: 'accessing' stamp: 'cr 7/20/2003 21:12'!
element
	^element
! !

!IconPanelEntry methodsFor: 'accessing' stamp: 'cr 7/20/2003 21:12'!
element: anElement
	element := anElement.
! !

!IconPanelEntry methodsFor: 'accessing' stamp: 'cr 7/20/2003 20:29'!
icon
	^icon
! !

!IconPanelEntry methodsFor: 'accessing' stamp: 'cr 7/20/2003 20:29'!
tag
	^tag! !

!IconPanelEntry methodsFor: 'accessing' stamp: 'cr 7/20/2003 20:29'!
text
	^text
! !


!IconPanelEntry class methodsFor: 'instance creation' stamp: 'cr 7/21/2003 22:13'!
icon: i text: txt tag: t 
	^self new
		icon: i text: txt tag: t;
		yourself.! !


!KeyboardEvent methodsFor: 'Prefab-conversion' stamp: 'cr 3/3/2002 20:06'!
asPrefabKeystroke
	^PrefabKeystroke fromKeyboardEvent: self.! !


!Morph methodsFor: 'classification' stamp: 'cr 7/9/1999 21:47'!
isPrefab
	^false.! !


!ClippedImageMorph methodsFor: 'other' stamp: 'cr 2/23/2003 08:10'!
drawOn: aCanvas

	| sourceRect |

"	super drawOn: aCanvas."

	sourceRect := (Rectangle center: form boundingBox center extent: self extent).
					"translatedToBeWithin: (0@0 extent: form extent)."
	aCanvas image: form at: self bounds origin sourceRect: sourceRect rule: Form paint.
	! !

!ClippedImageMorph methodsFor: 'other' stamp: 'cr 2/23/2003 08:02'!
extent: aPoint
	"Set extent.  I may not be bigger than my form."
	^super extent: (aPoint min: form extent)
! !

!ClippedImageMorph methodsFor: 'other' stamp: 'cr 6/30/1999 23:22'!
initialize
	super initialize.
	self form: ClippedImageMorph defaultForm.! !

!ClippedImageMorph methodsFor: 'other' stamp: 'cr 6/30/1999 23:25'!
readFromFile
	| fileName |
	fileName _ FillInTheBlank
		request: 'Please enter the image file name'
		initialAnswer: 'fileName'.
	fileName isEmpty ifTrue: [^ self].
	self form: (Form fromFileNamed: fileName).
! !

!ClippedImageMorph methodsFor: 'other' stamp: 'cr 6/30/1999 22:04'!
releaseCachedState

	super releaseCachedState.
	form hibernate.
! !

!ClippedImageMorph methodsFor: 'accessing' stamp: 'cr 6/30/1999 22:02'!
form
	"Return value of instance variable 'form'"
	^form! !

!ClippedImageMorph methodsFor: 'accessing' stamp: 'cr 7/4/1999 17:00'!
form: newValue
	"Set value of instance variable 'form'."
	form := newValue.

	"Make sure I'm exactly the size of my new form."
	self extent: form extent.
! !


!ClippedImageMorph class methodsFor: 'as yet unclassified' stamp: 'cr 6/30/1999 23:12'!
defaultForm
	"Return a 1-bit Form of the mouse."
	^ Form extent: 30@29 depth: 1
			fromArray: #( 0 0 0 0 0 335544480 33554688 0 8389632 0 
							272631840 268435488 268435488 269492256 
							3698688 141615168 3698688 0 0 1072906224 
							2164754436 403144800 0 67108992 0 0 0 0 0)
			offset: 0@0.! !


!HookedTextMorph methodsFor: 'all' stamp: 'cr 4/9/2002 23:39'!
addHookFor: aKey withMessage: aSymbol
	"Set this morph to notify its owner when 'aChar' is hit.  The hook gets one argument: the event that triggers
	 the hook.  The argument is ignored if the message doesn't take one.  If the result is not a boolean,
	 it is considered 'false'."
	hooks at: aKey put: aSymbol.! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/13/2000 18:57'!
drawNullTextOn: aCanvas
	"Avoid that ugly pink background."
	aCanvas paragraph: self paragraph bounds: bounds color: color
! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/19/2000 22:46'!
dropKeys
	"If true, eat all keystrokes that haven't been hooked."
	^dropKeys! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/7/2000 22:59'!
dropKeys: aBoolean
	"If true, eat all keystrokes that haven't been hooked."
	dropKeys := aBoolean.! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/13/2000 18:03'!
focusHook: aMessage
	focusHook := aMessage.
! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 1/23/2000 07:55'!
hookTarget: aPrefabEntry
	"Set the object to notify "
	hookTarget := aPrefabEntry.! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 3/3/2002 22:07'!
initialize
	super initialize.

	hooks := Dictionary new.
	dropKeys := false.
! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 4/10/2002 00:01'!
keyStroke: evt
	| keyObj newKey before after msg |
	"Intercept the keystroke.  If there's a hook (i.e. a PrefabResponse) defined for this key, execute it and
	 hand the return value off to the superclass's keyStroke (unless it's nil, in which case we drop it on 
	 the floor.)"

	"(evt printString, (evt commandKeyPressed ifTrue: ['CMD'] ifFalse: ['']), '     ') displayAt: 0@0."

	"Give the owner a chance to poach this keystroke"
	(anyKeyHook notNil and: [hookTarget perform: anyKeyHook with: evt])
		ifTrue: [^self].

	before := self editor selectionInterval.

	(hookTarget notNil and: [hooks includesKey: (keyObj := evt asPrefabKeystroke)])
		ifTrue: [
			(msg := hooks at: keyObj) numArgs > 0
				ifTrue: [newKey := hookTarget perform: msg with: evt]
				ifFalse: [newKey := hookTarget perform: msg].

			"Eat the event if false or a non-boolean is returned."
			newKey = true
				ifFalse: [
					^self.
				].

			"To do:  some way of letting the hook modify the key value.  Maybe."
		].

	"To do: support navigation by modified keystroke (e.g. emacs key bindings)."

	"Pass on this event if dropKeys is false.  This is used to do read-only text panes.
	 Also, if there's a modifier, we can drop it.  This bypasses those nifty features
	 that we don't want end-users to stumble on."
	(dropKeys or: [evt anyModifierKeyPressed])
		ifFalse: [super keyStroke: evt].

	after := self editor selectionInterval.

	hookTarget ifNotNil: [hookTarget scrollAfterSelection: after changedFrom: before].

	"(self editor selectionInterval first printString, '   ') displayAt: 0@0."

! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 2/13/2002 20:01'!
keyboardFocusChange: aBool
	"Allow the owner to do something if focus changes."
	(focusHook notNil and: [hookTarget notNil])
		ifTrue: [hookTarget perform: focusHook with: aBool].

	^super keyboardFocusChange: aBool.! !

!HookedTextMorph methodsFor: 'all' stamp: 'cr 1/23/2000 13:10'!
removeHookFor: aChar
	"Set this morph to not notify its owner when 'aChar' is hit."
	hooks at: aChar asciiValue put: nil.! !

!HookedTextMorph methodsFor: 'accessing' stamp: 'cr 3/6/2002 22:25'!
anyKeyHook: hook
	anyKeyHook := hook.! !


!OrientationAdjuster methodsFor: 'initialization' stamp: 'cr 11/10/2002 20:21'!
client: c orienter: or
	"Initialize this instance."

	client := c.

	or isNil
		ifTrue: [orienter := c]
		ifFalse: [orienter := or].

	[orienter respondsTo: #orientation] assert.	! !

!OrientationAdjuster methodsFor: 'initialization' stamp: 'cr 11/10/2002 20:22'!
initialize: aPrefab
	"Initialize using one morph."
	self client: aPrefab orienter: aPrefab.! !

!OrientationAdjuster methodsFor: 'accessing' stamp: 'cr 11/4/2002 19:34'!
client
	^client! !

!OrientationAdjuster methodsFor: 'orientation' stamp: 'cr 11/23/2002 13:00'!
oppositeOrientation
	self clientOrientation = #vertical
		ifTrue: [^#horizontal]
		ifFalse: [^#vertical].! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 21:29'!
bottom
	^self performTranslatedVersionOf: #bottom! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 21:30'!
bottom: coord
	^self performTranslatedVersionOf: #bottom: withArgs: {coord}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/9/2002 23:59'!
bottomLeft
	^self performTranslatedVersionOf: #bottomLeft! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/9/2002 23:59'!
bottomLeft: coord
	^self performTranslatedVersionOf: #bottomLeft: withArgs: {coord}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/10/2002 00:00'!
bottomRight
	^self performTranslatedVersionOf: #bottomRight! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/10/2002 00:00'!
bottomRight: coord
	^self performTranslatedVersionOf: #bottomRight: withArgs: {coord}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 19:50'!
extent
	^self maybeTranspose: client extent.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 19:50'!
extent: aPoint
	client extent: (self maybeTranspose: aPoint).! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 19:41'!
height
	^self performTranslatedVersionOf: #height! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:17'!
height: dim
	^self performTranslatedVersionOf: #height: withArgs: {dim}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 21:29'!
left
	^self performTranslatedVersionOf: #left! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 21:31'!
left: coord
	^self performTranslatedVersionOf: #left: withArgs: {coord}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:17'!
maxHeight
	^self performTranslatedVersionOf: #maxHeight! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:18'!
maxHeight: dim
	^self performTranslatedVersionOf: #maxHeight: withArgs: {dim}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:17'!
maxWidth
	^self performTranslatedVersionOf: #maxWidth! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:18'!
maxWidth: dim
	^self performTranslatedVersionOf: #maxWidth: withArgs: {dim}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:16'!
minHeight
	^self performTranslatedVersionOf: #minHeight! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:17'!
minHeight: dim
	^self performTranslatedVersionOf: #minHeight: withArgs: {dim}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:17'!
minWidth
	^self performTranslatedVersionOf: #minWidth! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/16/2002 19:18'!
minWidth: dim
	^self performTranslatedVersionOf: #minWidth: withArgs: {dim}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 7/10/2003 21:34'!
position: offset relativeTo: otherMorph
	"Set position	to offset + otherMorph topLeft in the logical coordinate system.  We assume that
	 otherMorph has the same orientation as self.  The origin is that of the other morph's inner
	 bounds."

	| origin fixedOffset |

	self clientOrientation = #vertical
		ifTrue: [
			origin := otherMorph innerBounds topLeft.
			fixedOffset := offset.
		] ifFalse: [
			origin := otherMorph innerBounds bottomLeft.
			fixedOffset := offset y @ (offset x negated - self width).
		].

	"Finally, actually move the client."
	client position: origin + fixedOffset.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 21:29'!
right
	^self performTranslatedVersionOf: #right! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 21:31'!
right: coord
	^self performTranslatedVersionOf: #right: withArgs: {coord}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 21:29'!
top
	^self performTranslatedVersionOf: #top! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 21:30'!
top: coord
	^self performTranslatedVersionOf: #top: withArgs: {coord}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/5/2002 22:32'!
topLeft
	^self performTranslatedVersionOf: #topLeft! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/5/2002 22:33'!
topLeft: coord
	^self performTranslatedVersionOf: #topLeft: withArgs: {coord}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/5/2002 22:54'!
topRight
	^self performTranslatedVersionOf: #topRight! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/5/2002 22:53'!
topRight: coord
	^self performTranslatedVersionOf: #topRight: withArgs: {coord}.! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 19:41'!
width
	^self performTranslatedVersionOf: #width! !

!OrientationAdjuster methodsFor: 'geometry' stamp: 'cr 11/4/2002 19:42'!
width: w
	^self performTranslatedVersionOf: #width: withArgs: {w}.! !

!OrientationAdjuster methodsFor: 'geometry-recalculating' stamp: 'cr 11/10/2002 21:09'!
dimensions: aPoint withLogicalHeight: anInteger
	"Return aPoint with the logical height forced to anInteger."

	self clientOrientation = #vertical
		ifTrue: [^ aPoint x @ anInteger]
		ifFalse: [^ anInteger @ aPoint y].
! !

!OrientationAdjuster methodsFor: 'geometry-recalculating' stamp: 'cr 11/10/2002 21:07'!
dimensions: aPoint withLogicalWidth: anInteger
	"Return aPoint with the logical width forced to anInteger."

	self clientOrientation = #vertical
		ifTrue: [^ anInteger @ aPoint y]
		ifFalse: [^ aPoint x @ anInteger].! !

!OrientationAdjuster methodsFor: 'geometry-recalculating' stamp: 'cr 11/10/2002 21:09'!
heightFor: aMorph
	"Return the logical height (wrt. client) of aMorph."

	self clientOrientation = #vertical
		ifTrue: [^aMorph height]
		ifFalse: [^aMorph width].! !

!OrientationAdjuster methodsFor: 'geometry-recalculating' stamp: 'cr 2/11/2003 22:18'!
maybeRotate: grPrim
	"Rotate grPrim ninety degrees relative to the logical origin if orientation is horizontal."
	self clientOrientation = #vertical
		ifTrue: [^grPrim]
		ifFalse: [^ (World height - grPrim y) @ grPrim x]
! !

!OrientationAdjuster methodsFor: 'geometry-recalculating' stamp: 'cr 11/10/2002 21:09'!
maybeTranspose: grPrim
	self clientOrientation = #vertical
		ifTrue: [^grPrim]
		ifFalse: [^grPrim transposed].! !

!OrientationAdjuster methodsFor: 'geometry-recalculating' stamp: 'cr 11/10/2002 21:08'!
widthFor: aMorph
	"Return the logical width (wrt. client) of aMorph."

	self clientOrientation = #vertical
		ifTrue: [^aMorph width]
		ifFalse: [^aMorph height].! !

!OrientationAdjuster methodsFor: 'geometry-recalculating' stamp: 'cr 6/25/2003 20:41'!
xFor: aPoint
	"Return the logical x (wrt. client) of aPoint."

	self clientOrientation = #vertical
		ifTrue: [^aPoint x]
		ifFalse: [^aPoint y].! !

!OrientationAdjuster methodsFor: 'geometry-recalculating' stamp: 'cr 6/25/2003 20:41'!
yFor: aPoint
	"Return the logical y (wrt. client) of aPoint."

	self clientOrientation = #vertical
		ifTrue: [^aPoint y]
		ifFalse: [^aPoint x].! !

!OrientationAdjuster methodsFor: 'geometry-widget-specific' stamp: 'cr 7/10/2003 22:27'!
xOffsetForScroller: aScrollbar
	"Return the logical horizontal distance between the logical left side of the client and the
	 logical right side of 'aScrollbar' such that the scrollbar is positioned 'correctly' in the
	 logical horizontal relative to the client's logical origin.

	 (This makes a lot more sense when you realize that the correct position is zero for horizontal
	 scrollers (i.e. the bottom) and almost the client's width for vertical (i.e. on the right-hand side.)"

	[aScrollbar orientation = self clientOrientation] assert.

	self clientOrientation = #vertical
		ifTrue: [^client innerBounds width - aScrollbar width]
		ifFalse: [^0].
! !

!OrientationAdjuster methodsFor: 'private' stamp: 'cr 11/10/2002 21:07'!
clientOrientation
	"Return the orientation of the client (or the orienter)."
	^ orienter orientation.! !

!OrientationAdjuster methodsFor: 'private' stamp: 'cr 11/4/2002 19:38'!
performTranslatedVersionOf: aMessage
	^self performTranslatedVersionOf: aMessage withArgs: #().! !

!OrientationAdjuster methodsFor: 'private' stamp: 'cr 7/11/2003 22:56'!
performTranslatedVersionOf: aMessage withArgs: args
	"Many wrapped messages have simple alternatives for the alternate orientation. This 
	 message just swaps in the appropriate other message (stored in OrientationTranslation)
	 and sends that instead."

	self clientOrientation == #vertical
		ifTrue: [^client perform: aMessage withArguments: args]
		ifFalse: [^client perform: (OrientationTranslation at: aMessage) withArguments: args].
! !

!OrientationAdjuster methodsFor: 'obsolete' stamp: 'cr 11/5/2002 22:47'!
fromOriginOffset: aPoint
	"Return the absolute point given when aPoint is used as the offset from the logical origin."

	^ self topLeft + (self maybeRotate: aPoint).! !


!OrientationAdjuster class methodsFor: 'instance creation' stamp: 'cr 11/4/2002 19:09'!
on: aPrefab
	^self basicNew initialize: aPrefab! !

!OrientationAdjuster class methodsFor: 'instance creation' stamp: 'cr 11/10/2002 21:01'!
on: aPrefab orientedTo: otherPrefab
	^self basicNew client: aPrefab orienter: otherPrefab.! !

!OrientationAdjuster class methodsFor: 'class initialization' stamp: 'cr 11/25/2002 01:50'!
initialize
	
	OrientationTranslation := Dictionary new.

	"Here are the remappings.  Think of the 'normal' state as the object in a vertical orientation
	 and the wierd state as a horizontal orientation."
	#(	width		height
	  	width:		height:
		height		width
		height:		width:

		left			bottom
		right		top
		top			left
		bottom		right

		topRight	topLeft
		topRight:	topLeft:

		topLeft		bottomLeft
		topLeft:		bottomLeft:

		bottomRight	topRight
		bottomRight: topRight:

		bottomLeft	bottomRight
		bottomLeft:	bottomRight:

		maxWidth	maxHeight
		maxWidth: 	maxHeight:

		maxHeight	maxWidth
		maxHeight:	maxWidth:

		minWidth	minHeight
		minWidth: 	minHeight:

		minHeight	minWidth
		minHeight:	minWidth:
	) pairsDo: [ :orig :new | OrientationTranslation at: orig put: new].! !


!PositionalBinding methodsFor: 'position calculation' stamp: 'cr 2/26/2000 22:50'!
newBounds
	| rect ib |
	"Return a rectangle containing the bounds for the widget given the current size of the outer
	 window."

	rect := widget bounds.
	ib := window innerBounds.

	topDist ifNotNil: [rect := rect withTop: ib bottom - topDist].
	botDist ifNotNil: [rect := rect withBottom: ib bottom - botDist].
	leftDist ifNotNil: [rect := rect withLeft: ib right - leftDist].
	rightDist ifNotNil: [rect := rect withRight: ib right - rightDist].

	^rect
! !

!PositionalBinding methodsFor: 'fixing' stamp: 'cr 2/20/2000 20:05'!
fixBottom
	botDist := window innerBounds bottom - widget bounds bottom.! !

!PositionalBinding methodsFor: 'fixing' stamp: 'cr 2/20/2000 20:03'!
fixLeft
	leftDist := window innerBounds right - widget bounds left.! !

!PositionalBinding methodsFor: 'fixing' stamp: 'cr 2/20/2000 20:02'!
fixRight
	rightDist := window innerBounds right - widget bounds right.! !

!PositionalBinding methodsFor: 'fixing' stamp: 'cr 2/20/2000 20:05'!
fixTop
	topDist := window innerBounds bottom - widget bounds top.! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 19:57'!
botDist: anInteger
	botDist := anInteger! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 19:57'!
leftDist: anInteger
	leftDist := anInteger! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 19:57'!
rightDist: anInteger
	rightDist := anInteger! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 19:56'!
topDist: anInteger
	topDist := anInteger! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 20:00'!
widget: aPrefab
	widget := aPrefab! !

!PositionalBinding methodsFor: 'accessing' stamp: 'cr 2/20/2000 20:00'!
window: aConstruction
	window := aConstruction! !


!PositionalBinding class methodsFor: 'instance creation' stamp: 'cr 2/20/2000 20:18'!
for: aWidget in: aManager
	^super new
		window: aManager;
		widget: aWidget;
		yourself.! !


!Prefab methodsFor: 'initialization' stamp: 'cr 11/4/2002 19:58'!
initialize

	super initialize.

	minSize := 1@1.							"Prevent a divide-by-zero."
	maxSize := SmallInteger maxVal asPoint.	"As close to infinity as is reasonable."

	self borderWidth: Prefab defaultBorderWidth.
	self borderColor: Prefab backgroundColor.
	self color: Prefab backgroundColor.
	
	foregroundColor := Prefab foregroundColor.

	hasFocus := false.! !

!Prefab methodsFor: 'API' stamp: 'cr 1/9/2000 21:58'!
color
	"Get color."
	^super color.

	"This is here so that you can tell by looking at the 'API' section that #extent: is 'officially'
	 an attribute of Prefab.  If this slows things down too much (unlikely), you can remove it
	 without breaking anything."! !

!Prefab methodsFor: 'API' stamp: 'cr 1/9/2000 21:57'!
color: aColor
	"Set color."
	^super color: aColor.

	"This is here so that you can tell by looking at the 'API' section that #extent: is 'officially'
	 an attribute of Prefab.  If this slows things down too much (unlikely), you can remove it
	 without breaking anything."! !

!Prefab methodsFor: 'API' stamp: 'cr 1/9/2000 21:57'!
extent
	"Get extent."
	^super extent.

	"This is here so that you can tell by looking at the 'API' section that #extent: is 'officially'
	 an attribute of Prefab.  If this slows things down too much (unlikely), you can remove it
	 without breaking anything."! !

!Prefab methodsFor: 'API' stamp: 'cr 11/2/2002 17:08'!
extent: aPoint
	"Set extent to the value closest to newExtent that is still within minSize and maxSize."

	^super extent: (self closestAllowedTo: aPoint)
! !

!Prefab methodsFor: 'API' stamp: 'cr 1/4/2000 23:48'!
foregroundColor
	"Color of whatever is in the foreground."
	^foregroundColor
! !

!Prefab methodsFor: 'API' stamp: 'cr 1/4/2000 23:49'!
foregroundColor: aColor
	"Color of whatever is in the foreground."
	foregroundColor := aColor
! !

!Prefab methodsFor: 'API' stamp: 'cr 1/4/2000 23:50'!
tag
	"The tag is a symbol which, if set, is a unique identifier for this Prefab in this Manager.
	 That is, only one Prefab in a Manager may hold a particular tag at a time.  Uniqueness
	 is NOT enforced so be careful.  The purpose of these is to make it easy to find individual
	 GUI bits after the window has been constructed."
	^tag
! !

!Prefab methodsFor: 'API' stamp: 'cr 1/4/2000 23:50'!
tag: aSymbol
	"The tag is a symbol which, if set, is a unique identifier for this Prefab in this Manager.
	 That is, only one Prefab in a Manager may hold a particular tag at a time.  Uniqueness
	 is NOT enforced so be careful.  The purpose of these is to make it easy to find individual
	 GUI bits after the window has been constructed."

	tag ifNotNil: [
		(tag class ~~ Symbol or: [(aSymbol at: 1) isLetter not])
			ifTrue: [
				self error: 'tag ', 
					aSymbol storeString, 
					' must be a symbol starting with a letter'.
			]
	].


	tag := aSymbol.
! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 19:01'!
maxHeight
	"Return the maximum height."
	^self maxSize y! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 19:01'!
maxHeight: h
	"Set the maximum height to 'h'."
	self maxSize: self maxSize x @ h.! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 18:56'!
maxSize
	"Return the maximum allowed extent."
	^maxSize! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 18:58'!
maxSize: aPoint
	"Set the maximum extent."
	maxSize := aPoint.
	self extent: self extent.			"Resize if necessary."
! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 19:01'!
maxWidth
	"Return the maximum width."
	^self maxSize x! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 19:00'!
maxWidth: w
	"Set the maximum width to 'w'."
	self maxSize: w @ self maxSize y.! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 19:02'!
minHeight
	"Return the minimum height."
	^self minSize y! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 19:03'!
minHeight: h
	"Set the minimum height to 'h'."
	self minSize: self minSize x @ h.! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 18:56'!
minSize
	"Return the minimum allowed extent."
	^minSize! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 18:58'!
minSize: aPoint
	"Set the minimum extent."
	minSize := aPoint.
	self extent: self extent.			"Resize if necessary."
! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 19:03'!
minWidth
	"Return the minimum width."
	^self minSize x! !

!Prefab methodsFor: 'API-Extent limits' stamp: 'cr 11/16/2002 19:03'!
minWidth: w
	"Set the minimum width to 'w'."
	self minSize: w @ self minSize y.! !

!Prefab methodsFor: 'API-Keyboard' stamp: 'cr 3/3/2002 21:46'!
tabKey
	"Return the character used to move the keyboard focus from self to the next client in the
	 tab order.  This is usually a tab key (hence 'tabbing')."

	^tabKey asDescriptionString! !

!Prefab methodsFor: 'API-Keyboard' stamp: 'cr 3/3/2002 21:43'!
tabKey: aKey
	"Set the character used to move the keyboard focus from self to the next client in the
	 tab order.  This is usually a tab key (hence 'tabbing')."

	tabKey := aKey asPrefabKeystroke.! !

!Prefab methodsFor: 'API-deprecated' stamp: 'cr 12/11/2001 03:38'!
style
	"This method has been renamed to #borderStyle (by those Prefabs that support it).  This method
	 is here for backwards compatibility and may go away at some point."
	^self borderStyle.! !

!Prefab methodsFor: 'API-deprecated' stamp: 'cr 12/11/2001 03:38'!
style: aSymbol
	"This method has been renamed to #borderStyle (by those Prefabs that support it).  This method
	 is here for backwards compatibility and may go away at some point."
	^self borderStyle: aSymbol.! !

!Prefab methodsFor: 'accessing' stamp: 'cr 6/8/2003 23:23'!
manager
	"Return the manager of this Prefab or nil it it's unmanaged.  For a Prefab to be managed, it must be registered
	 as a client of the manager AND must be in the Manager's submorph hierarchy."
	| o |

	o := self owner.

	"Follow the owner chain until we find either a manager or nothing."
	[o notNil and: [(o isKindOf: PrefabManager) not]]
		whileTrue: [o := o owner].

	(o notNil and: [o hasClient: self])
		ifTrue: [^o].

	^nil.! !

!Prefab methodsFor: 'accessing' stamp: 'cr 3/3/2002 21:47'!
tabKeyObject
	"Return the actual contents of tabKey, the PrefabKeystroke."
	^tabKey! !

!Prefab methodsFor: 'accessing' stamp: 'cr 1/13/2002 22:49'!
topLevelManager
	| mgr |
	"Return the outermost layer of management (self included) for this morph or nil if it's unmanaged."

	(mgr := self manager)
		ifNil: [
			(self isKindOf: PrefabManager)
				ifTrue: [^self]
				ifFalse: [^nil].
		].

	^mgr topLevelManager! !

!Prefab methodsFor: 'construction' stamp: 'cr 1/8/2000 02:55'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^OrderedCollection new
		add: {#extent:. self extent};
		add: {#color:. self color};
		add: {#foregroundColor:. self foregroundColor};
		add: {#tag:. self tag};
		yourself. ! !

!Prefab methodsFor: 'orientation adjusters' stamp: 'cr 7/10/2003 21:26'!
adjuster
	"Return an OrientationAdjuster for this object.  The receiver must implement #orientation."

	^OrientationAdjuster on: self
! !

!Prefab methodsFor: 'orientation adjusters' stamp: 'cr 7/10/2003 21:26'!
adjusterOrientedTo: aMorph
	^OrientationAdjuster on: self orientedTo: aMorph.
! !

!Prefab methodsFor: 'orientation adjusters' stamp: 'cr 7/10/2003 21:26'!
adjusterOrientedToOwner
	"Return an OrientationAdjuster that takes its orientation cue from the current owner."
	^self adjusterOrientedTo: self owner.! !

!Prefab methodsFor: 'other' stamp: 'cr 1/18/2000 23:59'!
justDroppedInto: aMorph event: evt
	| m |
	"If necessary, fix up the owner/manager invariant."

	"Skip any hollow morphs that may be between this one and the Manager."
	m := aMorph.
	[(m isKindOf: Prefab) and: [m isHollow]] whileTrue: [m := m owner].

	"If it's a PrefabManager and I'm not a client, add me as a client."
	((m isKindOf: PrefabManager) and: [(m hasClient: self) not])
		ifTrue: [m addClient: self].

	^super justDroppedInto: aMorph event: evt.
	! !

!Prefab methodsFor: 'extent operations' stamp: 'cr 11/2/2002 17:06'!
closestAllowedTo: newExtent
	"Return a point containing the extent closest to 'newExtent' while still within the range of
	 minSize and maxSize."
	^(newExtent max: self minSize) min: self maxSize! !

!Prefab methodsFor: 'tests' stamp: 'cr 11/2/2002 17:00'!
canResizeTo: aPoint
	"Return true if this Manager will allow itself to be resized to extent 'aPoint'."
	^aPoint >= minSize and: [aPoint <= maxSize]! !

!Prefab methodsFor: 'tests' stamp: 'cr 11/26/2001 00:19'!
isContainer
	"Return true if self can contain and manage other Prefabs.  If this message returns true, the
	 implementor must 1) resize its submorphs itself and 2) allow its manager(s) access to its clients
	 (typically via #clientWithTag:).  In other words, Prefabs that answer true to this message are
	 lightweight managers.

	 If a Prefab answers this message with true, it must also implement #clientWithTag: and #allClientTags.
	 "
	^ false.! !

!Prefab methodsFor: 'tests' stamp: 'cr 11/25/2001 23:04'!
isHollow	
	"Is this Prefab hollow? Hollow means that there is a region within the object that may contain
	 other Prefabs which are also clients of this Prefab's manager.  This Prefab's manager also
	 resizes these clients and will retrieve them by tag.  This is significantly different from the
	 behaviour implied by #isContainer."
	^ self hollowRegion notNil.! !

!Prefab methodsFor: 'tests' stamp: 'cr 10/21/2001 22:30'!
isManaged
	^self manager notNil.! !

!Prefab methodsFor: 'tests' stamp: 'cr 7/9/1999 21:49'!
isPrefab
	^true! !

!Prefab methodsFor: 'placement' stamp: 'cr 7/5/1999 22:48'!
hollowRegion
	"Some prefabs are hollow and allow other prefabs to be placed inside their bounds.  If
	 this is supported, return a rectangle containing this region.  A good (only?) example of
	 a morph that could use this sort of behaviour is a decorative frame in a dialog box."
	^nil.! !

!Prefab methodsFor: 'placement' stamp: 'cr 7/5/1999 22:45'!
parcelRequired
	"Region of window space this morph will occupy."
	^self bounds.
! !

!Prefab methodsFor: 'menu' stamp: 'cr 9/19/2001 00:47'!
addAddHandMenuItemsForHalo: aMenu hand: aHandMorph
	"Add halo menu items to be handled by the invoking hand. This is here mainly to override the
	 superclass's version and so remove options that are inappropriate for Prefabs."

	aMenu addLine.
	self maybeAddCollapseItemTo: aMenu.
	aMenu add: 'copy to paste buffer' action: #copyToPasteBuffer.
	aMenu add: 'copy Postscript' action: #clipPostscript.
	aMenu add: 'print PS to file...' target: self selector: #printPSToFile.
! !

!Prefab methodsFor: 'menu' stamp: 'cr 1/8/2000 02:57'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
"	super addCustomMenuItems: aCustomMenu hand: aHandMorph."
	
	aCustomMenu addLine;
		add: 'Set tag' target: self action: #setTag;
		add: 'Set background color' target: self selector: #changeColorOfAttribute: argument: #color;
		add: 'Set foreground color' target: self selector: #changeColorOfAttribute: argument: #foregroundColor.! !

!Prefab methodsFor: 'menu' stamp: 'cr 10/10/2001 01:05'!
changeColorOfAttribute: aSelector

	| oc |
	oc := self perform: aSelector.
	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: (aSelector,':') asSymbol;
		originalColor: oc;
		putUpFor: self near: self fullBoundsInWorld! !

!Prefab methodsFor: 'menu' stamp: 'cr 7/11/1999 20:59'!
setTag
	"Prompt the user for a tag name."
	| newTag |
	newTag := FillInTheBlank request: 'Enter new tag'
				initialAnswer: tag asString.

	newTag isEmpty
		ifFalse: [self tag: newTag asSymbol].
			! !

!Prefab methodsFor: 'tests-keyboard' stamp: 'cr 2/12/2002 20:32'!
hasFocus
	^hasFocus! !

!Prefab methodsFor: 'tests-keyboard' stamp: 'cr 1/13/2004 22:32'!
hasLogicalFocus
	"Return true if self OR a sub-component has the focus."

	"This is different from #hasFocus, as the latter refers to the morph itself.  Prefabs are
	 supposed to appear atomic to the user but they are not necessarily so.  #hasFocus is true
	 for the actual Morph while this method is true at the Prefab level.

	 For example, in a PrefabEdit, the embedded HookedTextMorph receives the actual keyboard
	 events and returns true when sent #hasFocus.  However, from the point of view of a 
	 PrefabManager, it's the PrefabEdit that has the focus and so it's #hasLogicalFocus will
	 return true.

	 For many Prefabs, this distinction is moot."

	"Default: assume nothing too tricky is going on."
	^self hasFocus.

! !

!Prefab methodsFor: 'tests-keyboard' stamp: 'cr 1/18/2002 00:57'!
neverGetsFocus
	"Return true if instances of this class will never, ever want the keyboard focus.  Returning true
	 also means that this object does not know how to deal with keyboard input.  This result
	 should be considered a constant."
	^true.! !

!Prefab methodsFor: 'tests-keyboard' stamp: 'cr 2/13/2002 20:35'!
wantsFocus
	"Return true if self can deal with having the focus.  The result applies to only this instance
	 at this time--that is, it may change."

	^ self neverGetsFocus not.

	"Note: This will become a lot more complex once some concept of disabled controls is
	 implemented.  At the least, this method should change its return value when self
	 becomes disabled."
! !

!Prefab methodsFor: 'subclass menu' stamp: 'cr 3/25/2001 21:25'!
setContentOrientation
	
	| orientations index |
	orientations := #(left right centered).

	index := (PopUpMenu labels: 'left\right\centered' withCRs)
				startUpWithCaption: 'Pick an orientation'.

	self contentOrientation: (orientations at: index).! !

!Prefab methodsFor: 'subclass menu' stamp: 'cr 3/25/2001 21:20'!
setImage
	"Set the label's image."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new label image (as a dictionary entry)'.
	newImage isEmpty
		ifFalse: [self image: newImage asSymbol].
			! !

!Prefab methodsFor: 'subclass menu' stamp: 'cr 3/25/2001 21:21'!
setImageFile
	"Set the label's image to the file in the given path."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new image file name'.
	newImage isEmpty
		ifFalse: [self image: newImage].
			! !

!Prefab methodsFor: 'subclass menu' stamp: 'cr 3/25/2001 21:19'!
setOrientation
	"Set orientation interactively."
	| orientations index |
	orientations := #(horizontal vertical).

	index := (PopUpMenu labels: 'horizontal\vertical' withCRs)
				startUpWithCaption: 'Pick an orientation'.

	self orientation: (orientations at: index).! !

!Prefab methodsFor: 'subclass menu' stamp: 'cr 3/25/2001 21:42'!
setRelief
	"Set relief interactively."
	| relief index |
	relief := #(raised inset).

	index := (PopUpMenu labels: 'raised\inset' withCRs)
				startUpWithCaption: 'Pick a relief'.

	self relief: (relief at: index).! !

!Prefab methodsFor: 'subclass menu' stamp: 'cr 11/22/2002 03:37'!
setStyle
	"Pick a border style."
	| styles index |
	styles := #(raised inset flush).

	index := (PopUpMenu labels: 'raised\inset\flush' withCRs)
				startUpWithCaption: 'Pick a border style'.
	
	index > 0
		ifTrue: [self borderStyle: (styles at: index)].! !

!Prefab methodsFor: 'subclass menu' stamp: 'cr 3/25/2001 21:23'!
setText
	"Set the label's text."
	| newText |
	newText := FillInTheBlank request: 'Enter new label text'.
	newText isEmpty
		ifFalse: [self text: newText].
			! !

!Prefab methodsFor: 'private-font' stamp: 'cr 8/16/2003 19:49'!
fontNamed: nameOrFont
	^Prefab fontNamed: nameOrFont.! !

!Prefab methodsFor: 'private-font' stamp: 'cr 8/16/2003 19:49'!
nameForFont: aStrikeFont
	^Prefab nameForFont: aStrikeFont.! !

!Prefab methodsFor: 'focus' stamp: 'cr 2/12/2002 21:18'!
focusColor
	
	| mgr |
	(mgr := self topLevelManager)
		ifNotNil: [^mgr focusColor].

	^Prefab defaultFocusColor.! !

!Prefab methodsFor: 'focus' stamp: 'cr 2/13/2002 21:10'!
showFocus: gotIt
	"Alter self's appearance to indicate that it has or does not have the keyboard focus."

	"Actual implementation details are left up to the individual subclasses."
! !

!Prefab methodsFor: 'focus' stamp: 'cr 2/18/2002 20:39'!
tabToNextFor: hand
	| next mgr |
	"Set the focus to the next item in the tabbing order wrt. hand."

	"Note: This assumes (for the moment) that there is only one hand."

	((mgr := self topLevelManager) notNil and: [(next := mgr tabOrder nextClient) notNil])
		ifTrue: [next takeFocusOn: hand].
! !

!Prefab methodsFor: 'focus' stamp: 'cr 2/18/2002 20:38'!
takeFocusOn: hand
	"Give yourself the focus on 'hand'.  This is wrapped so that subclasses can point the focus at their active
	 element."
	hand newKeyboardFocus: self.! !

!Prefab methodsFor: 'focus' stamp: 'cr 3/6/2002 22:54'!
tryAsShortcut: evt
	| tl |
	"See if event 'evt' is a shortcut key used by the toplevel manager.  If so, return true and hand it off
	 to the toplevel.  Otherwise, return false."

	(tl := self topLevelManager)
		ifNil: [^false].

	^ tl checkForShortcut: evt asPrefabKeystroke.! !

!Prefab methodsFor: 'focus-system' stamp: 'cr 2/13/2002 21:10'!
keyboardFocusChange: gotIt
	"The message is sent to a morph when its keyboard focus change. The given argument indicates that the receiver is gaining keyboard focus (versus losing) the keyboard focus. Morphs that accept keystrokes should change their appearance in some way when they are the current keyboard focus. This default implementation does nothing."

	hasFocus := gotIt.
	self showFocus: gotIt.! !


!IconPanelElement methodsFor: 'initialization' stamp: 'cr 7/22/2003 23:10'!
initialize
	super initialize.
	self borderWidth: 0.
	self color: Color transparent.

	text := StringMorph contents: ''.
	self addMorph: text.

	picture := ImageMorph new image: (Prefab formNamed: #noPic).
	self addMorph: picture.

! !

!IconPanelElement methodsFor: 'component assembly' stamp: 'cr 7/22/2003 23:08'!
addPicture: form sized: newExtent
	| newFormExtentRect |

	"#scaledToSize: seems to be a bit fragile, so we're careful not to change the aspect ratio
	 since this looks like it causes problems."

	newFormExtentRect := (0@0 extent: form extent) bestFitIn: (0@0 extent: newExtent).

	picture image: (form scaledToSize: newFormExtentRect extent).
! !

!IconPanelElement methodsFor: 'component assembly' stamp: 'cr 7/22/2003 23:27'!
configLabelWithFont: fontName
	text	font: (self fontNamed: fontName).
	self arrangeLabel.
! !

!IconPanelElement methodsFor: 'component assembly' stamp: 'cr 7/28/2003 21:05'!
entry: ent font: aFontName pictureExtent: pictureExtent labelWidth: width belowOrBeside: aSymbol

	textPositionWord := aSymbol.
	textPartWidth := width.
	panelEntry := ent.

	self addPicture: self baseIcon sized: pictureExtent.
	self configLabelWithFont: aFontName.
	self arrangeContents.! !

!IconPanelElement methodsFor: 'accessing' stamp: 'cr 7/28/2003 21:04'!
baseIcon
	^panelEntry icon! !

!IconPanelElement methodsFor: 'accessing' stamp: 'cr 7/22/2003 21:40'!
elementLayout: elo
	textPositionWord := elo.
	self arrangeContents.! !

!IconPanelElement methodsFor: 'accessing' stamp: 'cr 7/22/2003 23:25'!
font: fo
	(text font = fo)
		ifFalse: [self configLabelWithFont: fo].
	self arrangeContents.! !

!IconPanelElement methodsFor: 'accessing' stamp: 'cr 7/28/2003 21:12'!
panelEntry
	^panelEntry! !

!IconPanelElement methodsFor: 'accessing' stamp: 'cr 7/28/2003 21:05'!
pictureExtent: pe 
	pe = picture extent
		ifFalse: [self addPicture: self baseIcon sized: pe].

	self arrangeContents.! !

!IconPanelElement methodsFor: 'accessing' stamp: 'cr 7/28/2003 21:01'!
textContents
	^panelEntry text! !

!IconPanelElement methodsFor: 'accessing' stamp: 'cr 7/22/2003 23:28'!
textPartWidth: tpw
	textPartWidth := tpw.
	self arrangeLabel.
	self arrangeContents.! !

!IconPanelElement methodsFor: 'appearance' stamp: 'cr 7/28/2003 21:50'!
color: aColor

	| bg |
	super color: aColor.

	(aColor isTransparent and: [self owner notNil])
		ifTrue: [bg := self owner color.]
		ifFalse: [bg := aColor.].

	text
		ifNotNil: [text color: (Color black orColorUnlike: bg)].
! !

!IconPanelElement methodsFor: 'layout' stamp: 'cr 7/20/2003 17:53'!
arrangeContents

	[#(bottom right) includes: textPositionWord] assert.
	self perform: ('arrangeContents', textPositionWord capitalized) asSymbol.! !

!IconPanelElement methodsFor: 'layout' stamp: 'cr 7/21/2003 22:30'!
arrangeContentsBottom

	| innerBoundsExtent |
	innerBoundsExtent := self totalWidth @ (text height + picture height).
	self extent: (self borderWidth * 2) + innerBoundsExtent..

	picture position: (self left + ((self width - picture width) // 2)) @ self top.
	text position: (text bounds centeredBeneath: picture bounds) origin.
! !

!IconPanelElement methodsFor: 'layout' stamp: 'cr 8/6/2003 23:19'!
arrangeContentsRight
	self extent: (2 * self borderWidth) + (self totalWidth @ (picture height max: text height)).

	picture position: self innerBounds origin.

	text left: picture right + self horizontalGapWidth;
		top: self top + ((self height - text height) // 2).
! !

!IconPanelElement methodsFor: 'layout' stamp: 'cr 7/28/2003 21:01'!
arrangeLabel

	text	width: textPartWidth;
			contents: self textContents asString.
	
	text	trimContentsAndAppend: '...';
			narrowToFitContents.
! !

!IconPanelElement methodsFor: 'layout' stamp: 'cr 8/6/2003 23:06'!
horizontalGapWidth
	^text font widthOf: $X.! !

!IconPanelElement methodsFor: 'layout' stamp: 'cr 8/6/2003 22:59'!
totalWidth
	textPositionWord = #bottom
		ifTrue: [^textPartWidth]
		ifFalse: [^picture width + textPartWidth + self horizontalGapWidth].! !


!Prefab class methodsFor: 'class initialization' stamp: 'cr 5/7/2003 20:23'!
initialize
	"Initialize me."

	"Prefab initialize."
	
	Bitmaps := Dictionary new.
! !

!Prefab class methodsFor: 'class initialization' stamp: 'cr 11/4/2002 20:56'!
initializeAll
	"Initialize all classes in the Prefab changeset that need it."

	Prefab initialize.
	OrientationAdjuster initialize.! !

!Prefab class methodsFor: 'class initialization' stamp: 'cr 3/26/2005 22:52'!
loadFixedFont

	"Load in the Fixed12 font.  This is only useful for Quest For Pants.
	Attribution: this code started life as the preamble script for Ian Pumatra's X11 fonts
	package but was subsequently tortured into this."

	| strike file textStyle size fontName |

	fontName := 'Fixed'.
	size := 12.

	strike _ StrikeFont new.
	strike name: fontName.
	file := FileStream readOnlyFileNamed: fontName, size printString, '.sf2'.
	file binary.
	[strike readFromStrike2Stream: file] ensure: [file close].
	strike reset.

	textStyle _ TextStyle fontArray: {strike}.
	textStyle defaultFontIndex: 1.
	TextConstants at: fontName asSymbol put: textStyle.

! !

!Prefab class methodsFor: 'class initialization' stamp: 'cr 3/26/2005 20:26'!
loadImageLibrary
	"Load the 'built-in' images from the images directory."

	| dir |
	dir := FileDirectory default directoryNamed: 'images'.

	"Add entries as necessary."
	#(bang doNotEnter info question upArrow downArrow leftArrow rightArrow nopic) do: [ :imageTag |
		self addFormFromFile: (dir fullNameFor: imageTag asString, '.xpm') named: imageTag.
	].

	"Prefab loadImageLibrary"
! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 7/3/1999 21:47'!
addForm: aForm named: aSymbol
	"Add a form to the image dictionary."
	Bitmaps at: aSymbol put: aForm.! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 11/3/2002 14:19'!
addFormFromFile: aFileName named: aSymbol
	"Read in the named file and store it in the image library and named by 'aSymbol'."
	self addForm: (ImageReadWriter formFromFileNamed: aFileName) named: aSymbol! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 9/17/2001 01:48'!
availableImages
	^Bitmaps keys.! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 7/20/2003 21:02'!
formFor: picture
	"Attempt to convert 'picture' into a form.  If 'picture' is a string, treat it as a filename and try to load
	 the image from disk.  If it's a symbol, try to find it in the image library.  If it's a form, just return it."

	(picture isKindOf: Symbol)
		ifTrue: [^Prefab formNamed: picture].

	picture class = String
		ifTrue: [^ImageReadWriter formFromFileNamed: picture].

	(picture isKindOf: Form)
		ifTrue: [^picture].
! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 11/3/2002 14:18'!
formNamed: nameSymbol
	"Return the form associated with nameSymbol.  If missing, return the 'missing picture' form,
	 referenced by #nopic."
	^Bitmaps at: nameSymbol ifAbsent: [Bitmaps at: #nopic].! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 9/17/2001 02:25'!
formNamed: aSymbol ifAbsent: aBlock
	^Bitmaps at: aSymbol ifAbsent: aBlock.! !

!Prefab class methodsFor: 'API-image library' stamp: 'cr 1/9/2004 23:50'!
loadImagesIn: dirName
	"Load the 'built-in' images from the images directory."

	| dir tag |
	dir := FileDirectory on: dirName.

	"Add entries as necessary."
	dir fileNames do: [ :filename |
		(FileDirectory extensionFor: filename) = 'xpm'
			ifTrue: [
				tag := (FileDirectory baseNameFor: (filename copyFrom: 1 to: filename size - 4))
							asSymbol.
				self addFormFromFile: (dir fullNameFor: filename) named: tag.
			].
	].


! !

!Prefab class methodsFor: 'API-fonts' stamp: 'cr 8/16/2003 19:48'!
fontNamed: nameOrFont
	| dashPos family size |
	"Given a string containing a font's family name, a dash ('-') and a number, return the StrikeFont with
	 that family name and size.  If no such font exists, it's an error."

	(nameOrFont isKindOf: StrikeFont)
		ifTrue: [^ nameOrFont].

	dashPos := nameOrFont indexOf: $-.
	family := (nameOrFont copyFrom: 1 to: dashPos - 1) asSymbol.
	size := (nameOrFont copyFrom: dashPos + 1 to: nameOrFont size) asInteger.

	^ StrikeFont familyName: family size: size.! !

!Prefab class methodsFor: 'API-fonts' stamp: 'cr 8/16/2003 19:49'!
nameForFont: aStrikeFont
	| fontName |
	"Return a string describing aStrikeFont such that #fontNamed: can identify the font by it.
	 If 'aStrikeFont' is already a name, just return it."
	
	(aStrikeFont isKindOf: String)
		ifTrue: [
			"Make sure aStrikeFont is properly formed."
			self fontNamed: aStrikeFont.
			^ aStrikeFont.
		].

	fontName := aStrikeFont familyName.

	fontName = '(unnamed)'
		ifTrue: [self error: 'Strikefont has no name.'].	

	^ fontName asString, '-', aStrikeFont height printString.! !

!Prefab class methodsFor: 'misc' stamp: 'cr 7/10/1999 17:39'!
includeInNewMorphMenu
	"Include my subclasses but not me"
	^ self ~~ Prefab! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 6/26/1999 22:12'!
activateColor
	^ (Color r: 0.969 g: 0.969 b: 0.969)! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 3/25/2001 20:11'!
backgroundColor
	"Background color for most morphs."
	^ (Color r:  0.851 g:  0.851 b:  0.851)! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/24/1999 18:00'!
checkButtonCheckedColor
	^Color green.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/24/1999 17:29'!
checkButtonExtent
	"Dimensions of the switch part of a PrefabCheckButton."
	^10@10.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/4/1999 23:39'!
defaultBorderWidth
	^1! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 3/24/2002 01:25'!
defaultButtonActivateKey
	"The keystroke that typically activates a button or button-like thing."
	^PrefabKeystroke space! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/4/1999 23:39'!
defaultButtonBorderWidth
	^2! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 9/22/2001 02:32'!
defaultEditFont
	"Default font for PrefabEdits."
	^TextStyle defaultFont! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 4/8/2002 23:25'!
defaultEditTabbingKey
	"Default key to use when tabbing out of an edit pane."
	^'ctrl+tab' asPrefabKeystroke! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 9/23/2001 18:23'!
defaultEntryFont
	"Default font for PrefabEntry."
	^TextStyle defaultFont! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 2/12/2002 21:09'!
defaultFocusColor
	"Border color for a Prefab that has the focus."
	^Color yellow.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 23:06'!
defaultFrameBorderWidth
	^1! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/20/2003 20:41'!
defaultIconPanelElementPadding
	^10@10! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/21/2003 21:45'!
defaultIconPanelFontName
	^'NewYork-8'! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/20/2003 20:34'!
defaultIconPanelIconExtent
	^32@32
! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/21/2003 22:09'!
defaultIconPanelMaxCharsDisplayed
	^8.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/21/2003 22:09'!
defaultIconPanelRowLength
	^8! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/28/2003 21:18'!
defaultIconPanelSelectionColor
	^Color blue.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/4/1999 23:37'!
defaultInnerBorderWidth
	^2! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 9/22/2001 00:33'!
defaultLabelFont
	"For now, we just use the system default."
	^TextStyle defaultFont! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/10/2001 00:34'!
defaultListBoxDisabledColor
	"Default background for disabled listbox elements."
	^self backgroundColor! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/10/2001 00:11'!
defaultListBoxDisabledForeground
	"Default foreground colour for disabled listbox elements."
	^Color r: 0.5 g: 0.5 b: 0.5.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 9/22/2001 01:25'!
defaultListBoxFont
	"Default font for list-box items."
	^TextStyle defaultFont! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 12/20/1999 23:13'!
defaultListBoxSelectionColor
	^self backgroundColor darker ! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 12/20/1999 22:37'!
defaultListBoxSelectionForeground
	"Default foreground colour for selected listbox elements."
	^Color red.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 3/28/2001 23:07'!
defaultMenuBorderWidth
	^3! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/21/2001 23:46'!
defaultMinimumSliceSize
	"Minimum size in pixels that a client of a PrefabSlicedFrame can be shrunk in the direction
	 of layout."
	^ self sliceDividerWidth * 3! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 11/1/1999 00:29'!
defaultScrollbarLength
	"Initial length (in the axis the slider moves) of a scrollbar when created."
	^230! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 11/26/2001 00:23'!
defaultScrollbarWidth
	"Width (opposite to the axis the slider moves) of a scrollbar."
	^16! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/14/2003 19:39'!
defaultScrollingManagerExtentPadding
	^16@16.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/21/2001 01:31'!
defaultSeparatorThickness
	"Thickness of a PrefabSeparator."
	^1.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 3/3/2002 21:52'!
defaultTabbingKey
	"The key-sequence typically used to advance the focus to the next item in the tabbing order."
	^PrefabKeystroke tab.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/31/1999 22:49'!
foregroundColor
	"Foreground color for most prefab morphs."
	^Color black! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 12/15/1999 23:48'!
listBoxElementHeight
	"Height in pixels of a listbox element."
	^12! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 3/26/2000 15:53'!
managerFrameClass
	"Return the class that provides managers with title bars and the like."
	^PrefabManagerWrapper   "Warning: This *must* be a subclass of SystemWindow or else things break."! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/24/1999 23:47'!
radioButtonCheckedColor
	^Color red.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/18/1999 18:08'!
radioButtonCheckedColour
	^Color red.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/25/1999 00:08'!
radioButtonExtent
	^15@10.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/31/1999 22:53'!
scrollbarBackgroundColor
	"Background color for the trough of a scroll-bar."
	^ (Color r:  0.6 g:  0.6 b:  0.8)! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/31/1999 22:53'!
scrollbarBorderWidth
	"Width of scrollbar elements."
	^ 3! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 11/4/1999 00:08'!
scrollbarSliderColor
	"Background color for the slider of a scroll-bar."
	^ Color veryLightGray.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/28/2001 02:27'!
sliceDividerEndPadding
	"Space left between divider and elements and the outer edge (lengthwise)."
	^5.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 10/21/2001 01:21'!
sliceDividerWidth
	"Default size of the region between two slices in a PrefabSlicedFrame."
	^10.! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 11/5/2002 23:08'!
sliceHandleExtent
	"Dimensions of the button used to drag around a slice in a PrefabSlicedFrame."
	^6@14! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 22:55'!
windowFrameBorderWidth
	^9! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 22:55'!
windowFrameColor
	"Colour of top-level frames."
	^ Color r: 0.452 g: 0.742 b: 0.839.

	"Color r: 0.065 g: 0.839 b: 0.839"! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 22:55'!
windowFrameTextColor
	"Colour of top-level frames."
	^ Color black! !

!Prefab class methodsFor: 'constants-defaults' stamp: 'cr 7/13/1999 22:55'!
windowFrameTitleBarHeight
	^24! !

!Prefab class methodsFor: 'utilities' stamp: 'cr 7/15/2003 22:21'!
queryNumber: initialNum named: attrName
	"Query the user for a number other than 'initialNum',  Return initialNum
	 on cancellation or failure."
	| newNum |
	newNum := FillInTheBlank request: 'Enter a new value for ', attrName
					initialAnswer: initialNum storeString.

	newNum isEmpty
		ifTrue: [^initialNum]
		ifFalse: [^newNum asNumber].! !

!Prefab class methodsFor: 'utilities' stamp: 'cr 7/16/1999 23:20'!
queryPoint: initialPoint named: attrName
	"Query the user for a point other than 'initialPoint',  Return initialPoint
	 on cancellation or failure."
	| newPoint |
	newPoint := FillInTheBlank request: 'Enter a new value for ', attrName
					initialAnswer: initialPoint storeString.

	newPoint isEmpty
		ifTrue: [^initialPoint]
		ifFalse: [^Point readFromString: newPoint].! !


!IconPanelElement class methodsFor: 'as yet unclassified' stamp: 'cr 7/28/2003 21:06'!
entry: ent font: aFontName pictureExtent: pictureExtent labelWidth: width belowOrBeside: aSymbol
	^super new initialize;
		entry: ent
			font: aFontName
			pictureExtent: pictureExtent 
			labelWidth: width belowOrBeside: aSymbol;
		yourself.! !


!PrefabCheckButton methodsFor: 'initialization' stamp: 'cr 3/24/2002 03:10'!
initialize
	
	hasFocus := false.			"<--- Needed by #color:, called from initialize."
	super initialize.

	"Create the responses."
	selectResponse := PrefabResponse new.
	deselectResponse := PrefabResponse new.

	"No, we're not currently in the middle of a keystroke event."
	keyDown := false.

	"We need a border so that we can highlight this Morph when it has the focus, but
	 the border should usually be invisible."
	self borderWidth: Prefab defaultButtonBorderWidth.  "<- Should this be its own thing?"

	switch := SwitchElement new
				clickedColor: Prefab checkButtonCheckedColor;
				highlightColor: Prefab checkButtonCheckedColor twiceLighter;
				action: #clicked;
				target: self;
				extent: Prefab checkButtonExtent;
				color: self color;
				yourself.

	label := PrefabLabel new
				text: 'A Check-Button';
				contentOrientation: #left;
				borderWidth: 0;
				color: self color;
				yourself.

	self addMorph: switch;
		addMorph: label.

	"Resize to something reasonable.  Height is fixed so we don't care about it."
	self extent: (label idealExtent x + ((self borderWidth + self switchPosition x) * 3)) @ 0.

	self tabKey: Prefab defaultTabbingKey.

! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 3/23/2002 23:38'!
color: aColor
	"Set color.  Set label's color too."
	label ifNotNil: [label color: aColor].
	switch ifNotNil: [switch unclickedColor: aColor].

	"There border should be invisible unless this component has the focus."
	self hasLogicalFocus
		ifFalse: [self borderColor: aColor].

	^super color: aColor.	! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 1/8/2000 01:48'!
contentOrientation
	"Get position of the displayable within the label.  Options are #left, #right and #center
	 and they determine where (horizontally) the image or text is placed inside the bounds
	 of the label (or button) iff there is extra space."
	^label contentOrientation.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 3/18/2000 11:48'!
contentOrientation: aSymbol
	"Set position of the displayable within the label.  Options are #left, #right and #center
	 and they determine where (horizontally) the image or text is placed inside the bounds
	 of the label (or button) iff there is extra space."
	label contentOrientation: aSymbol.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 7/24/1999 18:54'!
extent: aPoint
	"Set extent to aPoint, making sure that it's not resized smaller than the specified minimum."

	^super extent: (aPoint x max: self minimumWidth) @ self fixedHeight.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 9/22/2001 00:49'!
font
	^label font
! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 9/22/2001 00:49'!
font: aFont
	label font: aFont! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 10/24/1999 20:44'!
image: aSymbolOrFilenameOrForm
	"Set label to image identified by aSymbolOrFilenameOrForm."
	label image: aSymbolOrFilenameOrForm.
! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 7/25/1999 00:20'!
isSelected
	^switch isClicked! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 2/27/2000 19:39'!
isSelected: aBoolean
	"Set selection"
	switch isClicked: aBoolean.
	self clicked.! !

!PrefabCheckButton methodsFor: 'API' stamp: 'cr 7/24/1999 19:42'!
text: aString
	"Set label text to aString."
	label text: aString.
! !

!PrefabCheckButton methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 19:31'!
actionDeselected: aBlockOrSymbol
	"Action to take when un-checked."
	deselectResponse action: aBlockOrSymbol! !

!PrefabCheckButton methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 19:31'!
actionSelected: aBlockOrSymbol
	"Action to take when checked."
	selectResponse action: aBlockOrSymbol.! !

!PrefabCheckButton methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 19:27'!
args: anArray
	"Set args to array of arguments to be used as parameters by the actions."
	selectResponse args: anArray.
	deselectResponse args: anArray! !

!PrefabCheckButton methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 19:33'!
target: anObject
	"The object to which the select and unselect actions are sent iff they are message
	 names."
	selectResponse target: anObject.
	deselectResponse target: anObject.! !

!PrefabCheckButton methodsFor: 'event handling' stamp: 'cr 2/27/2000 19:29'!
clicked
	"Button was clicked or state changed for some other reason."

	self isSelected
		ifTrue: [selectResponse invoke]
		ifFalse: [deselectResponse invoke]


! !

!PrefabCheckButton methodsFor: 'event handling' stamp: 'cr 3/23/2002 23:40'!
handlesKeyboard: evt
	^true! !

!PrefabCheckButton methodsFor: 'event handling' stamp: 'cr 3/24/2002 03:11'!
keyDown: anEvent

	keyDown := true.

	"Show the button pressed if this keystroke would activate it on release."
	anEvent asPrefabKeystroke = Prefab defaultButtonActivateKey
		ifTrue: [
			switch actPressed
		].! !

!PrefabCheckButton methodsFor: 'event handling' stamp: 'cr 3/24/2002 03:09'!
keyUp: evt
	| ks |
	"Handle a key release.  There are only two cases we care about: the tab, which advances the focus,
	 and the enter key, which invokes the button."

	keyDown
		ifFalse: [^self].
	keyDown := false.

	ks := evt asPrefabKeystroke.

	ks = tabKey
		ifTrue: [
			switch actCancelled.
			^self tabToNextFor: evt hand
		].

	ks = Prefab defaultButtonActivateKey
		ifTrue: [switch actReleased].

! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 3/25/2001 21:25'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set text' target: self action: #setText;
		add: 'Set orientation' target: self action: #setContentOrientation;
		add: 'Set image from image dictionary' target: self action: #setImage;
		add: 'Set image from file' target: self action: #setImageFile.! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 7/24/1999 23:12'!
setImage
	"Set the label's image."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new label image (as a dictionary entry)'.
	newImage isEmpty
		ifFalse: [self image: newImage asSymbol].
			! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 10/24/1999 20:43'!
setImageFile
	"Set the label's image to the file in the given path."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new image file name'.
	newImage isEmpty
		ifFalse: [self image: newImage].
			! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 7/24/1999 23:12'!
setOrientation
	
	| orientations index |
	orientations := #(left right centered).

	index := (PopUpMenu labels: 'left\right\centered' withCRs)
				startUpWithCaption: 'Pick an orientation'.

	self orientation: (orientations at: index).! !

!PrefabCheckButton methodsFor: 'menu' stamp: 'cr 7/24/1999 23:12'!
setText
	"Set the label's text."
	| newText |
	newText := FillInTheBlank request: 'Enter new label text'.
	newText isEmpty
		ifFalse: [self text: newText].
			! !

!PrefabCheckButton methodsFor: 'private' stamp: 'cr 7/24/1999 18:58'!
fixedHeight
	"Return the fixed height of the check button."
	^switch bounds height * 3.! !

!PrefabCheckButton methodsFor: 'private' stamp: 'cr 3/24/2002 01:16'!
labelOrigin
	"Return the point to be the origin of the label."
	^(self innerBounds origin + (switch bounds width * 3)) x @ self innerBounds top.! !

!PrefabCheckButton methodsFor: 'private' stamp: 'cr 7/24/1999 23:57'!
minimumWidth
	"Return the smallest size to which the button can be sized."
	^switch bounds width * 4.! !

!PrefabCheckButton methodsFor: 'private' stamp: 'cr 7/24/1999 18:52'!
switchPosition
	"Return the position to be occupied by actual button part."
	^self bounds origin + switch extent.! !

!PrefabCheckButton methodsFor: 'change reporting' stamp: 'cr 7/24/1999 19:11'!
layoutChanged

	switch position: self switchPosition.
	label bounds: (self labelOrigin corner: self innerBounds corner).

	super layoutChanged.! !

!PrefabCheckButton methodsFor: 'construction' stamp: 'cr 12/10/2001 00:32'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList, {label labelAttributeConstructor}
		add: {#contentOrientation:. self contentOrientation};
		add: {#font:. self font};
		yourself.! !

!PrefabCheckButton methodsFor: 'focus' stamp: 'cr 3/23/2002 23:20'!
neverGetsFocus
	^false! !

!PrefabCheckButton methodsFor: 'focus' stamp: 'cr 3/24/2002 01:13'!
showFocus: gotIt
	gotIt
		ifTrue: [
			self borderColor: self focusColor.
		] ifFalse: [
			self borderColor: self color.
		].! !

!PrefabCheckButton methodsFor: 'focus-system' stamp: 'cr 3/24/2002 03:09'!
keyboardFocusChange: gotIt
	"Focus changed."

	gotIt
		ifFalse: [
			keyDown := false.
			switch actCancelled
		].

	^super keyboardFocusChange: gotIt.! !


!PrefabCheckButton class methodsFor: 'parts bin' stamp: 'cr 4/27/2003 07:08'!
descriptionForPartsBin
	^self partName: 'PrefabCheckButton'
		categories: #('Prefab')
		documentation: 'A check box'! !


!PrefabEdit methodsFor: 'initialization' stamp: 'cr 2/1/2003 02:01'!
initialize
	super initialize.

	scrollPosition := 1.

	font := Prefab defaultEditFont.

	self borderWidth: 2;
		borderColor: #inset.

	textTransform := TransformMorph new 
						color: Color transparent;
						bounds: self innerBounds;
						yourself.

	self addMorph: textTransform.

	text := HookedTextMorph new
			contentsWrapped: '';
			hookTarget: self;
			position: 0@0;
			beAllFont: font;
			focusHook: #logicalKeyboardFocusChange:;
			extent: self innerBounds extent.

	textTransform addMorph: text.

	self extent: 	80@80.

	"We use a different default tabbing key 'cause tab is likely to be used for the tab character
	 in an editor window."
	self tabKey: Prefab defaultEditTabbingKey.

	"Set emacs key bindings."
	self bindKeyCollection: PrefabEdit emacsBindingArray.! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/7/2000 23:20'!
extent: aPoint
	super extent: aPoint.
	textTransform extent: self innerBounds extent.
	text width: self innerBounds width.
! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 12/10/2001 00:19'!
font
	"Return the name of the current font."
	^self nameForFont: font! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 12/10/2001 00:08'!
font: aFontOrString
	"Set the font to use for any text contents, present or future.  The font may be an actual StrikeFont or a string
	 describing it.  The description format is '<family-name>-<size>'.

	 Note: if I decide to add support for Text labels (rather than just strings), it is not clear yet how 
	 this will affect it."
	
	font := self fontNamed: aFontOrString.
	text beAllFont: font.
	self updateSlider.! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/8/2000 18:34'!
foregroundColor
	^text color! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/8/2000 18:34'!
foregroundColor: aColor
	text color: aColor.! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/19/2000 23:00'!
isReadOnly
	^text dropKeys! !

!PrefabEdit methodsFor: 'API' stamp: 'cr 2/19/2000 23:01'!
isReadOnly: aBoolean
	"Set read-only-ness of this editor."
	text dropKeys: aBoolean.! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 22:01'!
fractionalPosition
	"Return a number between 0 and 1 indicating the position of the
	 lines currently displayed relative to the entire editor.  A value
	 of 0.0 means the first line is visible and 1.0 means the last line is
	 visible. (If both are visible, the result may be somewhere in between."


	self visibleRatio >= 1
		ifTrue: [^0.0].

	^ (self scrollPosition + 1) asFloat / (text paragraph numberOfLines - self visibleLines)! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 19:28'!
fractionalPosition: aNumber
	"Set scroll position as a number between 0 and 1 indicating the position of the
	 list entries currently displayed relative to the entire list.  A value
	 of 0.0 means the first item is visible and 1.0 means the last item is
	 visible."

	self scrollPosition: ((aNumber min: 1 max: 0) asFloat 
							* (text paragraph numberOfLines - self visibleLines)) rounded + 1.
	 
! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 19:19'!
scrollPosition
	"Return position to which the editor is scrolled."

	^scrollPosition! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/9/2000 23:48'!
scrollPosition: index
	"Make 'index' the index of the first visible element."

	index = scrollPosition
		ifTrue: [^self].

	self scrollTo: index.
	scrollPosition := index.

	self updateSlider.! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/7/2000 23:09'!
text
	^text contents asString.! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 9/22/2001 02:58'!
text: aTextOrString
	text contentsWrapped: aTextOrString asString.
	self scrollPosition: 1.
	self updateSlider.! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 19:41'!
vScrollBar: aPrefabScrollBar	
	"Make aPrefabScrollBar the scrollbar that controls this listbox's vertical
	 scroll position, safely removing the current scrollbar (if there is one).  If
	 aPrefabScrollBar is nil, just remove the current scrollbar."

	vScrollBar ifNotNil: [
		vScrollBar target: nil;
			action: nil.
		vScrollBar := nil.
	].

	vScrollBar := aPrefabScrollBar.

	aPrefabScrollBar ifNotNil: [
		aPrefabScrollBar target: self;
			action: #fractionalPosition:.
		self updateSlider.
	].! !

!PrefabEdit methodsFor: 'API-Behaviour' stamp: 'cr 2/8/2000 19:26'!
visibleRatio
	| ratio |
	"Return a number between 0 and 1 that indicates what fraction of the lines 
	 can be displayed in the current window."

	ratio := self visibleLines / text paragraph numberOfLines.
	ratio > 1
		ifTrue: [ratio := 1].

	^ratio! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/10/2002 22:45'!
beginningOfLine
	| ndx |
	"Move the curser to the beginning of the current line."

	self withEditorDo: [ :ed |
		ndx := self findBeginningOfLineIn: ed text from: ed selectionInterval first.
		ed selectAt: ndx.
	].
! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/10/2002 23:14'!
cursorDown
	|  edText pos eotl eonl newPos botl |
	"Move the cursor down."
	self withEditorDo: [ :ed |
		edText := ed text.
		pos := ed selectionInterval first.

		eotl := self findEndOfLineIn: edText from: pos.

		"Skip if this is the first line."
		eotl >= edText size
			ifFalse: [
				botl := self findBeginningOfLineIn: edText from: pos.
				eonl := self findEndOfLineIn: edText from: eotl + 1.

				"Calculate the new cursor position.  If the next line is too short, put the
				 cursor at the end."
				newPos := eotl + 1 + (pos - botl) min: eonl.

				ed selectAt: newPos.
			].
	].! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/10/2002 22:40'!
cursorLeft
	| pos |
	"Move the cursor."
	self withEditorDo: [ :ed |	
		pos := ed selectionInterval first.

		pos > 1
			ifTrue: [ed selectAt: pos - 1].
	].! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/10/2002 22:41'!
cursorRight
	| pos |
	"Move the cursor."
	self withEditorDo: [ :ed |	
		pos := ed selectionInterval first.

		pos <= ed text size
			ifTrue: [ed selectAt: pos + 1].
	].! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/10/2002 22:57'!
cursorUp
	| edText pos botl bopl newPos |
	"Move the cursor up."
	self withEditorDo: [ :ed |	
		edText := ed text.
		pos := ed selectionInterval first.

		botl := self findBeginningOfLineIn: edText from: pos.

		"Skip if this is the first line."
		botl <= 1
			ifFalse: [
				bopl := self findBeginningOfLineIn: edText from: botl - 1.

				"Calculate the new cursor position.  If the previous line is too short, put the
				 cursor at the end."
				newPos := bopl + (pos - botl) min: botl - 1.

				ed selectAt: newPos.
			].

	].! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/9/2002 23:08'!
cutSelection
	"Cut the current selection into the clipboard.  Returns false."

	self withEditorDo: [ :ed | ed cut].
! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/10/2002 00:43'!
cutToEndOfLine
	| lastBuffer cutIndex oldPoint |
	"Cut everything from the current cursor position to the end of the line."

	self withEditorDo: [ :ed |
		lastBuffer := '' asText.

		"If the cursor hasn't moved since the last cut, we append this one to the
		 previous cut."
		lastKillIndex = ed selectionInterval first
			ifTrue: [lastBuffer := ed clipboardText].

		"Store the current cursor position."
		oldPoint := ed selectionInterval first.
		
		"If we're at the end of the editor, we can go home now."
		oldPoint >= ed text size
			ifFalse: [		
				"Determine the index of the end of the line.  If we're already there, cut the cr."
				cutIndex := self findEndOfLineIn: ed text from: oldPoint.

				"If we're not right at the CR originally and we're not at the end, we leave it for
				 the next time."
				(cutIndex > oldPoint and: [cutIndex < ed text size])
					ifTrue: [cutIndex := cutIndex - 1].

				"Cut, append to lastBuffer and store the result in the clipboard."
				ed selectFrom: oldPoint to: cutIndex.
				ed cut.
				lastBuffer := lastBuffer, ed clipboardText.
				ed clipboardText: lastBuffer.

				"Update lastKillIndex."
				lastKillIndex := oldPoint.
			].
	].	
! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/10/2002 23:32'!
deleteForwards
	| pos |
	"Delete the next character after the point."

	self withEditorDo: [ :ed |
		pos := ed selectionInterval first.

		pos < ed text size
			ifTrue: [
				ed selectFrom: pos to: pos;
					cut.
			].
			
	].

! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/10/2002 22:45'!
endOfLine
	"Move the curser to the beginning of the current line."

	self withEditorDo: [ :ed |
		ed selectAt: (self findEndOfLineIn: ed text from: ed selectionInterval first).
	].! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/9/2002 21:36'!
paste
	"Insert the current clipboard contents at the current cursor position."
	
	lastKillIndex := nil.
	self withEditorDo: [ :ed | ed paste].
! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/9/2002 00:55'!
point
	| result |
	"Return the current cursor position.  If text has been selected, this becomes the beginning of the selected
	 region."

	self withEditorDo: [ :ed |	result := ed selectionInterval first].

	^result.! !

!PrefabEdit methodsFor: 'API-Editor' stamp: 'cr 4/9/2002 01:08'!
point: index
	|  ndx |
	"Set the current cursor position.  This cancels any selection."

	ndx := index.
	self withEditorDo: [ :ed |	
		"Force ndx to be within an acceptable range."
		ndx := (1 max: ndx) min: text text size.

		ed selectAt: ndx.
	].
! !

!PrefabEdit methodsFor: 'API-Keyboard' stamp: 'cr 4/9/2002 23:45'!
bindKey: aKeystroke to: message
	"Bind the given keystroke (either a PrefabKeystroke or something that can be turned into one,
	 typically a string description) to the named message.  The message is sent to self and should be
	 implemented in the category 'API-Editor'."

	text addHookFor: aKeystroke asPrefabKeystroke withMessage: message.
	 ! !

!PrefabEdit methodsFor: 'API-Keyboard' stamp: 'cr 4/9/2002 23:47'!
bindKeyCollection: bindings
	"Bind a bunch of keystrokes in some sequencable collection, sorted in key, value pairs.  See
	 comment for #bindKey:to: for more details."

	 bindings pairsDo: [ :key :action | self bindKey: key to: action].! !

!PrefabEdit methodsFor: 'API-Keyboard' stamp: 'cr 4/8/2002 23:21'!
tabKey: aKey
	| oldKey keyObj |
	"Set the tabbing key."
	
	keyObj := aKey asPrefabKeystroke.

	(oldKey := self tabKeyObject)
		ifNotNil: [text removeHookFor: oldKey].

	super tabKey: keyObj.

	text addHookFor: keyObj withMessage: #tabPressedEvt:.! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 4/9/2002 00:34'!
handlesMouseDown: evt
	^true! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 2/27/2000 02:08'!
handlesMouseOver: evt
	^true.! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 4/9/2002 00:37'!
mouseDown: evt
	"Mouse clicks inside this morph (but not necessarily within the bounds of the text element)
	 should still give it the focus."
	self takeFocusOn: evt hand.! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 2/27/2000 02:08'!
mouseEnter: event
	"Restore the selection."

	super mouseEnter: event.

	selection ifNotNil: [
		text handleEdit: [
			text editor selectInterval: selection;
				setEmphasisHere
		]
	].
	event hand newKeyboardFocus: text
! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 2/27/2000 02:08'!
mouseLeave: event
	"Snag the selection before the focus goes away."

	text ifNotNil: [selection := text editor selectionInterval].
	super mouseLeave: event.
	event hand newKeyboardFocus: nil.
! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 9/23/2001 19:19'!
scrollAfterSelection: afterSel changedFrom: beforeSel
	"After a keystroke, scroll the cursor back into view if necessary."
	| cursorIndex line sp |

	"Determine cursor index."
	afterSel first = afterSel last
		ifTrue: [cursorIndex := afterSel first]
		ifFalse: [
			afterSel first ~= beforeSel first
				ifTrue: [cursorIndex := afterSel first]
				ifFalse: [cursorIndex := afterSel last].
		].


	line := text paragraph lineIndexOfCharacterIndex: cursorIndex + 1.
	sp := self scrollPosition.

	line < sp
		ifTrue: [^self scrollPosition: line].

	line >= (sp + self visibleLines - 1)
		ifTrue: [^self scrollPosition: line - self visibleLines + 1].


! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 4/8/2002 23:45'!
xxxmouseEnter: event
	"Restore the selection."

	super mouseEnter: event.

	selection ifNotNil: [
		text handleEdit: [
			text editor selectInterval: selection;
				setEmphasisHere
		]
	].
	event hand newKeyboardFocus: text
! !

!PrefabEdit methodsFor: 'events' stamp: 'cr 4/8/2002 23:45'!
xxxmouseLeave: event
	"Snag the selection before the focus goes away."

	text ifNotNil: [selection := text editor selectionInterval].
	super mouseLeave: event.
	event hand newKeyboardFocus: nil.
! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 4/10/2002 22:43'!
findBeginningOfLineIn: txt from: index
	| ndx |
	"Move the curser to the beginning of the current line."

	ndx := index.

	[ndx > 1 and: [(txt at: ndx - 1) ~= Character cr]]
		whileTrue: [ndx := ndx - 1].

	^ndx! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 4/10/2002 00:18'!
findEndOfLineIn: txt from: index
	| ndx last |
	"Find the index of the end of the current line."

	ndx := index.
	last := txt size.

	[ndx < last and: [(txt at: ndx) ~= Character cr]]
		whileTrue: [ndx := ndx + 1].

	^ndx.
! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 2/8/2000 18:53'!
lineHeight
	^text defaultLineHeight! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 2/8/2000 21:45'!
scrollTo: index
	"Pvt--Scroll to line 'index'."
	textTransform offset: 0@((index - 1) * self lineHeight).! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 4/14/2002 21:01'!
updateSlider
	"Position and size the slider of the attached vertical scroll bar (if it exists)
	 to reflect the current position and viewable ratio."
	vScrollBar ifNotNil: [
		vScrollBar ratio: self visibleRatio;
			fractionalPositionQuiet: self fractionalPosition;
			stepSize: 1.0/text paragraph numberOfLines
	].! !

!PrefabEdit methodsFor: 'private' stamp: 'cr 2/8/2000 18:53'!
visibleLines
	"Return number of lines displayable at current size."
	^self innerBounds height // self lineHeight.! !

!PrefabEdit methodsFor: 'focus' stamp: 'cr 4/8/2002 23:22'!
hasLogicalFocus
	"Return true if self OR a sub-component has the focus."

	^ text hasFocus! !

!PrefabEdit methodsFor: 'focus' stamp: 'cr 4/8/2002 23:54'!
logicalKeyboardFocusChange: gotIt
	"Indicate current focus status.  This gets called by the object in 'text'."

	gotIt
		ifTrue: [self restoreSelection]
		ifFalse: [self saveSelection].

	self showFocus: gotIt.! !

!PrefabEdit methodsFor: 'focus' stamp: 'cr 4/8/2002 23:23'!
neverGetsFocus
	"Return true if instances of this class will never, ever want the keyboard focus.  Returning true
	 also means that this object does not know how to deal with keyboard input.  This result
	 should be considered a constant."

	^false! !

!PrefabEdit methodsFor: 'focus' stamp: 'cr 4/8/2002 23:32'!
showFocus: gotIt
	"Alter self's appearance to indicate that it has or does not have the keyboard focus."

	gotIt
		ifTrue: [self borderColor: self focusColor]
		ifFalse: [self borderColor: #inset].

! !

!PrefabEdit methodsFor: 'focus' stamp: 'cr 4/8/2002 23:24'!
tabPressedEvt: keyEvt
	"The tab key has been pressed."

	self tabToNextFor: keyEvt hand.
	
	"Discard the keystroke.  (This should be smarter.)"
	^false! !

!PrefabEdit methodsFor: 'focus' stamp: 'cr 4/8/2002 23:24'!
takeFocusOn: hand
	"Give yourself the focus on 'hand'.  In this case, it's the HookedTextMorph that gets the focus."
	hand newKeyboardFocus: text.! !

!PrefabEdit methodsFor: 'focus-system' stamp: 'cr 4/8/2002 23:22'!
keyboardFocusChange: gotIt
	"The message is sent to a morph when its keyboard focus change. The given argument indicates that the receiver is gaining keyboard focus (versus losing) the keyboard focus. Morphs that accept keystrokes should change their appearance in some way when they are the current keyboard focus. This default implementation does nothing."

	"We really shouldn't ever get this.  For the moment, just drop it on the floor."! !

!PrefabEdit methodsFor: 'private-focus' stamp: 'cr 4/8/2002 23:52'!
restoreSelection
	"Restore the selection."

	selection ifNotNil: [
		text handleEdit: [
			text editor selectInterval: selection;
				setEmphasisHere
		]
	].
! !

!PrefabEdit methodsFor: 'private-focus' stamp: 'cr 4/8/2002 23:53'!
saveSelection
	"Snag the selection before the focus goes away."

	text 
		ifNotNil: [selection := text editor selectionInterval].
! !

!PrefabEdit methodsFor: 'private-focus' stamp: 'cr 4/9/2002 01:14'!
withEditorDo: aBlock
	| fixSel |
	"Force an editor into existence and pass it to 'aBlock' after first making sure that the
	 selection has been restored and saving it after if necessary."

	"EXPERIMENTAL."

	"Determine whether we need to restore and save the selection."
	fixSel := self hasLogicalFocus not.

	text handleEdit: [

		"This is inlined from 'restoreSelection' so that everything happens in the same handleEdit
		 block.  I'm not sure if this is necessary."
		fixSel & selection notNil
			ifTrue: [text editor selectInterval: selection;
						setEmphasisHere].

		"Now, do the block thing."
		aBlock value: text editor.
	].

	"If necessary, resave the selection."
	fixSel
		ifTrue: [
			self saveSelection.
			text releaseEditor.
		].

! !


!PrefabEdit class methodsFor: 'constants' stamp: 'cr 4/10/2002 23:46'!
emacsBindingArray
	"Return an array of keymappings to message for use by #setKeyBindings:.  This collection provides
	 the beginnings of a subset of emacs bindings, 'cause EVERYONE likes emacs, right?"

	^#(
		'CTRL+a'			beginningOfLine
		'CTRL+e'				endOfLine
		'CTRL+w'			cutSelection
		'CTRL+k'			cutToEndOfLine
		'CTRL+y'			paste

		'CTRL+d'				deleteForwards

		'CTRL+f'				cursorRight
		'right'				cursorRight

		'CTRL+b'			cursorLeft
		'left'				cursorLeft

		'CTRL+n'			cursorDown
		'down'				cursorDown

		'CTRL+p'			cursorUp
		'up'					cursorUp
	).! !

!PrefabEdit class methodsFor: 'parts bin' stamp: 'cr 4/27/2003 07:08'!
descriptionForPartsBin
	^self partName: 'PrefabEdit'
		categories: #('Prefab')
		documentation: 'A text editor'! !


!PrefabEntry methodsFor: 'initialization' stamp: 'cr 3/6/2002 22:38'!
initialize
	super initialize.

	returnResponse := PrefabResponse new.

	self borderWidth: 2;
		borderColor: #inset.

	font := Prefab defaultEntryFont.

	textTransform := TransformMorph new 
						color: Color transparent;
						bounds: self innerBounds;
						yourself.
	self addMorph: textTransform.

	text := HookedTextMorph new
			contentsWrapped: 'edit me';
			hookTarget: self;
			position: 0@0;
			width: 99999;
			beAllFont: font;
			addHookFor: Character cr asPrefabKeystroke withMessage: #returnHit: ;
			focusHook: #logicalKeyboardFocusChange:;
			anyKeyHook: #tryAsShortcut: .

	textTransform addMorph: text.

	self extent: 80 @ 1.		"Height is ignored."

	self tabKey: Prefab defaultTabbingKey.
	
	"Set text to fill its container."
"	((text container isKindOf: TextContainer) and: [text container fillsOwner not])
		ifFalse: [text fillingOnOff].
"


	! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 2/8/2000 18:54'!
extent: aPoint
	super extent: aPoint x @ (self lineHeight + (self borderWidth * 2)).
	textTransform extent: self innerBounds extent.
	owner ifNotNil: [text height: text defaultLineHeight].
! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 12/10/2001 00:20'!
font
	"Return the name of the current font."
	^self nameForFont: font! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 12/10/2001 00:10'!
font: aFontOrString
	| curserPos |
	"Set the font to use for any text contents, present or future.  The font may be an actual StrikeFont or a string
	 describing it.  The description format is '<family-name>-<size>'.

	 Note: if I decide to add support for Text labels (rather than just strings), it is not clear yet how 
	 this will affect it.

	 NOTE: this will change the vertical height of the PrefabEntry widget.  (The rule is that text Prefabs
	 whose height is determined by their contents will change when the font is changed.)"

	font := self fontNamed: aFontOrString.
	text beAllFont: font.
	self extent: self width @ 1.		"Force height change."

	"If necessary, rescroll to the curser position again."
	curserPos := text editor selectionInterval.
	self scrollAfterSelection: curserPos changedFrom: curserPos.! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 2/7/2000 23:32'!
foregroundColor
	^text color! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 2/7/2000 23:31'!
foregroundColor: aColor
	text color: aColor.! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 8/20/1999 23:14'!
text
	^text contents asString.! !

!PrefabEntry methodsFor: 'API' stamp: 'cr 2/19/2000 21:41'!
text: aTextOrString
	text contentsWrapped: aTextOrString asString! !

!PrefabEntry methodsFor: 'API-Actions' stamp: 'cr 1/23/2000 19:40'!
actionReturnPressed: aBlockOrSymbol
	"Action to occur when return is pressed."
	returnResponse action: aBlockOrSymbol.! !

!PrefabEntry methodsFor: 'API-Actions' stamp: 'cr 1/23/2000 19:44'!
argsReturnPressed: anArray
	"Array of extra arguments to pass to the response invoked when return is pressed."
	returnResponse args: anArray.! !

!PrefabEntry methodsFor: 'API-Actions' stamp: 'cr 1/23/2000 19:46'!
targetReturnPressed: anObject
	"The target to which to send the message assigned to actionReturnPressed (if it's a symbol
	 and not a block) when return is pressed."
	returnResponse target: anObject.! !

!PrefabEntry methodsFor: 'API-Keyboard' stamp: 'cr 3/3/2002 22:06'!
tabKey: aKey
	| oldKey keyObj |
	"Set the tabbing key."
	
	keyObj := aKey asPrefabKeystroke.

	(oldKey := self tabKeyObject)
		ifNotNil: [text removeHookFor: oldKey].

	super tabKey: keyObj.

	text addHookFor: keyObj withMessage: #tabPressedEvt:.! !

!PrefabEntry methodsFor: 'events' stamp: 'cr 2/14/2002 20:24'!
returnHit: evt
	| r |
	"The message the HookedTextMorph sends when return is hit."

	r := returnResponse invoke.

	"For the sake of tolerance, we assume a non-boolean return value is false."
	(r isKindOf: Boolean	)
		ifTrue: [^r]
		ifFalse: [^false].
	
! !

!PrefabEntry methodsFor: 'events' stamp: 'cr 9/23/2001 21:40'!
scrollAfterSelection: afterSel changedFrom: beforeSel
	| cursorIndex cb tib shiftVal |
	"Offset the text morph so that the curser is always visible."

	"TODO: make it so that the left and right scrolling happens in nicely-sized chunks rather
	 than exactly half a width."

	"Determine cursor index."
	afterSel first = afterSel last
		ifTrue: [cursorIndex := afterSel first]
		ifFalse: [
			afterSel first ~= beforeSel first
				ifTrue: [cursorIndex := afterSel last]
				ifFalse: [cursorIndex := afterSel first].
		].

	cursorIndex = 0
		ifTrue: [
			textTransform offset: 0@0.
			^self.
		].

	tib := textTransform innerBounds.
	cb := (text paragraph characterBlockForIndex: cursorIndex) 
				translateBy: (tib origin - (textTransform offset x @ 0)).

	(tib containsRect: cb)
		ifFalse: [
	
			"Set shiftval to current offset."
			shiftVal := textTransform offset x.

			"Adjust shiftVal by the amount to scroll (i.e. half a widget-length)."
			shiftVal := shiftVal + (cb center x - tib center x).

			"Adjust the shift."
			textTransform offset: (0 max: shiftVal)@0.
		].






! !

!PrefabEntry methodsFor: 'private' stamp: 'cr 2/13/2000 18:44'!
lineHeight
	^text defaultLineHeight! !

!PrefabEntry methodsFor: 'focus' stamp: 'cr 2/13/2002 20:34'!
hasLogicalFocus
	"Return true if self OR a sub-component has the focus."

	^ text hasFocus! !

!PrefabEntry methodsFor: 'focus' stamp: 'cr 2/13/2002 21:11'!
logicalKeyboardFocusChange: gotIt
	"Indicate current focus status.  This gets called by the object in 'text'."

	self showFocus: gotIt.! !

!PrefabEntry methodsFor: 'focus' stamp: 'cr 2/13/2002 20:35'!
neverGetsFocus
	"Return true if instances of this class will never, ever want the keyboard focus.  Returning true
	 also means that this object does not know how to deal with keyboard input.  This result
	 should be considered a constant."

	^false! !

!PrefabEntry methodsFor: 'focus' stamp: 'cr 2/13/2002 21:10'!
showFocus: gotIt
	"Alter self's appearance to indicate that it has or does not have the keyboard focus."

	gotIt
		ifTrue: [self borderColor: self focusColor]
		ifFalse: [self borderColor: #inset].

! !

!PrefabEntry methodsFor: 'focus' stamp: 'cr 2/18/2002 20:34'!
tabPressedEvt: keyEvt
	"The tab key has been pressed."

	self tabToNextFor: keyEvt hand.
	
	"Discard the keystroke.  (This should be smarter.)"
	^false! !

!PrefabEntry methodsFor: 'focus' stamp: 'cr 2/18/2002 20:38'!
takeFocusOn: hand
	"Give yourself the focus on 'hand'.  In this case, it's the HookedTextMorph that gets the focus."
	hand newKeyboardFocus: text.! !

!PrefabEntry methodsFor: 'focus-system' stamp: 'cr 2/13/2002 20:53'!
keyboardFocusChange: gotIt
	"The message is sent to a morph when its keyboard focus change. The given argument indicates that the receiver is gaining keyboard focus (versus losing) the keyboard focus. Morphs that accept keystrokes should change their appearance in some way when they are the current keyboard focus. This default implementation does nothing."

	"We really shouldn't ever get this.  For the moment, just drop it on the floor."! !


!PrefabEntry class methodsFor: 'parts bin' stamp: 'cr 4/27/2003 07:09'!
descriptionForPartsBin
	^self partName: 'PrefabEntry'
		categories: #('Prefab')
		documentation: 'A text entry field'! !


!PrefabFileSelector methodsFor: 'initialization' stamp: 'cr 8/11/2003 23:23'!
initialize
	window := PrefabManager new.
	window resizer: FixedDistanceResizer new.

	self buildOn: window.
	self findAndActivateComponents.
	self fixEdges.

! !

!PrefabFileSelector methodsFor: 'window construction' stamp: 'cr 8/11/2003 23:53'!
buildOn: aManager
	"Caution--automatically-generated method."
	| rootManager |

	rootManager := aManager.

	rootManager
		extent: 648@512;
		color: (Color r: 0.871 g: 0.871 b: 0.871);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		minSize: 1@1;
		maxSize: 1073741823@1073741823;
		yourself.


	rootManager addClient: (PrefabFrame new
		extent: 612@387;
		color: (Color r: 0.871 g: 0.871 b: 0.871);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		borderStyle: (InsetBorder basicNew instVarAt: 1 put: nil; instVarAt: 2 put: (Color r: 0.871 g: 0.871 b: 0.871); instVarAt: 3 put: 1; yourself);
		tag: #panelFrame;
		yourself)
		atRelPosition: 20@45.

	rootManager addClient: (PrefabEntry new
		extent: 512@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #dirEntryField;
		yourself)
		atRelPosition: 84@21.

	rootManager addClient: (PrefabButton new
		extent: 24@24;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #prevDirButton;
		image: #prevDir;
		contentOrientation: #centered;
		font: 'NewYork-12';
		yourself)
		atRelPosition: 604@17.

	rootManager addClient: (PrefabScrollingManager new
		extent: 596@371;
		color: (Color r: 0.871 g: 0.871 b: 0.871);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #filesScrollPane;
		minSize: 1@1;
		maxSize: 1073741823@1073741823;
		scrollBarWidth: 16;
		extentPadding: 16@16;
		yourself)
		atRelPosition: 28@53.

	rootManager addClient: (PrefabButton new
		extent: 103@32;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #selectButton;
		text: 'Select';
		contentOrientation: #centered;
		font: 'NewYork-12';
		yourself)
		atRelPosition: 416@472.

	rootManager addClient: (PrefabLabel new
		extent: 56@24;
		color: (Color r: 0.871 g: 0.871 b: 0.871);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Filename';
		contentOrientation: #left;
		font: 'NewYork-12';
		tag: #fileNameLabel;
		yourself)
		atRelPosition: 24@440.

	rootManager addClient: (PrefabEntry new
		extent: 544@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #fileEntryField;
		yourself)
		atRelPosition: 88@442.

	rootManager addClient: (PrefabLabel new
		extent: 56@16;
		color: (Color r: 0.871 g: 0.871 b: 0.871);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Mask';
		contentOrientation: #left;
		font: 'NewYork-12';
		tag: #maskLabel;
		yourself)
		atRelPosition: 24@472.

	rootManager addClient: (PrefabLabel new
		extent: 60@19;
		color: (Color r: 0.871 g: 0.871 b: 0.871);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Look In';
		contentOrientation: #left;
		font: 'NewYork-12';
		yourself)
		atRelPosition: 20@21.

	rootManager addClient: (PrefabEntry new
		extent: 80@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #maskEntryField;
		yourself)
		atRelPosition: 88@472.

	rootManager addClient: (PrefabButton new
		extent: 103@32;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #cancelButton;
		text: 'Cancel';
		contentOrientation: #centered;
		font: 'NewYork-12';
		yourself)
		atRelPosition: 528@472.

! !

!PrefabFileSelector methodsFor: 'window construction' stamp: 'cr 8/11/2003 22:50'!
createAndHookupIconPanel
	
	fileScroller := window clientWithTag: #filesScrollPane.

	fileScroller addClient: (filePane := PrefabIconPanel new
			rowLength: 3;
			iconExtent: 16@16;
			font: 'NewYork-12';
			elementLayout: #right;

			yourself).! !

!PrefabFileSelector methodsFor: 'window construction' stamp: 'cr 8/11/2003 23:53'!
fixEdges

	window resizer
		fixRightAndBottomOf: (window clientWithTag: #panelFrame);
		fixRightAndBottomOf: fileScroller;

		fixAllOf: (window clientWithTag: #cancelButton);
		fixAllOf: (window clientWithTag: #selectButton);

		fixLeftAndRightOf: (window clientWithTag: #prevDirButton);

		fixRightOf: dirField;
		fixAllButLeftOf: filenameField;
		fixTopAndBottomOf: maskField;

		fixTopAndBottomOf: (window clientWithTag: #fileNameLabel);
		fixTopAndBottomOf: (window clientWithTag: #maskLabel);

		yourself.	! !

!PrefabFileSelector methodsFor: 'window construction' stamp: 'cr 8/11/2003 23:18'!
openWithLabel: text
	window openInSystemWindowNamed: text.
	! !

!PrefabFileSelector methodsFor: 'events--buttons' stamp: 'cr 8/7/2003 21:02'!
cancelPressed
	self stub.
! !

!PrefabFileSelector methodsFor: 'events--buttons' stamp: 'cr 8/7/2003 21:05'!
selectPressed
	self stub.
! !

!PrefabFileSelector methodsFor: 'events--buttons' stamp: 'cr 8/7/2003 21:04'!
upDirPressed
	self stub.
! !

!PrefabFileSelector methodsFor: 'events--edit widgets' stamp: 'cr 8/11/2003 21:44'!
dirFieldChanged
	self stub.
! !

!PrefabFileSelector methodsFor: 'events--edit widgets' stamp: 'cr 8/11/2003 21:44'!
fileFieldChanged
	self stub.
! !

!PrefabFileSelector methodsFor: 'events--edit widgets' stamp: 'cr 8/11/2003 21:44'!
maskChanged
	self stub.
! !

!PrefabFileSelector methodsFor: 'control behaviour' stamp: 'cr 8/6/2003 23:32'!
findAndActivateComponents
	
	self hookUpTextFields.
	self hookUpButtons.
	self createAndHookupIconPanel.! !

!PrefabFileSelector methodsFor: 'control behaviour' stamp: 'cr 8/11/2003 23:24'!
hookUpButtonNamed: name action: action
	(window clientWithTag: name)
		action: action;
		target: self.

! !

!PrefabFileSelector methodsFor: 'control behaviour' stamp: 'cr 8/11/2003 23:22'!
hookUpButtons
	self	hookUpButtonNamed: #selectButton action: #selectPressed;
		hookUpButtonNamed: #cancelButton action: #cancelPressed;
		hookUpButtonNamed: #prevDirButton action: #upDirPressed.
! !

!PrefabFileSelector methodsFor: 'control behaviour' stamp: 'cr 8/11/2003 23:20'!
hookUpEntryNamed: name action: action
	^(window clientWithTag: name)
		targetReturnPressed: self;
		actionReturnPressed: action;
		yourself.

! !

!PrefabFileSelector methodsFor: 'control behaviour' stamp: 'cr 8/11/2003 21:42'!
hookUpTextFields
	maskField 		:= self hookUpEntryNamed: #maskEntryField	action: #maskChanged.
	filenameField	:= self hookUpEntryNamed: #fileEntryField	action: #fileFieldChanged.
	dirField			:= self hookUpEntryNamed: #dirEntryField	action: #dirFieldChanged.
! !


!PrefabFileSelector class methodsFor: 'as yet unclassified' stamp: 'cr 8/11/2003 23:20'!
new
	^self basicNew initialize.! !


!PrefabFrame methodsFor: 'initialization' stamp: 'cr 7/13/1999 23:08'!
initialize
	super initialize.

	self borderWidth: Prefab defaultFrameBorderWidth.
	self borderColor: #inset.
	self extent: 103@32.! !

!PrefabFrame methodsFor: 'API' stamp: 'cr 11/2/2002 20:49'!
borderType
	"Return the style of the border, one of #inset, #raised or #flush."

	| bc |
	bc := self borderColor.

	bc class = Color
		ifTrue: [^#flush]
		ifFalse: [^bc].
! !

!PrefabFrame methodsFor: 'API' stamp: 'cr 11/2/2002 20:49'!
borderType: aSymbol
	"Set the style of the border to one of #inset, #raised or #flush."

	"Paranoia"
	(#(inset raised flush) includes: aSymbol)
		ifFalse: [self error: 'invalid style, ', aSymbol printString].

	aSymbol = #flush
		ifTrue: [self borderColor: self color]
		ifFalse: [self borderColor: aSymbol].
! !

!PrefabFrame methodsFor: 'API' stamp: 'cr 7/14/1999 23:40'!
style
	"Return the look of the frame."

	| bc |
	bc := self borderColor.

	bc class = Color
		ifTrue: [^#flush]
		ifFalse: [^bc].
! !

!PrefabFrame methodsFor: 'API' stamp: 'cr 7/14/1999 23:40'!
style: aSymbol
	"Set the look of the frame."

	"Paranoia"
	(#(inset raised flush) includes: aSymbol)
		ifFalse: [self error: 'invalid style, ', aSymbol printString].

	aSymbol = #flush
		ifTrue: [self borderColor: self color]
		ifFalse: [self borderColor: aSymbol].
! !

!PrefabFrame methodsFor: 'construction' stamp: 'cr 12/11/2001 03:33'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		add: {#borderStyle:. self borderStyle};
		yourself.! !

!PrefabFrame methodsFor: 'dragging/dropping' stamp: 'cr 11/4/2001 21:58'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add submorphs just by dropping them on this morph."
	(self manager isConstruction)
		ifTrue: [self manager addClient: aMorph].
! !

!PrefabFrame methodsFor: 'dragging/dropping' stamp: 'cr 1/18/2002 00:24'!
allowSubmorphExtraction
	
	^self manager isConstruction! !

!PrefabFrame methodsFor: 'dragging/dropping' stamp: 'cr 11/25/2001 23:03'!
privateRemoveMorph: aMorph
	"If aMorph is a prefab, notify the resizer of the change."

	(aMorph isPrefab and: [self manager notNil and: [self isContainer not]])
		ifTrue: [self manager resizer removeClient: aMorph].

	super privateRemoveMorph: aMorph.! !

!PrefabFrame methodsFor: 'dragging/dropping' stamp: 'cr 2/24/2000 22:42'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a hand in response to the given event."

	^ self manager notNil and: [self manager wantsDroppedMorph: aMorph event: evt].! !

!PrefabFrame methodsFor: 'menu' stamp: 'cr 2/24/2000 22:20'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set border style' target: self action: #setStyle.! !

!PrefabFrame methodsFor: 'menu' stamp: 'cr 2/24/2000 22:22'!
setStyle
	"Pick a border style."
	| styles index |
	styles := #(raised inset flushed).

	index := (PopUpMenu labels: 'raised\inset\flush' withCRs)
				startUpWithCaption: 'Pick a border style'.

	self style: (styles at: index).! !

!PrefabFrame methodsFor: 'placement' stamp: 'cr 7/14/1999 22:59'!
hollowRegion
	^self innerBounds! !


!PrefabFrame class methodsFor: 'parts bin' stamp: 'nk 3/23/2003 18:11'!
descriptionForPartsBin
	^self partName: 'PrefabFrame'
		categories: #('Prefab')
		documentation: 'A frame'! !


!PrefabIconPanel methodsFor: 'initialization' stamp: 'cr 8/4/2003 22:54'!
initialize
	super initialize.

	entries := OrderedCollection new.

	rowLength := Prefab defaultIconPanelRowLength.
	font := self fontNamed: Prefab defaultIconPanelFontName.
	iconExtent := Prefab defaultIconPanelIconExtent.
	elementPadding := Prefab defaultIconPanelElementPadding.
	maxCharsDisplayed := Prefab defaultIconPanelMaxCharsDisplayed.
	elementLayout := #bottom.
	selectionColor := Prefab defaultIconPanelSelectionColor.
	multipleSelect := false.
	selectedItems := Set new.

	doubleClickResponse := PrefabResponse new.
	selectResponse := PrefabResponse new.

	self borderWidth: 0.
	self geometryChanged.! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/28/2003 21:31'!
allowMultipleSelect
	^multipleSelect! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/28/2003 21:31'!
allowMultipleSelect: aBoolean
	multipleSelect := aBoolean! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 8/4/2003 22:27'!
clearSelection
	"Clear any selection that may have occurred."

	self colorSelected: Color transparent.
	selectedItems := Set new.
! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/20/2003 21:36'!
elementLayout
	"Set the desired placement of the text relative to the picture in each element.  Options are #below and
	 #right."
	^elementLayout.! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/21/2003 22:05'!
elementLayout: layoutSymbol
	"Set the desired placement of the text relative to the picture in each element.  Options are #below and
	 #right."

	(#(bottom right) includes: layoutSymbol)
		ifFalse: [self error: 'elementLayout must be one of #below or #right.'].

	elementLayout := layoutSymbol.
	self elementAttributesChanged.! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/20/2003 20:43'!
extent: aPoint
! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/20/2003 21:26'!
font
	^self nameForFont: font.
! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/20/2003 21:29'!
font: aFontOrString
	"Set the font to use for any text contents, present or future.  The font may be an actual StrikeFont or a string
	 describing it.  The description format is '<family-name>-<size>'."

	font := self fontNamed: aFontOrString.
	self elementAttributesChanged.! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/22/2003 21:22'!
iconExtent
	"The extent of the icon parts of the individual elements."
	^iconExtent
! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/22/2003 23:02'!
iconExtent: newExtent
	"Set the extent of the icon parts of the individual elements.

	 Warning: Doing this on an existing populated Panel will resize the existing icons by scaling them
	 and introducing some measure of error.  Repeatedly changing the size will reduce them to a blurry
	 mess so DON'T DO THAT!!

	 This is here so you can set the size when the window opens.  Being able to resize existing icons
	 is here strictly as a development aid.  Figure out the size you want, set that before adding any
	 elements, then DON'T CHANGE IT!!"


	iconExtent := newExtent.
	self elementAttributesChanged.
! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/20/2003 20:50'!
maxCharsDisplayed
	"Get the maximum number of characters guaranteed to be displayed without truncation.  Note that if a variable-width
	 font is used, it is possible that more characters will be displayed without truncation."

	^maxCharsDisplayed! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/22/2003 21:18'!
maxCharsDisplayed: numChars
	"Set the maximum number of characters guaranteed to be displayed without truncation.  Note that if a variable-width
	 font is used, it is possible that more characters will be displayed without truncation."
	maxCharsDisplayed := numChars.

	self elementAttributesChanged.	! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/21/2003 21:03'!
rowLength
	"Number of icons to display in a horizontal row."
	^rowLength
! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/21/2003 21:03'!
rowLength: newLength
	"Set number of icons to display in a horizontal row."
	rowLength := newLength.
	self geometryChanged.
! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 8/4/2003 22:26'!
selectedItems
	"Return a Set containing the tags of all selected items (i.e. the associated values rather than the
	 label text part)."
	^selectedItems collect: [ :item | item panelEntry tag].! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/28/2003 21:38'!
selectionColor
	"The background colour for selected icons."
	^selectionColor! !

!PrefabIconPanel methodsFor: 'API' stamp: 'cr 7/28/2003 21:40'!
selectionColor: aColor
	"Set the background colour for selected icons."
	selectionColor := aColor.
	self colorSelected: aColor.! !

!PrefabIconPanel methodsFor: 'API-Contents' stamp: 'cr 7/20/2003 21:05'!
addItemTagged: tagObject withPicture: formOrName withText: aString

	self addEntry: (IconPanelEntry icon: (Prefab formFor: formOrName) text: aString tag: tagObject).
	! !

!PrefabIconPanel methodsFor: 'API-Contents' stamp: 'cr 8/11/2003 23:01'!
clearContents
	self clearSelection.
	entries do: [ :entry | entry element delete].
	entries := OrderedCollection new.
	self elementAttributesChanged.! !

!PrefabIconPanel methodsFor: 'API-Contents' stamp: 'cr 8/11/2003 23:02'!
removeItemTagged: itemTag

	| entry |

	self clearSelection.
	entry := entries detect: [ :e | e tag = itemTag] ifNone: [^self].

	entry element delete.
	entries remove: entry.

	self elementAttributesChanged.! !

!PrefabIconPanel methodsFor: 'API-Actions' stamp: 'cr 8/4/2003 22:47'!
actionDoubleClick: aBlockOrSymbol
	"What to do when an item is double-clicked.  The block or method gets one extra argument, the tag of the item
	 clicked."

	doubleClickResponse action: aBlockOrSymbol.! !

!PrefabIconPanel methodsFor: 'API-Actions' stamp: 'cr 8/4/2003 22:58'!
actionSelect: aBlockOrSymbol
	"What to do when an item is selected.  The block or method gets one extra argument, the tag of the item
	 clicked."

	selectResponse action: aBlockOrSymbol.! !

!PrefabIconPanel methodsFor: 'API-Actions' stamp: 'cr 8/4/2003 22:58'!
args: argArray
	"Set the arguments (if any) to be passed on in the event of a selection or double-click if an action has
	 been set for them."

	doubleClickResponse args: argArray.
	selectResponse args: argArray.
! !

!PrefabIconPanel methodsFor: 'API-Actions' stamp: 'cr 8/4/2003 22:58'!
target: targetObject
	"If an action is set for selection or double-clicks AND that action is a message name, targetObject is the
	 receiver of that message."

	doubleClickResponse target: targetObject.
	selectResponse target: targetObject.
! !

!PrefabIconPanel methodsFor: 'placement' stamp: 'cr 8/11/2003 22:59'!
elementAttributesChanged
	entries do: [ :entry | entry element	pictureExtent: iconExtent;
								textPartWidth: self textPartWidth;
								font: font;
								elementLayout: self elementLayout.
	].

	self geometryChanged.
! !

!PrefabIconPanel methodsFor: 'placement' stamp: 'cr 7/20/2003 22:16'!
geometryChanged
	self setExtent.
	entries withIndexDo: [ :entry :index | self positionElement: entry element atSlot: index].! !

!PrefabIconPanel methodsFor: 'geometry' stamp: 'cr 7/21/2003 22:15'!
coordsForSlot: slotNum
	| row padding column |

	padding := Prefab defaultIconPanelElementPadding.

	row     := (slotNum - 1) // self rowLength.
	column := (slotNum - 1) \\ self rowLength.

	^padding + ((self elementParcelExtent + padding) * (column @ row)).
! !

!PrefabIconPanel methodsFor: 'geometry' stamp: 'cr 7/21/2003 22:05'!
elementParcelExtent
	self elementLayout = #bottom
		ifTrue: [^ (iconExtent x max: self textPartWidth) @ (iconExtent y + self textPartHeight)]
		ifFalse: [^ (iconExtent x + self textPartWidth) @ (iconExtent y max: self textPartHeight)].
! !

!PrefabIconPanel methodsFor: 'geometry' stamp: 'cr 7/21/2003 22:09'!
setExtent
	| numRows padding newExtent |

	padding := Prefab defaultIconPanelElementPadding.
	numRows := (entries size // self rowLength) + 1.
	
	newExtent := ((self rowLength @ numRows) * (self elementParcelExtent + padding)) + padding.
	super extent: newExtent.! !

!PrefabIconPanel methodsFor: 'geometry' stamp: 'cr 7/21/2003 21:13'!
textPartHeight
	^font height.! !

!PrefabIconPanel methodsFor: 'geometry' stamp: 'cr 7/20/2003 22:08'!
textPartWidth
	^font maxWidth * self maxCharsDisplayed.! !

!PrefabIconPanel methodsFor: 'contents' stamp: 'cr 7/20/2003 21:38'!
addEntry: entryStruct

	entries add: entryStruct.
	self createElement: entryStruct.

	self geometryChanged.! !

!PrefabIconPanel methodsFor: 'contents' stamp: 'cr 7/28/2003 21:40'!
colorSelected: aColor
	selectedItems do: [ :item | item color: aColor]! !

!PrefabIconPanel methodsFor: 'contents' stamp: 'cr 8/4/2003 23:10'!
createElement: entryStruct
	| element |
	element := IconPanelElement 
				entry: entryStruct
					font: self font
					pictureExtent: iconExtent
					labelWidth: self elementParcelExtent x 
					belowOrBeside: self elementLayout.

	element
		on: #mouseDown send: #elementClickedEvent:onElement: to: self;
		on: #doubleClick send: #elementDoubleClickedEvent:onElement: to: self.

	entryStruct element: element.
	self addMorph: element.
! !

!PrefabIconPanel methodsFor: 'contents' stamp: 'cr 7/21/2003 21:27'!
positionElement: element atSlot: slotNum
	element position: self innerBounds origin + (self coordsForSlot: slotNum).! !

!PrefabIconPanel methodsFor: 'events' stamp: 'cr 8/4/2003 23:06'!
elementClickedEvent: event onElement: element

	(self allowMultipleSelect not or: [event shiftPressed not])
		ifTrue: [self clearSelection].

	selectedItems add: element.
	element color: self selectionColor.
	selectResponse invokeWith: element panelEntry tag.

	! !

!PrefabIconPanel methodsFor: 'events' stamp: 'cr 8/4/2003 23:08'!
elementDoubleClickedEvent: event onElement: element
	doubleClickResponse invokeWith: element panelEntry tag.

	! !

!PrefabIconPanel methodsFor: 'junk' stamp: 'cr 8/11/2003 23:03'!
fill: count
	"This is for debugging only.  Do not use in programs."
	1 to: count do: [ :x | self addItemTagged: x withPicture: Prefab availableImages atRandom 
								withText: 'Icon ', x printString.]
! !


!PrefabKeystroke methodsFor: 'comparing' stamp: 'cr 3/3/2002 22:14'!
= aKeystroke
	"Compare."
	
	(aKeystroke isKindOf: PrefabKeystroke)
		ifFalse: [^false].

	self == aKeystroke
		ifTrue: [^true].

	^charValue == aKeystroke value 
		and: [aKeystroke altPressed = alt
		and: [aKeystroke ctrlPressed = ctrl]].! !

!PrefabKeystroke methodsFor: 'comparing' stamp: 'cr 3/3/2002 19:54'!
hash
	| charBits result |
	"Hash is reimplemented because '=' is reimplemented.  Basically, this is the value of the ASCII character with
	 a couple of upper bits set depending on the values of the alt and control modifiers."

	"We calculate the number of bits a character will take up in the event that Squeak Central ever
	 decides to upgrade to UniCode."
	charBits := (Character characterTable size log: 2) ceiling.

	result := charValue.

	ctrl 
		ifTrue: [result := result bitOr: (1 << (charBits + 1))].

	alt
		ifTrue: [result := result bitOr: (1 << (charBits + 2))].

	"I hash 'result' before returning it because if charValue *is* Unicode, there's a remote possibility
	 that it's 32-bit, in which case we need to hash down to a small again."
	^result hash.! !

!PrefabKeystroke methodsFor: 'accessing' stamp: 'cr 2/18/2002 22:37'!
character
	^charValue asCharacter.! !

!PrefabKeystroke methodsFor: 'accessing' stamp: 'cr 2/18/2002 22:37'!
value
	^charValue
! !

!PrefabKeystroke methodsFor: 'testing' stamp: 'cr 2/18/2002 22:32'!
altPressed
	^alt! !

!PrefabKeystroke methodsFor: 'testing' stamp: 'cr 3/3/2002 19:33'!
cmdPressed
	"cmd is a synonym of alt.  (If this changes, you need to also fix = and hash)."
	^alt! !

!PrefabKeystroke methodsFor: 'testing' stamp: 'cr 2/18/2002 22:32'!
ctrlPressed
	^ctrl! !

!PrefabKeystroke methodsFor: 'conversion' stamp: 'cr 3/3/2002 21:46'!
asDescriptionString
	"Return the description string."
	| r |
	r := WriteStream on: (String new: 15).
	self writeDescriptionStringOn: r.
	^r contents.! !

!PrefabKeystroke methodsFor: 'conversion' stamp: 'cr 3/3/2002 21:36'!
asPrefabKeystroke
	^self.! !

!PrefabKeystroke methodsFor: 'conversion' stamp: 'cr 3/3/2002 21:10'!
withAlt
	^PrefabKeystroke new charValue: charValue ctrl: ctrl alt: true.! !

!PrefabKeystroke methodsFor: 'conversion' stamp: 'cr 3/3/2002 21:10'!
withCtrl
	^PrefabKeystroke new charValue: charValue ctrl: true alt: alt.! !

!PrefabKeystroke methodsFor: 'conversion' stamp: 'cr 3/3/2002 21:10'!
withCtrlAlt
	^PrefabKeystroke new charValue: charValue ctrl: true alt: true.! !

!PrefabKeystroke methodsFor: 'printing' stamp: 'cr 2/18/2002 23:26'!
printOn: aStream
	aStream nextPutAll: 'a PrefabKeystroke ('.
	self writeDescriptionStringOn: aStream.
	aStream nextPutAll: ')'.! !

!PrefabKeystroke methodsFor: 'printing' stamp: 'cr 3/3/2002 20:00'!
storeOn: aStream
	aStream nextPutAll: '(PrefabKeystroke fromDescriptionString: '''.
	self writeDescriptionStringOn: aStream.
	aStream nextPutAll: ''')'.! !

!PrefabKeystroke methodsFor: 'private' stamp: 'cr 2/18/2002 22:36'!
charValue: value ctrl: c alt: a
	"Pvt. Set the values."
	charValue := value.
	ctrl := c.
	alt := a.! !

!PrefabKeystroke methodsFor: 'private' stamp: 'cr 3/7/2002 22:04'!
setFromDescriptionString: aString
	| tokens |
	"Create an instance from a string description."

	alt := ctrl := false.
	charValue := nil.

	tokens := aString findTokens: '+'.

	tokens do: [ :tok |
		(tok asLowercase = 'cmd' or: [tok asLowercase = 'alt'])
			ifTrue: [alt := true]
			ifFalse: [

				tok asLowercase = 'ctrl'
					ifTrue: [ctrl := true]
					ifFalse: [
						"If charValue has already been set, this is an error."
						charValue ifNotNil: [self error: 'Invalid keystroke description string.'].

						"Character or ASCII code?"
						tok first = $\
							ifTrue: [charValue := tok allButFirst asInteger]
							ifFalse: [charValue := PrefabKeystroke codeFor: tok].
					].
			].
		].
	
! !

!PrefabKeystroke methodsFor: 'private' stamp: 'cr 3/7/2002 22:45'!
writeDescriptionStringOn: aStream
	"Write out a description suitable for use by 'fromDescriptionString:'."
	
	ctrl
		ifTrue: [aStream nextPutAll: 'CTRL+'].

	alt
		ifTrue: [aStream nextPutAll: 'ALT+'].

	aStream nextPutAll: (PrefabKeystroke nameFor: charValue).! !


!PrefabKeystroke class methodsFor: 'class initialization' stamp: 'cr 3/7/2002 22:29'!
initialize
	| code |
	"Set CharCodes and CharNames.  Note the order of the arrays.  When a symbol has a long 
	 and a short form, we prefer the long form in CharNames."

	CharCodes := Dictionary new.
	CharNames := Dictionary new.

	"First, everything that has constant in class Character."
	#(backspace enter cr escape euro linefeed lf space tab) do: [ :nm |
		CharCodes at: nm asString put: (code := (Character perform: nm) asciiValue).
	
		(CharNames includesKey: code)
			ifFalse: [CharNames at: code put: nm asString].
	].

	"Some extra keys.  I think that's it, actually."
	#(	left 		28
		right		29
		up			30
		down		31

		insert		5
		delete		8
		del			8

		home		1
		end			4

		pageUp		11
		pageDown	12

		pgUp		11
		pgDown		12
	) pairsDo: [ :nm :cc | 
		CharCodes at: nm asString put: cc.

		(CharNames includesKey: cc)
			ifFalse: [CharNames at: cc put: nm asString].
	].
! !

!PrefabKeystroke class methodsFor: 'instance creation' stamp: 'cr 3/3/2002 21:11'!
fromCharacter: aCharacter
	^super new
		charValue: aCharacter asciiValue ctrl: false alt: false;
		yourself.! !

!PrefabKeystroke class methodsFor: 'instance creation' stamp: 'cr 3/7/2002 21:40'!
fromDescriptionString: aString
	^super new setFromDescriptionString: aString.! !

!PrefabKeystroke class methodsFor: 'instance creation' stamp: 'cr 4/10/2002 00:01'!
fromKeyboardEvent: evt
	"Create an instance from a keyboard event."
	^super new
		charValue: (evt controlKeyPressed ifTrue: [evt keyValue + $a asciiValue - 1] ifFalse: [evt keyValue])
		ctrl: evt controlKeyPressed 
		alt: evt commandKeyPressed;
		yourself.! !

!PrefabKeystroke class methodsFor: 'instance creation' stamp: 'cr 2/18/2002 22:37'!
new
	^super new charValue: $a asciiValue ctrl: false alt: false; yourself! !

!PrefabKeystroke class methodsFor: 'common keystrokes' stamp: 'cr 3/7/2002 21:29'!
cr
	^self basicNew 
		charValue: Character cr asciiValue ctrl: false alt: false! !

!PrefabKeystroke class methodsFor: 'common keystrokes' stamp: 'cr 3/7/2002 21:30'!
enter
	^self basicNew 
		charValue: Character enter asciiValue ctrl: false alt: false! !

!PrefabKeystroke class methodsFor: 'common keystrokes' stamp: 'cr 3/7/2002 21:30'!
escape
	^self basicNew 
		charValue: Character escape asciiValue ctrl: false alt: false! !

!PrefabKeystroke class methodsFor: 'common keystrokes' stamp: 'cr 3/7/2002 21:30'!
lf
	^self basicNew 
		charValue: Character lf asciiValue ctrl: false alt: false! !

!PrefabKeystroke class methodsFor: 'common keystrokes' stamp: 'cr 3/7/2002 21:31'!
newPage
	^self basicNew 
		charValue: Character newPage asciiValue ctrl: false alt: false! !

!PrefabKeystroke class methodsFor: 'common keystrokes' stamp: 'cr 3/7/2002 23:11'!
space
	^self basicNew 
		charValue: Character space asciiValue ctrl: false alt: false! !

!PrefabKeystroke class methodsFor: 'common keystrokes' stamp: 'cr 3/3/2002 22:00'!
tab
	^self basicNew 
		charValue: Character tab asciiValue ctrl: false alt: false! !

!PrefabKeystroke class methodsFor: 'private' stamp: 'cr 3/7/2002 22:37'!
codeFor: string
	"Return the ascii value for the character indicated by 'string', which may be a single character
	 or a symbolic name for a hard-to-type character.  It is the later if and only if length > 1."

	"Initialize the dictionary if necessary."
	CharCodes
		ifNil: [self initialize].

	string size = 1
		ifTrue: [^string first asciiValue].

	^CharCodes at: string asLowercase
		ifAbsent: [^self error: string printString, ' is not a valid character name.'].! !

!PrefabKeystroke class methodsFor: 'private' stamp: 'cr 3/7/2002 22:36'!
nameFor: charVal
	| k |
	"Return a string containing, in order of preference, a symbolic name, a single printable character
	 or the character '\' followed by the digits of charVal.  This is the most readable form for the character-
	 code part of a keystroke with ASCII code 'charVal'."

	"Guarantee initialization."
	CharNames
		ifNil: [self initialize].

	(CharNames includesKey: charVal)
		ifTrue: [^CharNames at: charVal].

	(k := charVal asCharacter) isPrintable
		ifTrue: [^k asString].

	^'\', charVal asString.! !


!PrefabLabel methodsFor: 'initialization' stamp: 'cr 9/22/2001 00:52'!
initialize
	super initialize.
	orientation := #centered.
	font := Prefab defaultLabelFont.

	self text: 'A Label'.! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 1/8/2000 01:47'!
contentOrientation
	"Get position of the displayable within the label.  Options are #left, #right and #center
	 and they determine where (horizontally) the image or text is placed inside the bounds
	 of the label (or button) iff there is extra space."
	^orientation
! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 1/8/2000 01:49'!
contentOrientation: anOrientation
	"Set position of the displayable within the label.  Options are #left, #right and #center
	 and they determine where (horizontally) the image or text is placed inside the bounds
	 of the label (or button) iff there is extra space."

	(#(left right centered) includes: anOrientation)
		ifFalse: [self error: 'invalid orientation: ', orientation printString].

	orientation := anOrientation.
	self layoutChanged.! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 12/10/2001 00:19'!
font
	"Return the name of the current font."
	^self nameForFont: font! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 12/10/2001 00:08'!
font: aFontOrString
	"Set the font to use for any text contents, present or future.  The font may be an actual StrikeFont or a string
	 describing it.  The description format is '<family-name>-<size>'.

	 Note: if I decide to add support for Text labels (rather than just strings), it is not clear yet how 
	 this will affect it."

	font := self fontNamed: aFontOrString.

	(labelMorph isKindOf: StringMorph)
		ifTrue: [self text: self text].! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 12/20/1999 22:43'!
foregroundColor: aColor
	"Set foreground color"
	super foregroundColor: aColor.
	
	(labelMorph isKindOf: StringMorph)
		ifTrue: [labelMorph color: aColor].! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 7/24/1999 19:37'!
idealExtent
	"Return the extent that would best display the contents without clipping or excess
	 empty space."
	
	labelMorphMaxSize ifNil: [^ self borderWidth + 10@10].

	^labelMorphMaxSize + self borderWidth.! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 7/20/2003 21:03'!
image: img
	"Set the label to display the image 'img'.  If img is a symbol, look it up in the
	 image library.  If it's a string, assume it's a filename and try to load it.  If it's
	 a form, just copy it."
	| form |

	imageID := img.
	form := Prefab formFor: img.

	(img isKindOf: Form)
		ifTrue: [imageID := nil].

	form ifNil: [self error: 'Argument must be one of Symbol, String or Form'.].

	self labelMorph: (ClippedImageMorph new form: form).
! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 12/20/1999 22:42'!
text
	"Return the text of the label.  If there is no text (say there's a picture instead), return nil."

	(labelMorph isKindOf: StringMorph)
		ifTrue: [^labelMorph contents].

	^nil.! !

!PrefabLabel methodsFor: 'API' stamp: 'cr 12/10/2001 00:29'!
text: aTextOrString
	"Set the label's contents to 'aTextOrString'."
	self labelMorph: (StringMorph new 
						contents: aTextOrString asString;
						color: self foregroundColor;
						font: font;
						yourself).
	imageID := nil.! !

!PrefabLabel methodsFor: 'attribute-list creation' stamp: 'cr 10/31/1999 14:32'!
labelAttributeConstructor
	"Return an array containing a message name and value that can be used to recreate my
	 text or image part.  If no such thing can be found, return an empty array."

	imageID ifNotNil: [
		^{#image:. imageID}.
	].

	self submorphsDo: [ :s |
		s class = ClippedImageMorph
			ifTrue: [^{#image:. s form}].

		s class = StringMorph
			ifTrue: [^{#text:. s contents}].
	].

	^#().! !

!PrefabLabel methodsFor: 'change reporting' stamp: 'cr 7/17/2003 22:52'!
layoutChanged
	self resizeContents.
	super layoutChanged.
! !

!PrefabLabel methodsFor: 'change reporting' stamp: 'cr 7/17/2003 22:52'!
resizeContents
	labelMorph ifNotNil: [
			labelMorph bounds: self submorphRectangle.
	].
! !

!PrefabLabel methodsFor: 'construction' stamp: 'cr 12/10/2001 00:32'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList, {self labelAttributeConstructor}
		add: {#contentOrientation:. self contentOrientation};
		add: {#font:. self font};
		yourself.! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 3/25/2001 21:26'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set text' target: self action: #setText;
		add: 'Set content orientation' target: self action: #setContentOrientation;
		add: 'Set image from image dictionary' target: self action: #setImage;
		add: 'Set image from file' target: self action: #setImageFile.! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 7/11/1999 21:13'!
setImage
	"Set the label's image."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new label image (as a dictionary entry)'.
	newImage isEmpty
		ifFalse: [self image: newImage asSymbol].
			! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 10/24/1999 20:43'!
setImageFile
	"Set the label's image to the file in the given path."
	| newImage |
	newImage := FillInTheBlank request: 'Enter new image file name'.
	newImage isEmpty
		ifFalse: [self image: newImage].
			! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 1/8/2000 01:51'!
setOrientation
	
	| orientations index |
	orientations := #(left right centered).

	index := (PopUpMenu labels: 'left\right\centered' withCRs)
				startUpWithCaption: 'Pick an orientation'.

	self contentOrientation: (orientations at: index).! !

!PrefabLabel methodsFor: 'menu' stamp: 'cr 7/11/1999 21:12'!
setText
	"Set the label's text."
	| newText |
	newText := FillInTheBlank request: 'Enter new label text'.
	newText isEmpty
		ifFalse: [self text: newText].
			! !

!PrefabLabel methodsFor: 'private' stamp: 'cr 7/4/1999 00:00'!
labelMorph: aMorph
	
	labelMorph ifNotNil: [
		labelMorph delete.
	].

	labelMorph := aMorph.
	labelMorphMaxSize := aMorph extent.
	"labelMorph position: self center - (labelMorph extent // 2)."
	self addMorph: aMorph.! !

!PrefabLabel methodsFor: 'private' stamp: 'cr 7/4/1999 17:39'!
submorphRectangle
	"Return the rectangle containing the label part (i.e. a StringMorph or ClippedImage). This
	must be inside the innerBounds, no bigger than labelMorphMaxSize in either direction and
	positioned according to the value of orientation if possibility.  Currently, only left, right
	and centered are supported."

	| labelRect ib |

	ib := self innerBounds.

	labelRect := Rectangle center: ib center extent: labelMorphMaxSize.
	
	orientation = #left
		ifTrue: [
			labelRect := labelRect translateBy: (ib left - labelRect left) @ 0.
		].

	orientation = #right
		ifTrue: [
			labelRect := labelRect translateBy: (ib right - labelRect right) @ 0.
		].


	"If neither of these is true, we assume orientation #centered, the default."

	"Clip along the horizontal if necessary.  If this happens, we revert to left-justification."
	labelRect width > ib width
		ifTrue: [
			labelRect := Rectangle origin: ib origin x @ labelRect origin y
							extent: (ib width)@labelRect height
		].


	"Now do the vertical."
	labelRect height > ib height
		ifTrue: [
			labelRect := Rectangle origin: labelRect origin x @ (ib origin y)
							extent: (labelRect withHeight: ib height) extent.
		].
	
	
	^labelRect.
! !


!PrefabButton methodsFor: 'initialization' stamp: 'cr 3/7/2002 23:12'!
initialize
	super initialize.

	response := PrefabResponse new.
	self tabKey: Prefab defaultTabbingKey.

	self borderWidth: Prefab defaultButtonBorderWidth.
	self borderColor: #raised.
	clickedIn := false.
	self text: 'A Button'.
	self extent: 103@32.! !

!PrefabButton methodsFor: 'API' stamp: 'cr 12/6/1999 00:21'!
action: aBlockOrSymbol
	"Set the action to 1) a block to evaluate when the button is pressed or 2) a message to send
	 to a specified target."
	response action: aBlockOrSymbol! !

!PrefabButton methodsFor: 'API' stamp: 'cr 11/28/1999 00:56'!
args: anArray
	"Set args to array of arguments to be used as parameters by action."
	response args: anArray! !

!PrefabButton methodsFor: 'API' stamp: 'cr 11/28/1999 02:32'!
target: anObject
	"The object that gets the message when the button is pressed."
	response target: anObject! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 3/7/2002 21:27'!
handlesKeyboard: evt
	^true! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 6/26/1999 23:07'!
handlesMouseDown: evt
	^true.
! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 3/24/2002 01:34'!
keyDown: anEvent

	clickedIn := true.

	"Show the button pressed if this keystroke would activate it on release."
	anEvent asPrefabKeystroke = Prefab defaultButtonActivateKey
		ifTrue: [self actPressed].! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 3/24/2002 01:25'!
keyUp: anEvent
	| ks |
	"Handle a key release.  There are only two cases we care about: the tab, which advances the focus,
	 and the enter key, which invokes the button."

	clickedIn
		ifFalse: [^self].

	ks := anEvent asPrefabKeystroke.

	ks = tabKey
		ifTrue: [
			self actCancelled.
			^self tabToNextFor: anEvent hand
		].

	ks = Prefab defaultButtonActivateKey
		ifFalse: [^self actCancelled].


	self actReleased.! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 3/24/2002 01:34'!
mouseDown: evt

	clickedIn := true.
	self actPressed.! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 3/11/2002 19:18'!
mouseMove: evt
	"If the pointer was moved out of the button's perimeter without the blue button being
	 released, unpress the button without performing the action."

	(self containsPoint: evt cursorPoint)
		ifFalse: [
			self actCancelled.
		].


! !

!PrefabButton methodsFor: 'event handling' stamp: 'cr 3/11/2002 19:26'!
mouseUp: evt
	self actReleased.! !

!PrefabButton methodsFor: 'construction' stamp: 'cr 9/22/2001 01:04'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."

	^super attributeList.! !

!PrefabButton methodsFor: 'private-event handling' stamp: 'cr 3/11/2002 19:17'!
actCancelled
	"Restore the original appearance but don't invoke the response.  This is for the case where the user presses
	 the button but either doesn't release inside it or, in the envent of a keystroke, moves the focus
	 elsewhere before releasing the key."

	clickedIn
		ifFalse: [^self].

	clickedIn := false.
	self showFocus: self hasLogicalFocus.

! !

!PrefabButton methodsFor: 'private-event handling' stamp: 'cr 3/24/2002 01:34'!
actPressed
	"Visually indicate the button is down and set the relevant flags."

	self borderColor: #inset.! !

!PrefabButton methodsFor: 'private-event handling' stamp: 'cr 3/11/2002 19:24'!
actReleased
	"Visually indicate that the button has been released and trigger any associated events."

	clickedIn
		ifFalse: [^self].

	self actCancelled.
	response invoke.! !

!PrefabButton methodsFor: 'focus-system' stamp: 'cr 3/11/2002 19:28'!
keyboardFocusChange: gotIt
	"Focus changed."

	gotIt
		ifFalse: [self actCancelled].

	^super keyboardFocusChange: gotIt.! !

!PrefabButton methodsFor: 'focus' stamp: 'cr 3/6/2002 23:07'!
neverGetsFocus
	^false! !

!PrefabButton methodsFor: 'focus' stamp: 'cr 3/7/2002 23:13'!
showFocus: gotIt
	"Alter self's appearance to indicate that it has or does not have the keyboard focus."

	gotIt
		ifTrue: [self borderColor: self focusColor]
		ifFalse: [self borderColor: #raised].

	
! !


!PrefabLabel class methodsFor: 'parts bin' stamp: 'cr 4/27/2003 07:10'!
descriptionForPartsBin
	^self partName: 'PrefabLabel'
		categories: #('Prefab')
		documentation: 'A text or image label'! !


!PrefabButton class methodsFor: 'parts bin' stamp: 'nk 3/23/2003 18:08'!
descriptionForPartsBin
	^self partName: 'PrefabButton'
		categories: #('Prefab')
		documentation: 'A button'! !


!PrefabListBox methodsFor: 'initialization' stamp: 'cr 4/14/2002 22:23'!
initialize
	super initialize.

	items := OrderedCollection new.
	indices := IdentityDictionary new.
	selection := IdentitySet new.
	disabled := IdentitySet new.
	selectionMode := #single.

	font := Prefab defaultListBoxFont.
	elementHeight := font height + 2.
	"elementHeight := Prefab listBoxElementHeight." "<---wrongo"

	selectColor := Prefab defaultListBoxSelectionColor.
	selectForeground := Prefab defaultListBoxSelectionForeground.

	disabledColor := Prefab defaultListBoxDisabledColor.
	disabledForeground := Prefab defaultListBoxDisabledForeground.

	customForegrounds := IdentityDictionary new.
	customBackgrounds := IdentityDictionary new.

	scrollPosition := 1.
	selectResponse := PrefabResponse new.
	super extent: 175@(15*elementHeight).

	self addMorph: (transform := TransformMorph new
						color: Color transparent;
						bounds: self innerBounds;
						yourself).

	self borderWidth: 2;
		borderColor: #inset.! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 4/15/2002 00:21'!
at: index color: aColorOrNil
	| item |
	"Set the colour for *only* the element at index to 'aColorOrNil'.  This is in effect only
	 when the item at index is enabled and unselected.  If aColorOrNil is nil, revert back 
      to the default."

	item := (items at: index) first.

	aColorOrNil
		ifNil: [
			customBackgrounds removeKey: item ifAbsent: [].
			^self.
		].

	"Change the color if the item isn't already discoloured in some way."
	((selection includes: item) or: [disabled includes: item])
		ifFalse: [item color: aColorOrNil].

	customBackgrounds at: item put: aColorOrNil.
	
! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 5/4/2002 03:49'!
at: index foregroundColor: aColorOrNil
	| item |
	"Set the foreground colour for *only* the element at index to 'aColorOrNil'.  This is in effect only
	 when the item at index is enabled and unselected.  If aColorOrNil is nil, revert back to the default."


	item := (items at: index) first.

	aColorOrNil
		ifNil: [
			customForegrounds removeKey: item first ifAbsent: [].
			^self.
		].

	"Change the color if the item isn't already discoloured in some way."
	((selection includes: item) or: [disabled includes: item])
		ifFalse: [item foregroundColor: aColorOrNil].

	customForegrounds at: item put: aColorOrNil.
	
! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 4/14/2002 21:53'!
clearCustomColors
	"Clear all custom foreground and backgound colours."

	customForegrounds := IdentityDictionary new.
	customBackgrounds := IdentityDictionary new.

	self color: self color.
	self foregroundColor: self foregroundColor.! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 4/15/2002 00:17'!
color: aColor
	"Set background color and update submorphs."

	super color: aColor.
	items
		ifNotNil: [
			items do: [ :i |
				((selection includes: i first) or: [customBackgrounds includes: i first])
					ifFalse: [i first color: aColor].
			]
		].! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 10/10/2001 00:56'!
disabledColor
	^disabledColor! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 10/10/2001 00:57'!
disabledColor: aColor
	"Set background color of disableded elements."
	disabledColor := aColor.
	disabled do: [ :i |
		i color: aColor
	].! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 10/10/2001 00:57'!
disabledForeground
	^disabledForeground! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 10/10/2001 00:58'!
disabledForeground: aColor
	"Set foreground color of disableded elements."
	disabledForeground := aColor.
	disabled do: [ :i |
		i foregroundColor: aColor
	].! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 22:33'!
elementHeight
	^elementHeight! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 9/22/2001 01:36'!
elementHeight: anInteger
	| elem |
	"Set the height of each individual list item.

	WARNING: this may become deprecated as #font: also resizes the element height.
	"

	elementHeight = anInteger
		ifTrue: [^self].

	elementHeight := anInteger.
	
	(1 to: items size) do: [ :n |
		elem := (items at: n) first.
		elem position: elem bounds origin x @ (elementHeight * (n - 1));
			height: elementHeight.
	].
	self updateSlider.! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 1/4/2000 23:20'!
extent: aPoint

	super extent: aPoint.
	transform bounds: self innerBounds.
	self scrollTo: scrollPosition.
	self updateSlider.! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/10/2001 00:21'!
font
	"Return the name of the current font."
	^self nameForFont: font! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/10/2001 00:14'!
font: aFontOrString
	"Set the font and resize the elements to display it correctly."

	font == aFontOrString
		ifTrue: [^self].

	font := self fontNamed: aFontOrString.
	items do: [ :i | i first font: font].
	self elementHeight: font height + 2.! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 4/15/2002 00:18'!
foregroundColor: aColor
	"Set foreground color and update submorphs."

	super foregroundColor: aColor.
	items do: [ :i |
		((selection includes: i first) or: [customForegrounds includes: i])
			ifFalse: [i first foregroundColor: aColor].
	]! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/21/1999 00:40'!
scrollPosition
	"Return position to which the listbox is scrolled."

	^scrollPosition! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 1/4/2000 22:55'!
scrollPosition: index
	"Make 'index' the index of the first visible element."

	index = scrollPosition
		ifTrue: [^self].

	self scrollTo: index.
	scrollPosition := index.
! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 23:04'!
selectColor
	^selectColor! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 23:04'!
selectColor: aColor
	"Set background color of selected elements."
	selectColor := aColor.
	selection do: [ :i |
		i color: aColor
	].! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 22:59'!
selectForeground
	^selectForeground! !

!PrefabListBox methodsFor: 'API-Appearance' stamp: 'cr 12/20/1999 23:01'!
selectForeground: aColor
	"Set foreground color of selected elements."
	selectForeground := aColor.
	selection do: [ :i |
		i foregroundColor: aColor
	].! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 2/8/2000 21:57'!
fractionalPosition
	"Return a number between 0 and 1 indicating the position of the
	 list entries currently displayed relative to the entire list.  A value
	 of 0.0 means the first item is visible and 1.0 means the last item is
	 visible. (If both are visible, the result may be somewhere in between."


	self visibleRatio >= 1
		ifTrue: [^0.0].

	^ (self scrollPosition - 1) asFloat / (items size - self visibleLines)! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 12/29/1999 17:09'!
fractionalPosition: aNumber
	"Set scroll position as a number between 0 and 1 indicating the position of the
	 list entries currently displayed relative to the entire list.  A value
	 of 0.0 means the first item is visible and 1.0 means the last item is
	 visible."

	self scrollPosition: ((aNumber min: 1 max: 0) asFloat 
							* (items size - self visibleLines)) rounded + 1.
	 
! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 1/4/2000 23:37'!
selectionMode
	"Return selection mode. One of #single (only allow one item to be selected at any one time) or
	 #multiple (allow shift+click to select multiple items)."
	^selectionMode.! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 12/20/1999 22:17'!
selectionMode: aSymbol
	"Set selection mode. One of #single (only allow one item to be selected at any one time) or
	 #multiple (allow shift+click to select multiple items)."
	| s |

	"Protect from invalid modes."
	(#(single multiple) includes: aSymbol)
		ifFalse: [self error: 'invalid selection mode, #', aSymbol asString].


	(aSymbol = #single and: [selectionMode = #multiple and: [selection size > 1]])
		ifTrue: [
			s := selection anyOne.
			selection do: [ :i | i ~= s ifTrue: [self deSelectLabel: i]].
			selection := Set with: s.
		].
	selectionMode := aSymbol! !

!PrefabListBox methodsFor: 'API-Selection and Position' stamp: 'cr 1/3/2000 00:38'!
vScrollBar: aPrefabScrollBar	
	"Make aPrefabScrollBar the scrollbar that controls this listbox's vertical
	 scroll position, safely removing the current scrollbar (if there is one).  If
	 aPrefabScrollBar is nil, just remove the current scrollbar."

	vScrollBar ifNotNil: [
		vScrollBar target: nil;
			action: nil.
		vScrollBar := nil.
	].

	vScrollBar := aPrefabScrollBar.

	aPrefabScrollBar ifNotNil: [
		aPrefabScrollBar target: self;
			action: #fractionalPosition:.
		self updateSlider.
	].! !

!PrefabListBox methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 20:43'!
actionClicked: aStringOrBlock
	"Action to perform when an item is selected (or possibly de-selected)."
	selectResponse action: aStringOrBlock.! !

!PrefabListBox methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 20:51'!
argsClicked: anArray
	"Extra args passed on with response."
	selectResponse args: anArray.! !

!PrefabListBox methodsFor: 'API-Actions' stamp: 'cr 2/27/2000 20:43'!
targetClicked: anObject
	"Target for select action."
	selectResponse target: anObject.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 1/3/2000 00:39'!
addLast: aPairOrString
	"Append an item with label identical to value.  Convenience method."
	items addLast: nil.
	self at: items size put: aPairOrString.
	self updateSlider.
	^aPairOrString.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 1/4/2000 23:28'!
at: index
	"Return the pair (Array with label string and associated object) at index."
	| pair |
	pair := items at: index.
	^Array with: pair first text with: pair second.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 4/14/2002 22:12'!
at: index put: pairOrString
	"Put pairOrString at index and update the display to reflect this.  A pair is a two-element
	 Array (or array-like thing) containing a string and another object.  The string is displayed
	 in the list box while the second object is passed on to various hooks and things."
	| pair entry oldItem |

	"Create a pair if pairOrString is a string."
	(pairOrString isKindOf: String)
		ifTrue: [pair := Array with: pairOrString with: pairOrString]
		ifFalse: [pair := pairOrString].
	
	"Remove the old item, if it existed."
	oldItem := items at: index.
	oldItem
		ifNotNil: [
			oldItem first delete.
			indices removeKey: oldItem first.
			customForegrounds removeKey: oldItem ifAbsent: [].
			customBackgrounds removeKey: oldItem ifAbsent: [].
		].

	"Create the row and install it."
	entry := self rowFor: pair first.
	entry position: 0@(index * self elementHeight).
	transform addMorph: entry.

	items at: index put: {entry. pair second}.
	indices at: entry put: index.

	^pairOrString.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 7/18/2003 08:47'!
at: index put: string withTag: tagObject
	"This is here for readability.  It's identical to #at:put: where the second argument is a pair,
	 only the label and tag parts are split across the message arguments."

	^self at: index put: {string. tagObject}.
! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 4/14/2002 21:55'!
removeAll
	"Remove all items."

	items isEmpty
		ifTrue: [^self].

	transform removeAllMorphs.

	"Clear internal representation."
	items := items species new: items size.
	selection := selection species new.
	disabled := disabled species new.
	customForegrounds := customForegrounds species new.
	customBackgrounds := customBackgrounds species new.

	self scrollPosition: 1.

	self updateSlider.
! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 4/14/2002 21:55'!
removeAt: index
	"Remove the indexed item."
	| item removed |

	item := items at: index.
	
	removed := Array with: item first text with: item second.
	
	item first delete.
	items removeAt: index.

	disabled remove: items first ifAbsent: [].
	selection remove: items first ifAbsent: [].

	customForegrounds remove: items first ifAbsent: [].
	customBackgrounds remove: items first ifAbsent: [].
	

	self updateSlider.
			
	^removed.! !

!PrefabListBox methodsFor: 'API-Contents' stamp: 'cr 12/29/1999 15:27'!
size
	"Return the number of elements in the list box."
	^items size! !

!PrefabListBox methodsFor: 'API-Position' stamp: 'cr 9/21/2001 00:33'!
visibleRatio
	| ratio |
	"Return a number between 0 and 1 that indicates what fraction of the contents 
	 can be displayed in the current window."

	"Prevent divide-by-zero or other wierdnesses."
	items size <= 0
		ifTrue: [^1].

	ratio := self visibleLines / items size.
	ratio > 1
		ifTrue: [ratio := 1].

	^ratio! !

!PrefabListBox methodsFor: 'API-Selection' stamp: 'cr 10/10/2001 00:44'!
disableAt: index
	| label |
	"Disable the item at index."

	(index < 0 or: [index > self size])
		ifTrue: [self error: 'index out of range'].

	label := (items at: index) first.
	disabled add: label.
	self markDisabled: label.
	selection remove: label ifAbsent: [].
	! !

!PrefabListBox methodsFor: 'API-Selection' stamp: 'cr 10/10/2001 00:46'!
disabledItems
	"Return a Set containing all disabled items (i.e. the associated values rather than the
	 label text part)."
	^disabled collect: [ :item | (self at: (indices at: item)) second].! !

!PrefabListBox methodsFor: 'API-Selection' stamp: 'cr 10/10/2001 00:44'!
enableAt: index
	| label |
	"Enable (i.e. allow selection of) the item at index."

	(index < 0 or: [index > self size])
		ifTrue: [self error: 'index out of range'].

	label := (items at: index) first.

	disabled remove: label ifAbsent: [^self].

	self deSelectLabel: label.
! !

!PrefabListBox methodsFor: 'API-Selection' stamp: 'cr 9/26/2001 00:50'!
selectedItems
	"Return a Set containing all selected items (i.e. the associated values rather than the
	 label text part)."
	^selection collect: [ :item | (self at: (indices at: item)) second].! !

!PrefabListBox methodsFor: 'construction' stamp: 'cr 12/10/2001 00:23'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		add: {#elementHeight:. self elementHeight};
		add: {#selectColor:. self selectColor};
		add: {#disabledColor:. self disabledColor};
		add: {#selectForeground:. self selectForeground};
		add: {#selectionMode:. self selectionMode};
		add: {#font:. self font};
		yourself.
! !

!PrefabListBox methodsFor: 'event handling' stamp: 'cr 5/4/2002 04:21'!
paneClickedEvent: event onLabel: label
	"Select the clicked label, unselecting others if mode is #single."

	label visible
		ifFalse: [^self].

	"Disabled labels aren't affected."
	(disabled includes: label)
		ifTrue: [^self].

	(selectionMode = #single or: [event shiftPressed not])
		ifTrue: [
			selection do: [ :n | self deSelectLabel: n].
			selection := Set new.
		].

	self selectLabel: label.! !

!PrefabListBox methodsFor: 'misc' stamp: 'cr 1/4/2000 23:47'!
test
	"test method.  fill the listbox with entries."
	1 to: 30 do: [ :x |
		self addLast: {'line #', x printString. x}.
	].! !

!PrefabListBox methodsFor: 'menu' stamp: 'cr 10/10/2001 01:56'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu
		add: 'Set selection background color' target: self 
				selector: #changeColorOfAttribute: argument: #selectColor;
		add: 'Set selection foreground color' target: self 
				selector: #changeColorOfAttribute: argument: #selectForeground;

		add: 'Set disabled background color' target: self 
				selector: #changeColorOfAttribute: argument: #disabledColor;
		add: 'Set disabled foreground color' target: self 
				selector: #changeColorOfAttribute: argument: #disabledForeground;

		addLine;

		add: 'Fill with test entries' target: self selector: #fillWithJunk;
		add: 'Disable some (not saved)' target: self selector: #disableSomeEntries.! !

!PrefabListBox methodsFor: 'menu' stamp: 'cr 10/10/2001 01:55'!
disableSomeEntries
	"Mark every third entry disabled."

	1 to: self size by: 3 do: [ :n | self disableAt: n].
	! !

!PrefabListBox methodsFor: 'menu' stamp: 'cr 5/4/2002 04:17'!
fillWithJunk
	"test method.  fill the listbox with entries."
	self removeAll.
	1 to: 30 do: [ :x |
		self addLast: {'line #', x printString. x}.
	].! !

!PrefabListBox methodsFor: 'menu' stamp: 'cr 5/4/2002 04:56'!
fillWithLotsOfJunk
	"test method.  fill the listbox with many, many entries.  Not used.  This is here to test how
	 well the morph can deal with large numbers of entries.  (Currently, the answer is slowly.)"
	self removeAll.
	1 to: 300000 do: [ :x |
		self addLast: {'line #', x printString. x}.
	].! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 5/4/2002 03:47'!
backgroundFor: item
	"Return the desired background color for item, using either backgroundColor or customBackgrounds."
	[item class = PrefabLabel] assert.	"This is a sign that I need to refactor this class.  *sigh*."
	^ customBackgrounds at: item ifAbsent: [^ self color].! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 4/14/2002 21:59'!
deSelectLabel: label
	"Pvt-Mark label as not being selected (*or* disabled).  Doesn't effect internal selection set."
	label color: (self backgroundFor: label);
		foregroundColor: (self foregroundFor: label).! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 5/4/2002 03:47'!
foregroundFor: item
	"Return the desired foreground color for item, using either foregroundColor or customForegrounds."

	[item class = PrefabLabel] assert.	"This is a sign that I need to refactor this class.  *sigh*."

	^ customForegrounds at: item ifAbsent: [^ self foregroundColor].! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 10/10/2001 00:42'!
markDisabled: pane
	"Color pane disabled.  Doesn't affect internal disabled list."

	pane color: Prefab defaultListBoxDisabledColor;
		foregroundColor: Prefab defaultListBoxDisabledForeground.
! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 9/26/2001 02:30'!
rowFor: aString
	| label |
	"Pvt--return a label for 'aString'"

	label := PrefabLabel new
				text: ' ', aString;
				width: 999999;		"take advantage of the transform's clipping"
				height: elementHeight;
				contentOrientation: #left;
				color: self color;
				foregroundColor: self foregroundColor;
				borderWidth: 0;
				font: font;
				yourself.

	label on: #mouseDown send: #paneClickedEvent:onLabel: to: self.

	^label.! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 1/4/2000 23:07'!
scrollTo: index
	"Pvt--update submorphs to display self scrolled to index."
	transform offset: 0@(index * elementHeight).! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 2/27/2000 21:34'!
selectLabel: aLabel
	"Pvt-Mark 'aLabel' as selected and perform whatever associated events are required."

	aLabel color: selectColor;
		foregroundColor: self selectForeground.
	selection add: aLabel.

	selectResponse invokeWith: (self at: (indices at: aLabel)) second! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 9/21/2001 00:37'!
updateSlider
	"Position and size the slider of the attached vertical scroll bar (if it exists)
	 to reflect the current position and viewable ratio."
	vScrollBar ifNotNil: [
		vScrollBar ratio: self visibleRatio;
			fractionalPositionQuiet: self fractionalPosition;
			stepSize: 1.0/(self size max: 1).	"<-- Prevent division by zero."
	].! !

!PrefabListBox methodsFor: 'private' stamp: 'cr 12/21/1999 00:47'!
visibleLines
	"Return number of lines displayable at current size."
	^self innerBounds height // elementHeight! !


!PrefabListBox class methodsFor: 'parts bin' stamp: 'nk 3/23/2003 18:12'!
descriptionForPartsBin
	^self partName: 'PrefabListBox'
		categories: #('Prefab')
		documentation: 'A list box'! !


!PrefabManager methodsFor: 'initialization' stamp: 'cr 8/11/2003 23:43'!
initialize
	super initialize.

	self privateSetResizer: PrefabResizer new.

	beingResized := false.
	self borderWidth: 0.
	frameColor := Prefab backgroundColor darker.

	forceConstruction := false.
	self focusColor: Prefab defaultFocusColor.

! !

!PrefabManager methodsFor: 'API' stamp: 'cr 11/2/2002 20:54'!
borderType
	"Return the style of the border, one of #inset, #raised or #flush."

	self borderWidth = 0
		ifTrue: [^#flush]
		ifFalse: [^self borderColor].
! !

!PrefabManager methodsFor: 'API' stamp: 'cr 11/2/2002 20:55'!
borderType: aSymbol
	"Set the style of the border to one of #inset, #raised or #flush."
	"Paranoia"
	(#(inset raised flush) includes: aSymbol)
		ifFalse: [self error: 'invalid style, ', aSymbol printString].

	aSymbol = #flush
		ifTrue: [self borderWidth: 0]
		ifFalse: [
			self borderColor: aSymbol.
			self borderWidth: Prefab defaultFrameBorderWidth.
		].
! !

!PrefabManager methodsFor: 'API' stamp: 'cr 9/26/2001 01:33'!
close
	"Close this manager and its owner if necessary.  This will close a Manager in a system window."


	self owner = self world
		ifTrue: [self delete]
		ifFalse: [
			"Experimental: support nested Managers."
			(self owner isKindOf: PrefabManager)
				ifTrue: [owner close]
				ifFalse: [self root delete].
		].

! !

!PrefabManager methodsFor: 'API' stamp: 'cr 11/2/2002 17:01'!
extent: newExtent
	| ne |
	"Set extent to the value closest to newExtent that is still within minSize and maxSize."

	"Ick: If this Manager is embedded in a SystemWindow and gets resized, it first resizes the owner, which
	 results in a call to this method, leading to infinite recursion.  We get around this by using the instance
	 variable 'beingResized' as a flag.  If it's true, it means we're in the middle of resizing the outer
	 window and can ignore this request."
	beingResized
		ifTrue: [^self].

	ne := self closestAllowedTo: newExtent.

	"If we're in a system window, resize it appropriately first."
	(self owner isKindOf: SystemWindow)
		ifTrue: [
			"Set beingResized to true while resizing the wrapper so we don't get an infinite recursion
			 when #extent: gets called by it.  This really should be done differently, but this is easiest
			 for the moment."

			beingResized := true.

			super extent: ne.
			self owner extent: (self owner extentWithClientSized: ne).

			beingResized := false.
		] ifFalse: [
			super extent: ne.
		].! !

!PrefabManager methodsFor: 'API' stamp: 'cr 8/11/2003 23:39'!
frameColor
	"Get the preferred color to use for the borders of any system window which may contain this on."
	^frameColor! !

!PrefabManager methodsFor: 'API' stamp: 'cr 8/11/2003 23:42'!
frameColor: newColor
	"Set the preferred color to use for the borders of any system window which may contain this on.
	 If this Manager is currently contained in such a window, set its color now as well."

	frameColor := newColor.

	(self owner isKindOf: SystemWindow)
		ifTrue: [self owner setWindowColor: frameColor].
! !

!PrefabManager methodsFor: 'API' stamp: 'cr 12/13/2001 01:34'!
isAtomic
	"Get the atomicity of this object.  If atomic is false, outer Managers will be allowed to lookup
	 clients by tag.  If true, this Prefab is treated as an atomic control.

	 All base Managers return false to this."
	^false

! !

!PrefabManager methodsFor: 'API' stamp: 'cr 9/17/2001 02:15'!
openInSystemWindow
	"Put this Manger into a system window.  Return the system window."
	| nm |
	
	"If this Manager is already open (i.e. in a World), close it."
	self world
		ifNotNil: [self delete].

	title isNil
		ifTrue: [self title: self class printString].

	(nm := Prefab managerFrameClass new)
		client: self;
		setLabel: title;
		openInWorld.

	^nm
! !

!PrefabManager methodsFor: 'API' stamp: 'cr 3/26/2000 15:45'!
openInSystemWindowNamed: aString
	"Put this Manger into a system window named with 'aString'.  Return the system window."

	self title: aString.
	^self openInSystemWindow.! !

!PrefabManager methodsFor: 'API' stamp: 'cr 3/26/2000 15:40'!
title: aString
	"Set the title (i.e. the text displayed in the title bar if this gets put in a system window) to
	 'aString'."

	(self owner isKindOf: SystemWindow)
		ifTrue: [self owner setLabel: aString].

	title := aString.
! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 12/1/1999 22:18'!
addClient: aMorph
	"Attempt to add aMorph to the manager's collection of clients.  It is assumed that the
	 morph is correctly positioned relative to the manager.  Raise error on failure."
	self addClient: aMorph onFailure: [self error: 'unable to place ', aMorph printString, ' .'].! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 6/8/2003 23:29'!
addClient: aMorph atRelPosition: aPoint
	"Attempt to add aMorph to the manager's collection of clients at a location indicated by
	 aPoint, which is a point relative to my origin."
	aMorph position: aPoint + self logicalOrigin.
	self addClient: aMorph! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 6/8/2003 23:04'!
addClient: aMorph onFailure: aBlock
	"Attempt to add aMorph to the manager's collection of clients.  It is assumed that the morph
	 is correctly positioned relative to the manager.  Evaluate aBlock on failure."

	"Make aMorph the submorph of the appropriate element, either self or a hollow 
	 Prefab (e.g. a PrefabFrame)."
	(resizer ownerFor: aMorph) addMorph: aMorph.

	"Add aMorph to the resizer's list of managed morphs."
	(resizer hasClient: aMorph)
		ifTrue: [resizer removeClient: aMorph].
	resizer addClient: aMorph.


! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/16/2002 22:19'!
allAtomicClients
	| result |
	"Return a list of all clients, and clients of clients, and clients of clients of clients, etc., which are
	 not Managers."

	result := Set new.

	self clients do: [ :cl |
		((cl isKindOf: PrefabManager) and: [cl isAtomic not])
			ifTrue: [result addAll: cl allAtomicClients]
			ifFalse: [result add: cl].
	].

	^result asArray.! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 12/13/2001 02:56'!
checkTags
	"Ensure that there are no duplicate tags.  If any are found, it is an error."
	^self checkTagsAndDo: [ :dups | self error: 'Duplicate tags found: ', dups printString.].! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 12/14/2001 02:37'!
checkTagsAndDo: aBlock
	| tags dupes |
	"Check this Manager (and all nested client Manager's clients) for duplicated tags and, if any are
	 found, evalueate 'aBlock' with a list of the tags."

	tags := self allClientTags asBag.
	dupes := tags asSet select: [ :t | (tags occurrencesOf: t) > 1].

	dupes isEmpty
		ifFalse: [aBlock value: dupes asArray]! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 12/13/2001 01:45'!
clientWithTag: aSymbol
	| result |
	"Return the first client with tag = aSymbol. or nil on failure."

	aSymbol ifNil: [^nil]. "Paranoia"

	self clients do: [ :client |
		client tag = aSymbol
			ifTrue: [^client].

		"If this client is a manager, search it for the given tag."
		((client isKindOf: PrefabManager) and: [client isAtomic not])
			ifTrue: [
				(result := client clientWithTag: aSymbol)
					ifNotNil: [^result].
			].
		].

	^nil.! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 12/13/2001 01:38'!
clients
	"Return a Collection of this Manager's clients.  Note that the clients of nested Managers are not
	 in the list, although the Manager itself is."
	^resizer clients.! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/23/2000 21:43'!
hasClient: aMorph
	"Test if aMorph is a client.  Note that this tests only if 'aMorph' is referenced by this
	 Manager's Resizer, not if it's a submorph of self.  (It's a rather sloppy invariant that a
	 Prefab is a client if and only if it's a submorph.)"
	^resizer hasClient: aMorph.! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 7/14/2003 22:36'!
minimumBoundsContainingClients
	^resizer clients inject: 1@1 into: [ :max :cl | cl bounds corner max: max]! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 6/2/2002 21:55'!
removeAllClients
	"Remove all clients.  Note that removed clients are then dropped into the World."
	self clients shallowCopy do: [ :cl | self removeClient: cl].! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 6/2/2002 21:54'!
removeClient: aMorph
	"Remove 'aMorph' from the client list and toss it out into the cruel, cold World."
	resizer removeClient: aMorph.
	World addMorph: aMorph.
	! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 2/23/2000 21:32'!
resizer
	"Return the current Resizer."
	^resizer! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 12/9/2001 00:25'!
resizer: aResizer
	"Set the resizer to 'aResizer'.  For the moment, this *must* be done before any clients
	 have been added."

	self privateSetResizer: aResizer.! !

!PrefabManager methodsFor: 'API-client management' stamp: 'cr 6/8/2003 23:41'!
sortedClientList
	"Return a list of clients, sorted in the order they should be created.
	 Usually, this means that hollow morphs are first."
	^ resizer clientsSortedOuterToInner.! !

!PrefabManager methodsFor: 'API-keyboard' stamp: 'cr 2/12/2002 21:07'!
focusColor
	"Get the color to use to indicate that a prefab has the focus."
	^focusColor! !

!PrefabManager methodsFor: 'API-keyboard' stamp: 'cr 2/12/2002 21:07'!
focusColor: aColor
	"Set the color to use to indicate that a prefab has the focus."
	focusColor := aColor! !

!PrefabManager methodsFor: 'API-keyboard' stamp: 'cr 2/18/2002 20:02'!
setDefaultTabOrder
	"Set a new tab order containing all clients.  Order is not guaranteed to be useful."
	self tabOrder setDefaultTabOrder.! !

!PrefabManager methodsFor: 'API-keyboard' stamp: 'cr 4/10/2002 23:56'!
setTabOrder: tabOrderList
	"Set the tabbing order.  tabOrderList is a SequencableCollection of either Prefabs or symbols 
	 corresponding to tag names."

	self tabOrder setTabOrder: tabOrderList.! !

!PrefabManager methodsFor: 'API-keyboard actions' stamp: 'cr 3/4/2002 22:36'!
action: aStringOrBlock onKey: key
	"Set the action to perform on the given keystroke."

	(self responseFor: key) action: aStringOrBlock.
	! !

!PrefabManager methodsFor: 'API-keyboard actions' stamp: 'cr 3/4/2002 22:39'!
args: anArray onKey: key
	"Set the argument(s) to pass to the action associated with the given keystroke."
	(self responseFor: key) args: anArray.	! !

!PrefabManager methodsFor: 'API-keyboard actions' stamp: 'cr 3/6/2002 22:48'!
target: anObject forShortcuts: mapArray
	| stream key message nargs args argStream |
	"Add a bunch of shortcuts to this object targetted at 'anObject'.  The shortcuts are in 'mapArray'
	 which is expected to be an array containing one or more sets of items of the form:

		key		message		arg1 arg2 arg3...

	where 'key' is one of the valid forms for expressing a keystroke, 'message' is the message
	to send when that keystroke is received and the arg1..3 are arguments for the message.  There
	must be exactly as many arguments as expected by 'message'."

	"Example:   (not a valid DoIt)

	bogocalc target: bogocalc forShortcuts: #(
		'1'				button:			1
		'2'				button: 			2
		'3'				button:			3
		'+'				add
		'-'				subtract).
	"	


	stream := ReadStream on: mapArray.

	[stream atEnd]
		whileFalse: [

			"We're a bit more vigilant toward user errors here, since this is likely to get called by
			 Prefab non-hackers and it would be nice to return a meaningful error message."

			key := stream next.	
			(key respondsTo: #asPrefabKeystroke)
				ifFalse: [self error: 'Invalid key value: ''', key printString, ''''].
			key := key asPrefabKeystroke.

			stream atEnd
				ifTrue: [self error: 'Missing binding for key ', key printString.].

			message := stream next.
			(message isKindOf: Symbol)
				ifFalse: [self error: 'Expecting a symbol but got: ''', message printString, ''''].

			args := nil.
			nargs := message numArgs.
			nargs > 0
				ifTrue: [
					argStream := WriteStream on: (Array new: 10).
					nargs timesRepeat: [
						stream atEnd
							ifTrue: [self error: 'Argument missing from shortcut array.'].
						argStream nextPut: stream next.
					].
					args := argStream contents.
				].

			"Set the binding."
			self action: message onKey: key;
				target: anObject onKey: key;
				args: args onKey: key.

	].


! !

!PrefabManager methodsFor: 'API-keyboard actions' stamp: 'cr 3/4/2002 22:38'!
target: anObject onKey: key
	"Set the target of the action associated with key."
	(self responseFor: key) target: anObject.! !

!PrefabManager methodsFor: 'change reporting' stamp: 'cr 3/20/2005 16:26'!
layoutChanged
	
	"PrefabSlicedFrame doesn't use a resizer, so this would cause an error there."
	resizer
		ifNotNil: [
			resizer newSizesDo: [ :morph :parcel | 
				(morph bounds = parcel)		"<---icky hack. this should be fixed elsewhere."
					ifFalse: [morph bounds: parcel].
			]
		].

	^super layoutChanged.
! !

!PrefabManager methodsFor: 'construction' stamp: 'cr 1/8/2000 01:31'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		add: {#minSize:. self minSize};
		add: {#maxSize:. self maxSize};
		yourself.
! !

!PrefabManager methodsFor: 'menu' stamp: 'cr 7/15/2003 22:07'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	self addMoreCustomMenuItems: aCustomMenu.

	"Construction stuff: hidden unless we're the bottom-level manager with construction enabled."
	(self owner isKindOf: PrefabManager)
		ifFalse: [
			aCustomMenu addLine;
				add: (forceConstruction ifTrue: ['Dis'] ifFalse: ['En']), 'able construction mode'
					target: self action: #toggleConstruction.
			
			self isConstruction
				ifTrue: [aCustomMenu add: 'Display construction source'
							target: self action: #displayConstructionMethod].
		].
! !

!PrefabManager methodsFor: 'menu' stamp: 'cr 7/15/2003 22:06'!
addMoreCustomMenuItems: aCustomMenu
	"Adds menu items to 'aCustomMenu'.  This is here so that subclasses can override it instead of
	 #addCustomMenuItems:hand: and so make sure that the construction menu items stay at the
	 bottom."

	aCustomMenu
		add: 'Set border style' target: self action: #setStyle;
		addLine;
		add: 'Set minimum size' target: self action: #setMinSize;
		add: 'Set maximum size' target: self action: #setMaxSize;
		add: 'Fix size to current extent' target: self action: #fixSize;
		add: 'Set fixed size' target: self action: #setFixedSize.

! !

!PrefabManager methodsFor: 'menu' stamp: 'cr 7/9/2002 23:35'!
displayConstructionMethod
	| msg |
	"Create the method and display it in a workspace."

	self clientsInBounds 
		ifFalse: [
			msg := 	'One or more clients currently\',
					'extends outside the bounds of\',
					'its manager(s).  Generated code\',
					'will have to be fixed manually.\',
					'Continue anyway?'.

			(PopUpMenu confirm: msg withCRs)
				ifFalse: [^self].
		].

	(StringHolder new contents: self constructionMethod)
		openLabel: 'Method Source'.
! !

!PrefabManager methodsFor: 'menu' stamp: 'cr 12/9/2001 18:54'!
fixSize
	"Prevent resizing."
	(nil confirm: 'Set both minimum and maximum sizes to current size?')
		ifFalse: [^self].

	self minSize: self extent.
	self maxSize: self extent.! !

!PrefabManager methodsFor: 'menu' stamp: 'cr 12/9/2001 18:47'!
setFixedSize
	"Prompt for a size and set both the minimum and maximum sizes to it."
	| newSize |
	newSize := self class queryPoint: self extent named: 'fixed size'.
	self minSize: newSize.
	self maxSize: newSize.! !

!PrefabManager methodsFor: 'menu' stamp: 'cr 12/9/2001 18:47'!
setMaxSize
	self maxSize: (self class queryPoint: self maxSize named: 'maximum size').! !

!PrefabManager methodsFor: 'menu' stamp: 'cr 12/9/2001 18:47'!
setMinSize
	self minSize: (self class queryPoint: self minSize named: 'minimum size').! !

!PrefabManager methodsFor: 'menu' stamp: 'cr 12/9/2001 19:14'!
toggleConstruction
	"Toggle 'forceConstruction' flag."
	forceConstruction := forceConstruction not.! !

!PrefabManager methodsFor: 'tests' stamp: 'cr 1/5/2002 00:39'!
isConstruction
	"A manager is typically rigged for construction if forceConstruction is true or it's embedded in
	 a manager that's rigged for construction AND it's capable of construction."
	^ forceConstruction
		or: [(self owner isKindOf: PrefabManager)
				and: [self owner isConstruction]]! !

!PrefabManager methodsFor: 'tests' stamp: 'cr 12/14/2001 02:43'!
isContainer
	^self isAtomic not! !

!PrefabManager methodsFor: 'tests' stamp: 'cr 7/8/1999 19:50'!
isResizable
	^self maxSize > self minSize.! !

!PrefabManager methodsFor: 'tests' stamp: 'cr 12/8/2001 22:20'!
needsResizer
	^true
! !

!PrefabManager methodsFor: 'events' stamp: 'cr 3/26/2000 12:14'!
handlesMouseDown: evt
	"Eat mouse-down events if this Manager has a window frame (i.e. it's a proper
	 top-level window."
	^self owner isKindOf: Prefab managerFrameClass.! !

!PrefabManager methodsFor: 'accessing' stamp: 'cr 3/4/2002 22:13'!
shortcuts
	^shortcuts
! !

!PrefabManager methodsFor: 'accessing' stamp: 'cr 2/17/2002 16:13'!
tabOrder
	| mgr |
	"Return the TabOrder associated with this Manager."

	"We initialize this lazily, since embedded Managers use their owners' and most don't need one."

	"If we're not the topmost, return *it's* TabOrder."
	((mgr := self topLevelManager) isNil or: [mgr == self])
		ifFalse: [^self topLevelManager tabOrder].

	"If necessary, create the TabOrder."
	tabOrder
		ifNil: [tabOrder := TabOrder new	manager: self].


	^tabOrder.
	! !

!PrefabManager methodsFor: 'client tags' stamp: 'cr 12/14/2001 02:40'!
allClientTags
	| result |
	"Return a Bag containing the tags of all accessible clients."
	
	result := Bag new.
	self clients do: [ :sm |
		sm tag
			ifNotNil: [result add: sm tag].

		sm isContainer
			ifTrue: [result addAll: sm allClientTags].
	].

	^result.! !

!PrefabManager methodsFor: 'client tags' stamp: 'cr 6/8/2003 23:29'!
logicalOrigin
	^self innerBounds origin.! !

!PrefabManager methodsFor: 'construction--code generation' stamp: 'cr 11/10/2002 00:09'!
clientsInBounds
	| ib stat |
	"Return false if there is a client whose bounds are outside of this manager's bounds."

	ib := self innerBounds.

	"Shrink the extent by one since addClient is a bit fussier.  (This might be masking some other bug, though)."
	"ib := ib origin extent: ib extent - 1 asPoint."

	self clients do: [ :cl |
		(cl isKindOf: PrefabManager)
			ifTrue: [stat := cl clientsInBounds]
			ifFalse: [stat := ib containsRect: cl bounds].

		stat ifFalse: [^false].
	].

	^true.! !

!PrefabManager methodsFor: 'construction--code generation' stamp: 'cr 12/10/2001 00:48'!
constructionMethod	
	"Create and return the source of a method which will recreate this Manager's layout."
	| body rootName names result |
	"Stream containing method body."
	body := WriteStream on: (String new: 100).

	"Tempname of the root window."
	rootName := 'rootManager'.

	"Create tempname set."
	names := TempNameSet new.
	names addSymbol: rootName.	
	
	"Append source to create the root manager."
	body tab; nextPutAll: rootName; cr.
	self makeSourceToBuild: nil fromList: self attributeList on: body.
	body nextPut: $.; cr; cr.

	"Now, generate code to populate the root."
	self makeSourceToPopulatePaneNamed: rootName varNames: names on: body.

	"Finally, assemble the complete method."
	result := WriteStream on: (String new: 100).
	result
		nextPutAll: 'buildOn: aManager'; cr;
		tab; nextPutAll: '"Caution--automatically-generated method."'; cr;
		nextPutAll: names declarationString; cr;
		tab; nextPutAll: rootName; nextPutAll: ' := aManager.'; cr; cr;
		nextPutAll: body contents; cr.

	^ result contents.

	! !

!PrefabManager methodsFor: 'construction--code generation' stamp: 'cr 12/10/2001 01:14'!
makeSourceToBuild: prefab fromList: attrList on: resultStream
	"Generate source code to recreate prefab and write the results to resultStream."
	
	"Add code to create the instance (if desired)."
	prefab
		ifNotNil: [
			resultStream
				nextPutAll: prefab class name;
				nextPutAll: ' new'; cr.
		].

	"Now, add code to set all of the attributes."
	attrList do: [ :attr |
		attr second
			ifNotNil: [
				resultStream tab; tab.
				self writeAttribute: attr on: resultStream.
				resultStream nextPut: $;; cr.
			].
	].

	"Finally, append a 'yourself' to round out the cascade."
	resultStream tab; tab; nextPutAll: 'yourself'.! !

!PrefabManager methodsFor: 'construction--code generation' stamp: 'cr 7/10/2002 12:27'!
makeSourceToPopulatePaneNamed: var varNames: names on: resultStream
	| varName list |
	"Create and return source code which will recreate self's contents."

	list := self sortedClientList.
	list do: [ :m |

		"We use varName as a flag to indicate that we need to recurse over the current object as well as
		 the name of the temp we are using.  For this reason, we need to clear it first."
		varName := nil.
		
		resultStream cr; tab;
			nextPutAll: var;
			nextPutAll: ' addClient: ('.

		"If this item is a manager, store it in a temp. variable."
		((m isKindOf: PrefabManager) and: [m isConstruction])
			ifTrue: [
				varName := names generatedSymbol.
				resultStream
					nextPutAll: varName;
					nextPutAll: ' := '.
			].

		self makeSourceToBuild: m fromList: m attributeList on: resultStream.
		resultStream nextPut: $); cr.

		resultStream tab; tab; nextPutAll: 'atRelPosition: ';
			nextPutAll: (m bounds origin - self innerBounds origin) storeString;
			nextPut: $.;
			cr.

		"If this Prefab is a manager, we need to create its client list as well."
		varName
			ifNotNil: [
				m makeSourceToPopulatePaneNamed: varName varNames: names on: resultStream.
			].

	].
! !

!PrefabManager methodsFor: 'construction--code generation' stamp: 'cr 12/9/2001 19:19'!
writeAttribute: attr on: aWriteStream
	"Write a string of Squeak code to set this attribute on aWriteStream."
	aWriteStream nextPutAll: attr first asString;
		nextPutAll: ' ';
		nextPutAll: attr second storeString.
! !

!PrefabManager methodsFor: 'construction junk' stamp: 'cr 12/9/2001 19:18'!
buildFromList: aCollection indent: depthInt on: aWriteStream
	| last |
	"Append Smalltalk method calls and arguments onto 'aWriteStream'."
	 
	aCollection allButLast do: [ :attr |
		attr second
			ifNotNil: [
				self writeAttribute: attr on: aWriteStream.
				aWriteStream nextPut: $;; cr.
				1 to: depthInt do: [ :x | aWriteStream tab].
			].
	].

	last := aCollection last.
	last second
		ifNotNil: [self writeAttribute: last on: aWriteStream].
! !

!PrefabManager methodsFor: 'construction junk' stamp: 'cr 12/9/2001 19:18'!
buildFromMorphCollection: aCollection on: resultStream
	
	aCollection do: [ :m |
		resultStream cr; tab; 
			nextPutAll: 'aManager addClient: ('; 
			nextPutAll: m class name;
			nextPutAll: ' new'; cr; tab; tab.

		self buildFromList: m attributeList indent: 2 on: resultStream.
		resultStream nextPut: $;; cr; 
			tab; tab; nextPutAll: 'yourself)';	cr.

		resultStream tab; tab; nextPutAll: 'atRelPosition: ';
			nextPutAll: (m bounds origin - self innerBounds origin) storeString;
			nextPut: $.;
			cr.
	].
! !

!PrefabManager methodsFor: 'construction junk' stamp: 'cr 12/9/2001 22:15'!
constructionMethodSourceNamed: methodName
	"Return the source code for a method that will recreate the layout of this manager."
	| result |

	"Sanity check: this should only be called on the root Manager and only if construction
	 is enabled."
	[(self owner isKindOf: PrefabManager) not and: [self isConstruction]] assert.

	result := WriteStream on: (String new: 100).
	
	result nextPutAll: methodName.
	methodName last = $: ifFalse: [result nextPut: $:].

	result nextPutAll: ' aManager'; cr; tab; 
		nextPutAll: '"Caution--automatically-generated method."'; cr; cr; tab;
		nextPutAll: 'aManager'; cr; tab; tab.

	self buildFromList: self attributeList indent: 2 on: result.
	result nextPut: $.; cr.

	self buildFromMorphCollection: self sortedClientList on: result.

	^result contents.
! !

!PrefabManager methodsFor: 'construction junk' stamp: 'cr 12/9/2001 21:45'!
writeConstructionMethodBodyOn: result
	|  rootName names |

	"Tempname of the root window."
	rootName := 'rootManager'.

	"Create tempname set."
	names := TempNameSet new.
	names addSymbol: rootName.	
	
! !

!PrefabManager methodsFor: 'dragging and dropping' stamp: 'cr 12/9/2001 18:01'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add submorphs just by dropping them on this morph."
	
	"Transcript nextPutAll: 'dropping ', aMorph printString; cr; endEntry."

	aMorph bounds: aMorph bounds.
	self addClient: aMorph.
! !

!PrefabManager methodsFor: 'dragging and dropping' stamp: 'cr 12/13/2001 02:19'!
allowSubmorphExtraction


	"Hmmmm.  This doesn't seem to get sent anywhere."
	^ self isConstruction.! !

!PrefabManager methodsFor: 'dragging and dropping' stamp: 'cr 12/13/2001 02:22'!
privateRemoveMorph: aMorph
	"If aMorph is a prefab, notify the resizer of the change."

	(aMorph isPrefab and: [resizer notNil and: [resizer hasClient: aMorph]])
		ifTrue: [resizer removeClient: aMorph].

	super privateRemoveMorph: aMorph.! !

!PrefabManager methodsFor: 'dragging and dropping' stamp: 'cr 4/8/2002 22:45'!
repelsMorph: aMorph event: evt
	^self isConstruction and: [(self wantsDroppedMorph: aMorph event: evt) not].
! !

!PrefabManager methodsFor: 'dragging and dropping' stamp: 'cr 12/9/2001 18:07'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a
	 hand in response to the given event.  This is conditional on isConstruction returning true."

	"Transcript nextPutAll: 'wants ', aMorph innerBounds printString; cr; endEntry."

	^ self isConstruction and: [aMorph isPrefab and: [self innerBounds containsRect: aMorph bounds]].! !

!PrefabManager methodsFor: 'keyboard shortcuts' stamp: 'cr 3/6/2002 22:39'!
checkForShortcut: keyStroke
	"Check if keyStroke is a registered shortcut.  If it is, execute it and return true.  Otherwise, return
	 false."

	(shortcuts notNil and: [shortcuts includesKey: keyStroke])
		ifFalse: [^false].

	(shortcuts at: keyStroke) invoke.

	^true.
	! !

!PrefabManager methodsFor: 'private' stamp: 'cr 6/8/2003 21:43'!
privateSetResizer: aResizer
	"Set the resizer to 'aResizer'.  For the moment, this *must* be done before any clients
	 have been added."

	aResizer window: self.

[
	"If the current resizer (and therefore, this manager) already has clients, we need to
	 transfer them over to the new resizer."
	(resizer notNil and: [resizer clients isEmpty not])
		ifTrue: [
			resizer clients do: [ :c | aResizer addClient: c].
		].
].  "Not sure if this works.  CR."

	resizer := aResizer.
! !

!PrefabManager methodsFor: 'private' stamp: 'cr 3/6/2002 22:49'!
responseFor: keystroke
	| ks |
	"Return the response object associated with 'keystroke', creating it if necesary."
	
	shortcuts
		ifNil: [shortcuts := Dictionary new].

	ks := keystroke asPrefabKeystroke.
	^shortcuts at: ks ifAbsent: [shortcuts at: ks put: PrefabResponse new].
! !


!Calculator methodsFor: 'states' stamp: 'cr 12/1/1999 22:59'!
appendKey: aString

	| origText |
	clearFirst
		ifTrue: [
			origText := ''.
			clearFirst := false
		] ifFalse: [
			origText := display text.
		].
	display text: origText, aString.
! !

!Calculator methodsFor: 'states' stamp: 'cr 12/1/1999 23:00'!
clear
	"Clear the display."
	display text: '0'.
	clearFirst := true.
! !

!Calculator methodsFor: 'states' stamp: 'cr 12/1/1999 22:55'!
clearEntry
	self clear.! !

!Calculator methodsFor: 'states' stamp: 'cr 12/2/1999 00:15'!
eval
	| result |
	clearFirst := true.

	[result := Compiler evaluate: '^ ', display text for: nil notifying: nil logged: false. ] 
		ifError: [ :err :rcvr | result := nil].

	result = nil
		ifTrue: [display text: 'Error!!!!!!']
		ifFalse: [display text: result printString].


! !

!Calculator methodsFor: 'construction' stamp: 'cr 12/3/1999 05:43'!
addSemanticActions
	"Make the buttons do stuff when pushed."
	
	| button |
	
	0 to: 9 do: [ :num |
		button := self clientWithTag: ('b', num storeString) asSymbol.
		button target: self;
			action: #appendKey:;
			args: (Array with: num asString).
	].

	(self clientWithTag: #decimal)
		target: self;
		action: #appendKey:;
		args: (Array with: '.').

	#(clear clearEntry eval) do: [ :key |
		button := self clientWithTag: key.
		button target: self;
			action: key.
	].

	#( + - * /) do: [ :key |
		button := self clientWithTag: key.
		button target: self;
			action: #appendKey:;
			args: (Array with: key asString).
	].! !

!Calculator methodsFor: 'construction' stamp: 'cr 1/8/2000 02:56'!
buildOn: aManager
	"Caution--automatically-generated method."

	aManager
		extent: 218@299;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		minSize: 10@10;
		maxSize: 1073741823@1073741823.

	aManager addClient: (PrefabFrame new
		extent: 178@42;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		yourself)
		atRelPosition: 19@19.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b6;
		text: '6';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 99@159.

	aManager addClient: (PrefabButton new
		extent: 60@40;
		color: (Color r: 1.0 g: 0.194 b: 0.161);
		foregroundColor: Color black;
		tag: #clear;
		text: 'Clear';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 139@79.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #/;
		text: '/';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 159@239.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #-;
		text: '-';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 159@159.

	aManager addClient: (PrefabButton new
		extent: 39@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b4;
		text: '4';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@159.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b2;
		text: '2';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 59@199.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #decimal;
		text: '.';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 59@239.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b5;
		text: '5';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 59@159.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b3;
		text: '3';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 99@199.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b9;
		text: '9';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 99@119.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #*;
		text: '*';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 159@199.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b8;
		text: '8';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 59@119.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #+;
		text: '+';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 159@119.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b0;
		text: '0';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@239.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b1;
		text: '1';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@199.

	aManager addClient: (PrefabButton new
		extent: 39@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #b7;
		text: '7';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@119.

	aManager addClient: (PrefabButton new
		extent: 120@40;
		color: (Color r: 1.0 g: 0.71 b: 0.677);
		foregroundColor: Color black;
		tag: #clearEntry;
		text: 'Clear Entry';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 19@79.

	aManager addClient: (PrefabLabel new
		extent: 167@27;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #display;
		text: '0';
		contentOrientation: #right;
		yourself)
		atRelPosition: 24@29.

	aManager addClient: (PrefabButton new
		extent: 40@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: Color black;
		tag: #eval;
		text: '=';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 99@239.
! !

!Calculator methodsFor: 'initialization' stamp: 'cr 2/26/2000 22:29'!
initialize
	super initialize.

	self resizer: RubberSheetResizer new.

	clearFirst := true.

	self buildOn: self.

	display := self clientWithTag: #display.
	self addSemanticActions.
! !


!EditorFrame methodsFor: 'as yet unclassified' stamp: 'cr 12/11/2001 03:33'!
buildOn: aManager
	"Caution--automatically-generated method."

	aManager
		extent: 633@441;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		minSize:  300@200;
		maxSize: 99999@99999.

	aManager addClient: (PrefabFrame new
		extent: 623@40;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		borderStyle: #raised;
		tag: #buttonBar;
		yourself)
		atRelPosition: 3@3.

	aManager addClient: (PrefabScrollBar new
		extent: 20@386;
		color: (Color r: 0.6 g: 0.6 b: 0.8);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #scroller;
		orientation: #vertical;
		yourself)
		atRelPosition: 607@47.

	aManager addClient: (PrefabButton new
		extent: 63@28;
		color: (Color r: 1.0 g: 0.599 b: 0.599);
		foregroundColor: (Color r: 0.125 g: 0.125 b: 0.125);
		tag: #reverseButton;
		text: 'Reverse';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 80@8.

	aManager addClient: (PrefabEdit new
		extent: 604@388;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #editor;
		yourself)
		atRelPosition: 3@47.

	aManager addClient: (PrefabButton new
		extent: 67@28;
		color: (Color r: 0.0 g: 1.0 b: 0.4);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #clearButton;
		text: 'Clear';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 10@8.

	aManager addClient: (PrefabButton new
		extent: 71@28;
		color: (Color r: 0.4 g: 0.8 b: 1.0);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #fillButton;
		text: 'Fill';
		contentOrientation: #centered;
		yourself)
		atRelPosition: 146@8.
! !

!EditorFrame methodsFor: 'as yet unclassified' stamp: 'cr 2/26/2000 22:44'!
fixEdges
	"Set the resizer to do the right thing when the window is resized."

	self resizer
		fixBottomOf: editor;
		fixRightOf: editor;

		fixLeftOf: scroller;
		fixRightOf: scroller;
		fixBottomOf: scroller;

		fixRightOf: (self clientWithTag: #buttonBar).
	! !

!EditorFrame methodsFor: 'as yet unclassified' stamp: 'cr 2/26/2000 22:33'!
initialize
	| s |
	super initialize.

	self resizer: FixedDistanceResizer new.

	self buildOn: self.

	editor := self clientWithTag: #editor.
	scroller := self clientWithTag: #scroller.

	editor text: ''.

	(self clientWithTag: #clearButton) action: [editor text: ''].
	(self clientWithTag: #reverseButton) action: [editor text: editor text reversed].
	(self clientWithTag: #fillButton) action: [
		s := WriteStream on: (String new: 200).
		s tab.
		200 timesRepeat: [
			s nextPutAll: 'All work and no play make Jack a dull boy.  '.
			(1 to: 8) atRandom = 1
				ifTrue: [s cr; tab].
		].
		editor text: s contents.
		s := nil.		"Save some RAM.  Hey, why not?"
	].
	
	editor vScrollBar: scroller.

	self fixEdges.! !


!PrefabManager class methodsFor: 'parts bin' stamp: 'nk 3/24/2003 08:03'!
descriptionForPartsBin
	^self partName: 'PrefabManager'
		categories: #('Prefab-Managers')
		documentation: 'A manager'! !

!PrefabManager class methodsFor: 'API-instance creation' stamp: 'cr 3/26/2000 15:49'!
newInSystemWindow
	"Create and open a new instance but contained in a system window."
	^self new openInSystemWindow; yourself.! !

!PrefabManager class methodsFor: 'API-instance creation' stamp: 'cr 3/26/2000 15:48'!
newInSystemWindowNamed: aString
	"Create and open a new instance but contained in a system window."
	^self new openInSystemWindowNamed: aString; yourself.
! !


!Calculator class methodsFor: 'instance creation' stamp: 'cr 2/23/2000 22:03'!
newInSystemWindow
	^super newInSystemWindowNamed: 'Cheesy Calculator'.! !


!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 00:47'!
client
	"Client is the single morph--a PrefabManager--that occupies the entire client area."
	^client! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 8/11/2003 23:44'!
client: aPrefabManager
	"Client is the single morph--a PrefabManager--that occupies the entire client area."

	| clientColor |
	clientColor := aPrefabManager color.

	client := aPrefabManager.
	self clientExtent: aPrefabManager extent.
	self addMorph: aPrefabManager frame: (0@0 extent: 1@1).

	"The base class like to change its client's colour for some reason.  Rather than root it out,
	 I just hack it here by setting it back afterwards."
	aPrefabManager color: clientColor.

	self setWindowColor: aPrefabManager frameColor.
! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 21:23'!
clientExtent: newExtent
	"Set extent so that client area has an extent of 'newExtent'."

	self extent: (self extentWithClientSized: newExtent).! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 2/23/2000 22:52'!
clientSizeWithExtent: aPoint
	"Return the extent of the client region if the extent is set to 'aPoint'."

	^aPoint - ((0 @ self labelRect extent y) + (self borderWidth * 2)).
! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 2/23/2000 23:08'!
extent: aPoint
	| pt |
	"Set extent to 'aPoint' unless the client won't be resized to that size."

	pt := aPoint.
	client ifNotNil: [
		pt := self extentWithClientSized: (client closestAllowedTo: (self clientSizeWithExtent: pt)).
	].

	^super extent: pt.! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 21:00'!
extentWithClientSized: clientExtent
	"Return extent of self such that client area has extent 'clientExtent'."

	^clientExtent + (0 @ self labelRect extent y) + (self borderWidth * 2).! !

!PrefabManagerWrapper methodsFor: 'all' stamp: 'cr 1/9/2000 21:27'!
initialExtent
	client
		ifNil: [^super initialExtent].

	^ self extentWithClientSized: client extent.! !


!PrefabMiddleManager methodsFor: 'initialization' stamp: 'cr 11/25/2001 23:51'!
initialize
	super initialize.

	atomic := false.! !

!PrefabMiddleManager methodsFor: 'API' stamp: 'cr 11/25/2001 23:50'!
isAtomic
	"Get the atomicity of this object.  If atomic is false, outer Managers will be allowed to lookup
	 clients by tag.  If true, this Prefab is treated as an atomic control."
	^atomic! !

!PrefabMiddleManager methodsFor: 'API' stamp: 'cr 11/25/2001 23:50'!
isAtomic: aBool
	"Set the atomicity of this object.  If false, outer Managers will be allowed to lookup
	 clients by tag.  If true, this Prefab is treated as an atomic control."
	atomic := aBool.! !

!PrefabMiddleManager methodsFor: 'tests' stamp: 'cr 1/5/2002 00:45'!
isConstruction

	"MiddleManagers construct their own layout (more or less) and so don't allow things to be dropped into
	 them, nor do they need to be populated by the build method."
	^false! !

!PrefabMiddleManager methodsFor: 'tests' stamp: 'cr 11/25/2001 23:51'!
isContainer
	^ atomic not! !


!PrefabMiddleManager class methodsFor: 'parts bin' stamp: 'cr 4/27/2003 07:21'!
xxxxdescriptionForPartsBin    "<--- future is in doubt."
	^self partName: 'MiddleManager'
		categories: #('Prefab-Managers')
		documentation: 'A lightweight manager'! !


!PrefabMorphHolder methodsFor: 'initialization' stamp: 'cr 7/17/2003 21:07'!
initialize
	super initialize.

	clientResizePolicy := #clientIgnored.
! !

!PrefabMorphHolder methodsFor: 'API' stamp: 'cr 7/17/2003 21:19'!
client
	^client
! !

!PrefabMorphHolder methodsFor: 'API' stamp: 'cr 7/17/2003 21:40'!
client: newClient

	client
		ifNotNil: [client delete].

	client := newClient.

	newClient
		ifNotNil: [
			self addMorph: newClient.
			self resizeClient.
		].


! !

!PrefabMorphHolder methodsFor: 'API' stamp: 'cr 7/15/2003 22:31'!
clientResizePolicy
	^clientResizePolicy.
! !

!PrefabMorphHolder methodsFor: 'API' stamp: 'cr 7/17/2003 21:06'!
clientResizePolicy: policyName

	"Supported policies:"	
	[#(
		clientStretched		"Resize the client whenever the Prefab is resized."
		clientIgnored		"Ignore the client's size."
	) includes: policyName] assert.

	clientResizePolicy := policyName.
	self extent: self extent.
! !

!PrefabMorphHolder methodsFor: 'API' stamp: 'cr 7/17/2003 21:24'!
extent: newExtent
	super extent: newExtent.
	client
		ifNotNil: [self resizeClient].
! !

!PrefabMorphHolder methodsFor: 'resize hooks' stamp: 'cr 7/17/2003 21:33'!
resizeClient
	self perform: (#resize, clientResizePolicy capitalized) asSymbol.
! !

!PrefabMorphHolder methodsFor: 'resize hooks' stamp: 'cr 7/17/2003 21:36'!
resizeClientIgnored
	client center: self center.! !

!PrefabMorphHolder methodsFor: 'resize hooks' stamp: 'cr 7/17/2003 21:36'!
resizeClientStretched
	client
		position: self innerBounds origin;
		extent: self innerBounds extent.
! !


!PrefabMorphHolder class methodsFor: 'parts bin' stamp: 'cr 7/17/2003 21:26'!
descriptionForPartsBin
	^self partName: 'PrefabMorphHolder'
		categories: #('Prefab')
		documentation: 'A Prefab wrapper for non-Prefab morphs.'! !


!PrefabRadioButton methodsFor: 'initialization' stamp: 'cr 3/24/2002 01:04'!
initialize
	super initialize.
	switch extent: Prefab radioButtonExtent;
		borderWidth: 1;
		toggleMode: false;
		clickedColor: Prefab radioButtonCheckedColor;
		highlightColor: Prefab radioButtonCheckedColor twiceLighter.

	label text: 'A Radio-Button'.

	"Resize to something reasonable.  Height is fixed so we don't care about it."
	self extent: (label idealExtent x + ((self borderWidth + switch extent x) * 3)) @ 0.
! !

!PrefabRadioButton methodsFor: 'API' stamp: 'cr 7/25/1999 18:13'!
isSelected: aBoolean
	"Set selection.  If set to true, first deselect any other sibling PrefabRadioButtons
	 (i.e. radio buttons that are submorphs of my owner."

	aBoolean ifTrue: [self deselectAllOthers].

	super isSelected: aBoolean.! !

!PrefabRadioButton methodsFor: 'event handling' stamp: 'cr 7/25/1999 18:17'!
clicked
	self isSelected
		ifTrue: [self deselectAllOthers].

	^super clicked.! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 18:13'!
deselectAllOthers
	"Deselect all other PrefabRadioButton submorphs of my owner."

	self owner submorphsDo: [ :morph |
		((morph isKindOf: PrefabRadioButton) and: [morph ~= self])
			ifTrue: [morph isSelected: false].
	].! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 00:08'!
fixedHeight
	^switch bounds height * 3.! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 00:12'!
labelOrigin
	"Return the point to be the origin of the label."
	^(self innerBounds origin + (switch bounds width * 2)) x @ self innerBounds origin y.! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 00:25'!
minimumWidth
	"Return the smallest size to which the button can be sized."
	^switch bounds width * 2.! !

!PrefabRadioButton methodsFor: 'private' stamp: 'cr 7/25/1999 00:11'!
switchPosition
	"Return the position to be occupied by actual button part."
	^self bounds origin + ((switch extent x // 2) @ (switch extent y)).! !


!PrefabRadioButton class methodsFor: 'parts bin' stamp: 'nk 3/23/2003 18:13'!
descriptionForPartsBin
	^self partName: 'PrefabRadioButton'
		categories: #('Prefab')
		documentation: 'A radio button'! !


!PrefabResizer methodsFor: 'initialization' stamp: 'cr 12/13/2001 00:42'!
initialize
	parcels := IdentityDictionary new.

! !

!PrefabResizer methodsFor: 'accessing' stamp: 'cr 7/5/1999 22:52'!
window: aPrefabManager
	window := aPrefabManager.! !

!PrefabResizer methodsFor: 'resize policy' stamp: 'cr 2/23/2000 21:07'!
convertRect: aMorph
	"Return some object based on 'aMorph' that can be used later
	 to resize 'aMorph' as is consistant with the Layout (e.g. a rectangle
	 of aMorph's bounds scaled relative to a 1@1 rectangle.)  The default
	 is simply the bounds relative to the Manager's origin."
	^aMorph bounds translateBy: window innerBounds origin negated.! !

!PrefabResizer methodsFor: 'resize policy' stamp: 'cr 10/21/2001 02:42'!
newSizesDo: aBlock
	"Evaluate aBlock, a two-argument block, over all parcels where arg1 is the morph and
	 arg2 is the parcel.  The parcel must be adjusted to reflect the absolute bounds of the
	 client at this time.

	 Unmanaged morphs (i.e. those whose #needsResizer returns false) do not have aBlock
	 evaluated on them.

	 Default--no resize."
! !

!PrefabResizer methodsFor: 'tests' stamp: 'cr 1/10/2000 23:48'!
hasClient: aMorph
	^parcels includesKey: aMorph! !

!PrefabResizer methodsFor: 'client accessing' stamp: 'cr 7/8/1999 20:05'!
clients
	^parcels keys.! !

!PrefabResizer methodsFor: 'client accessing' stamp: 'cr 6/8/2003 23:41'!
clientsSortedOuterToInner
	| hm max changed testable |
	"Return a list of clients sorted in order of containerness--that is, such that no hollow morph
	 comes after the things its supposed to contain."

	hm := IdentityDictionary new.
	self hollowClients do: [ :x | hm at: x put: 0].
	max := 0.
	changed := true.

	[changed] whileTrue: [
		changed := false.

		testable := (hm keys select: [ :item | (hm at: item) >= max]) asArray.

		testable do: [ :first |
			testable do: [ :second |
				((first == second) not and: [first bounds containsRect: second bounds])
					ifTrue: [
						hm at: second put: max + 1.
						changed := true.
					].
			].
		].

		max := max + 1.
	].

	^(hm keys asSortedCollection: [ :l :r | (hm at: l) < (hm at: r)]) asArray, 
			self nonHollowClients asArray.
	

			
! !

!PrefabResizer methodsFor: 'client accessing' stamp: 'cr 10/21/2001 02:36'!
hollowClients
	"Return a collection of clients with hollow bits."
	^ self clients select: [ :m | m isHollow]! !

!PrefabResizer methodsFor: 'client accessing' stamp: 'cr 10/21/2001 02:36'!
nonHollowClients
	"Return a collection of clients without hollow bits."
	^self clients select: [ :m | m isHollow not]! !

!PrefabResizer methodsFor: 'private' stamp: 'cr 11/26/2001 02:11'!
mustManage: aMorph
	"Determine whether 'aMorph' needs to be resized by me."

	aMorph ownerChain allButFirst do: [ :m |
		m = window
			ifTrue: [^true].

		m isHollow
			ifFalse: [^false].
	].

	^false. "redundant, I think..."! !

!PrefabResizer methodsFor: 'client management' stamp: 'cr 2/23/2000 21:00'!
addClient: aMorph
	"See if the requested parcel (defined by aRectangle) is available for aMorph and if so,
	 allocate it.  Return true on success, false if parcel is not available."

	| iform |
	iform := self convertRect: aMorph.
	parcels at: aMorph put: iform.
! !

!PrefabResizer methodsFor: 'client management' stamp: 'cr 11/26/2001 01:39'!
ownerFor: aMorph
	"Return the morph that should own 'aMorph', a morph that is already registered here.
	 Normally, it's the manager that owns this Resizer but it might also be a hollow morph
	 that contains 'aMorph'."

	| p |
	p := aMorph bounds.

	self hollowClients do: [ :client |
		(client innerBounds containsRect: p)
			ifTrue: [^client].
	].

	^window.! !

!PrefabResizer methodsFor: 'client management' stamp: 'cr 7/9/1999 21:43'!
removeClient: aMorph
	"Remove 'aMorph'."
	parcels removeKey: aMorph.! !


!FixedDistanceResizer methodsFor: 'resize policy' stamp: 'cr 2/26/2000 22:37'!
convertRect: aMorph
	"Return a binding for aRect."
	^PositionalBinding for: aMorph in: window.
	! !

!FixedDistanceResizer methodsFor: 'resize policy' stamp: 'cr 2/24/2000 22:06'!
newSizesDo: aBlock
	"Evaluate aBlock, a two-argument block, over all parcels where arg1 is the morph and
	 arg2 is the new bounds.  This gets called when clients need to be resized."

	parcels associationsDo: [ :assoc |
		aBlock value: assoc key value: assoc value newBounds.
	].
! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 8/11/2003 23:49'!
fixAllButLeftOf: aMorph
	"Fix all edges of 'aMorph' except for the left one."

	self fixTopOf: aMorph;
		fixBottomOf: aMorph;
		fixRightOf: aMorph.
! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 8/11/2003 23:49'!
fixAllButRightOf: aMorph
	"Fix all edges of 'aMorph' except for the right one."

	self fixTopOf: aMorph;
		fixBottomOf: aMorph;
		fixLeftOf: aMorph.
! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 9/25/2001 00:51'!
fixAllOf: aMorph
	"Fix all edges of 'aMorph'."

	self fixTopOf: aMorph;
		fixBottomOf: aMorph;
		fixLeftOf: aMorph;
		fixRightOf: aMorph.

! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 2/24/2000 22:10'!
fixBottomOf: aMorph
	"Fix the bottom edge of aMorph's position relative the the manager's bottom edge."
	(parcels at: aMorph) fixBottom! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 9/25/2001 01:04'!
fixLeftAndRightOf: aMorph
	self fixLeftOf: aMorph;
		fixRightOf: aMorph.! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 2/24/2000 22:11'!
fixLeftOf: aMorph
	"Fix the left edge of aMorph's position relative the the manager's right edge."
	(parcels at: aMorph) fixLeft! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 1/4/2002 23:53'!
fixRightAndBottomOf: aMorph
	"Fix the right and bottom edge of aMorph's position relative the the manager's right edge."
	self fixRightOf: aMorph;
		fixBottomOf: aMorph.! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 2/24/2000 22:11'!
fixRightOf: aMorph
	"Fix the right edge of aMorph's position relative the the manager's right edge."
	(parcels at: aMorph) fixRight! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 9/25/2001 01:04'!
fixTopAndBottomOf: aMorph
	self fixTopOf: aMorph;
		fixBottomOf: aMorph.! !

!FixedDistanceResizer methodsFor: 'API-Edge fixing' stamp: 'cr 2/24/2000 22:11'!
fixTopOf: aMorph
	"Fix the top edge of aMorph's position relative the the manager's bottom edge."
	(parcels at: aMorph) fixTop! !


!PrefabResizer class methodsFor: 'instance creation' stamp: 'cr 7/5/1999 22:35'!
new
	^super new initialize.! !


!PrefabResponse methodsFor: 'accessing' stamp: 'cr 11/24/1999 21:37'!
action: aBlockOrSymbol
	"Set the action to 1) a block to evaluate when the button is pressed or 2) a message to send
	 to either a specified target or the manager's specified target."
	action := aBlockOrSymbol.! !

!PrefabResponse methodsFor: 'accessing' stamp: 'cr 11/24/1999 21:37'!
args: anArray
	"Set args to array of arguments to be used as parameters by action."
	args := anArray.! !

!PrefabResponse methodsFor: 'accessing' stamp: 'cr 11/24/1999 21:38'!
target: anObject
	"The object that gets the message when invoked."
	target := anObject.! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 11/28/1999 00:03'!
invoke
	"Invoke with no extra arguments."
	^self invokeWithArgs: #().
! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 11/28/1999 00:02'!
invokeWith: arg
	"Invoke with one extra argument."
	^self invokeWithArgs: (Array with: arg).
! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 11/28/1999 00:03'!
invokeWith: arg1 with: arg2
	"Invoke with two extra arguments."
	^self invokeWithArgs: (Array with: arg1 with: arg2).
! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 11/28/1999 00:04'!
invokeWith: arg1 with: arg2 with: arg3
	"Invoke with three extra arguments."
	^self invokeWithArgs: (Array with: arg1 with: arg2 with: arg3).
! !

!PrefabResponse methodsFor: 'invocation' stamp: 'cr 7/18/2003 08:38'!
invokeWithArgs: extraArgs
	"Send the message or invoke the block, returning the result or nil."

	| tmpArgs |
	action ifNil: [^nil].			"If no action specified, we're done."

	tmpArgs := self allArgs: extraArgs.
	action class = BlockContext
		ifTrue: [
			action numArgs = tmpArgs size
				ifTrue: [
					^action valueWithArguments: tmpArgs.
				].

			"If arg counts don't match and the block has only one arg., just pass the
			 whole array."
			action numArgs = 1
				ifTrue: [
					^action value: tmpArgs.
				].

			self error: 'Expecting a BlockContext that takes ', tmpArgs size printString, 
						' arguments.'.
		].

	target ifNotNil: [
		action numArgs ~= tmpArgs size
			ifTrue: [^self error: 'Argument count mismatch in response'.].

		^target perform: action withArguments: tmpArgs.
	].

	^nil.
! !

!PrefabResponse methodsFor: 'private' stamp: 'cr 11/24/1999 22:06'!
allArgs: extras
	"Return an array containing all arguments for the current invocation.  This consists
	 of 'args' with 'extras' appended."
	| tmpArgs |

	"Shortcut: no arguments."
	args ifNil: [extras ifNil: [^#()]].

	tmpArgs := args.
	tmpArgs ifNil: [
		tmpArgs := Array new.
	].

	"If no extras, we're done."
	extras ifNil: [^tmpArgs].

	(extras isKindOf: SequenceableCollection)
		ifTrue: [^tmpArgs, extras]
		ifFalse: [^tmpArgs, (Array with: extras)].
! !


!PrefabResponse class methodsFor: 'instance creation' stamp: 'cr 11/28/1999 00:22'!
action: aBlockContext
	^self new
		action: aBlockContext;
		yourself.! !

!PrefabResponse class methodsFor: 'instance creation' stamp: 'cr 11/28/1999 00:21'!
target: anObject action: aSymbol
	^self new
		target: anObject;
		action: aSymbol;
		yourself.! !

!PrefabResponse class methodsFor: 'instance creation' stamp: 'cr 11/28/1999 00:21'!
target: anObject action: aSymbol args: anArray
	^self new
		target: anObject;
		action: aSymbol;
		args: anArray;
		yourself.! !


!PrefabScrollBar methodsFor: 'initialization' stamp: 'cr 5/4/2002 05:15'!
initialize
	super initialize.

	self borderWidth: 1;
		borderColor: Color black.

	fractionalPosition := 0.0.
	ratio := 0.1.
	stepSize := 0.05.
	orientation
		ifNil: [orientation := #vertical].

	response := PrefabResponse new.

	^self initializeMorph.

! !

!PrefabScrollBar methodsFor: 'initialization' stamp: 'cr 2/23/2003 08:33'!
initializeMorph
	"Create the scroll-bar, assuming that orientation has been set."
	| images |

	self color: Prefab scrollbarBackgroundColor;
		borderColor: #inset.

	self isVertical
		ifTrue: [
			self width: Prefab defaultScrollbarWidth;
				height: Prefab defaultScrollbarLength.
		] ifFalse: [
			self width: Prefab defaultScrollbarLength;
				height: Prefab defaultScrollbarWidth.
		].

	images := (self isHorizontal ifTrue: [#(rightArrow leftArrow)] ifFalse: [#(downArrow upArrow)])
		collect: [ :n |
			(Prefab formNamed: n) 
				scaledToSize: (self isVertical ifTrue: [self width] ifFalse: [self height]) asPoint // 2.
		].

	forwardButton := (PrefabButton new
		image: images first;
		target: self;
		action: #stepForward;
		borderWidth: 1;
		yourself).

	backwardButton := (PrefabButton new
		image: images second;
		target: self;
		action: #stepBackward;
		borderWidth: 1;
		yourself).

	self addMorph: forwardButton;
		addMorph: backwardButton.

	self initializeSlider.

! !

!PrefabScrollBar methodsFor: 'initialization' stamp: 'cr 1/8/2000 01:57'!
initializeSlider
	"Create the slider and give it the relevant event handlers."
	slider := RectangleMorph new color: Prefab scrollbarSliderColor.
	self updateSliderBounds.
	sliderShadow := RectangleMorph newBounds: self totalSliderArea
						color: Prefab scrollbarBackgroundColor.

	slider on: #mouseStillDown send: #sliderDragged: to: self.
	slider on: #mouseDown send: #mouseDownInSlider: to: self.
	slider on: #mouseUp send: #mouseUpInSlider: to: self.

	slider setBorderWidth: 1 borderColor: #raised.
	sliderShadow setBorderWidth: 1 borderColor: #inset.

	self addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider.
! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 3/20/2005 16:17'!
extent: newExtent
	| fp |
	"Change extent, preserving slider position."

	"Case 1: the morph is incomplete."
	(slider isNil or: [forwardButton isNil or: [backwardButton isNil]])
		ifTrue: [^super extent: newExtent].

	fp := self fractionalPosition.
	super extent: newExtent.
	self fractionalPositionQuiet: fp.! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 5/4/2002 05:23'!
fractionalPosition
	"Return a number between 0 and 1 indicating where the slider is between the start and
	 end of the scrollbar trough."

	^fractionalPosition! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:24'!
fractionalPosition: fr
	"Set the slider position and trigger any set response as if the slider had
	 been dragged.  Argument is a number between 0 and 1 representing the
	 whole range of the slider's movement."

	self fractionalPositionQuiet: fr.
	response invokeWith: self fractionalPosition.
! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 5/4/2002 05:18'!
fractionalPositionQuiet: fr
	| fraction range |
	"Set the slider position *without* triggering the normal movement action."

	fraction := fr asFloat.
	
	fraction < 0	ifTrue: [fraction := 0.0].
	fraction > 1 ifTrue: [fraction := 1.0].

	range := self isVertical 
		ifTrue: [self usableSliderArea extent y]
		ifFalse: [self usableSliderArea extent x].

	self sliderPosition: (range * fraction) rounded.

	fractionalPosition := fr.	! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/6/2000 00:48'!
orientation
	"Orientation is one of #vertical or #horizontal and determines on which axis this scroll bar lies."
	^orientation! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/6/2000 00:48'!
orientation: aSymbol
	"Orientation is one of #vertical or #horizontal and determines on which axis this scroll bar lies."
	| fp |
	(#(horizontal vertical) includes: aSymbol)
		ifFalse: [self error: 'Orientation must be one of #horizontal or #vertical'].


	orientation = aSymbol
		ifTrue: [^self].

	fp := self fractionalPosition.

	self removeAllMorphs.

	forwardButton := nil.
	backwardButton := nil.
	slider := nil.
	sliderShadow := nil.

	orientation := aSymbol.

	self initializeMorph.

	self fractionalPositionQuiet: fp.
! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:17'!
ratio
	"Ratio of slider length to trough length expressed as a float."
	^ratio! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 7/11/2003 23:21'!
ratio: ratioValue
	"Ratio of slider length to trough length expressed as a float."
	ratio := ratioValue asFloat min: 1.0 max: 0.0001.
	self updateSliderBounds.
! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:23'!
stepSize
	"Amount by which to change the slider position when one of the buttons is pressed.  This
	 is a float indicating how much to add to/subtract from the slider's fractional position."
	^stepSize! !

!PrefabScrollBar methodsFor: 'API' stamp: 'cr 1/5/2000 05:23'!
stepSize: aFloat
	"Amount by which to change the slider position when one of the buttons is pressed.  This
	 is a float indicating how much to add to/subtract from the slider's fractional position."
	stepSize := aFloat.! !

!PrefabScrollBar methodsFor: 'API-actions' stamp: 'cr 12/6/1999 00:21'!
action: aBlockOrSymbol
	"Set the action to 1) a block to evaluate when the slider is moved or 2) a message to send
	 to a specified target."
	response action: aBlockOrSymbol! !

!PrefabScrollBar methodsFor: 'API-actions' stamp: 'cr 12/6/1999 00:21'!
args: anArray
	"Set args to array of arguments to be used as parameters by action."
	response args: anArray! !

!PrefabScrollBar methodsFor: 'API-actions' stamp: 'cr 12/6/1999 00:22'!
target: anObject
	"The object that gets the message when the slider is moved."
	response target: anObject! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/7/2000 01:30'!
advanceScroller
	"Advance the scroll bar by one length in the direction indicated by cnhDirection."
	self fractionalPosition: self fractionalPosition + cnhDirection.! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/8/2000 00:43'!
startScrollingTowardPointer: evt
	"Begin scrolling by moving the slider toward the point in 'evt' which should be in the scrollbar's trough.
	 The slider moves by one length immediately, then delays a bit, after which it moves by a length
	 periodically, as determined by the result of 'self stepTime'.  This method advances the slider immediately
	 on the click, then starts stepping.  Releasing the mouse button should stop stepping."
	| ad sign |
	ad := self activeDimension.
	sign := (evt cursorPoint - slider bounds origin dotProduct: ad) sign.

	cnhDirection := (slider extent dotProduct: ad) asFloat / (self usableSliderArea extent dotProduct: ad) * sign.

	self advanceScroller.

	ignoreSteps := 3.
	self startStepping.
! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/8/2000 00:52'!
step
	"Advance the scroller only if ignoreSteps is zero.  Otherwise, decrement it.
	 This lets us delay for a bit, then scroll at regular intervals."
	(ignoreSteps > 0)
		ifTrue: [
			ignoreSteps := ignoreSteps - 1.
			^self.
		].

	self advanceScroller.! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/8/2000 00:44'!
stepTime
	^200! !

!PrefabScrollBar methodsFor: 'click-and-hold scrolling' stamp: 'cr 1/8/2000 00:58'!
wantsSteps
	"We don't want steps at startup, only while the left button is down."
	^false.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/7/2000 00:43'!
handlesMouseDown: evt
	^true
! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/7/2000 01:25'!
mouseDown: evt
	self startScrollingTowardPointer: evt.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 11/2/1999 00:13'!
mouseDownInSlider: event
	slider color: Color veryVeryLightGray.
	sliderShadow bounds: slider bounds.
	sliderShadow show.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/7/2000 01:24'!
mouseUp: evt
	self stopStepping! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 11/2/1999 00:13'!
mouseUpInSlider: event
	slider color: Color veryLightGray.
	sliderShadow hide.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 3/20/2005 15:41'!
sliderDragged: event
	"Event handler.  Position slider based on mouse location."	
	| p |
	p := event targetPoint adhereTo: self usableSliderArea.

	self moveSliderToPoint: p.
	response invokeWith: self fractionalPosition.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 1/5/2000 05:50'!
stepBackward
	"Backward button pressed."
	self fractionalPosition: self fractionalPosition - stepSize.! !

!PrefabScrollBar methodsFor: 'events' stamp: 'cr 4/14/2002 20:59'!
stepForward
	"Forward button pressed."
	self fractionalPosition: self fractionalPosition + stepSize.! !

!PrefabScrollBar methodsFor: 'change reporting' stamp: 'cr 1/5/2000 05:45'!
layoutChanged
	"Make sure all elements are positioned correctly after a resize."
	
	(forwardButton notNil and: [backwardButton notNil])
		ifTrue: [

			forwardButton extent: self buttonExtent.
			backwardButton extent: self buttonExtent.

			self isVertical
				ifTrue: [
					forwardButton
						position: self innerBounds bottomLeft 
									- (0 @ (forwardButton bounds height)).
					backwardButton 
						position: self innerBounds origin.
				] ifFalse: [		
					forwardButton 
						position: self innerBounds topRight 
							- (backwardButton bounds width @ 0).

					backwardButton
						position: self innerBounds origin.
				].

		].

	slider
		ifNotNil: [
			slider position: (slider bounds origin * self activeDimension) 
							+ (self innerBounds origin * self inactiveDimension);
				extent: self sliderExtent.
		].

	super layoutChanged.! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 11/1/1999 00:55'!
activeDimension
	"Return a point which, when multiplied with another point, zeros the dimension not allowed
	 by the current orientation."

	orientation = #horizontal
		ifTrue: [^1@0]
		ifFalse: [^0@1].
! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 12/9/1999 03:10'!
buttonExtent
	"Return dimensions to assign to the buttons."
	self isVertical
		ifTrue: [^ (self innerBounds width) @ (self innerBounds width // 1.2)]
		ifFalse: [^ (self innerBounds height // 1.2) @ (self innerBounds height)].
! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 11/1/1999 22:40'!
inactiveDimension
	"Return a point which, when multiplied with another point, zeros the dimension allowed
	 by the current orientation."

	orientation = #horizontal
		ifTrue: [^0@1]
		ifFalse: [^1@0].
! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 4/14/2002 21:08'!
sliderExtent
	| sExt |
	"Return the extent of slider based on the result of ratio."

	sExt  := (self totalSliderArea extent * self ratio max: (slider borderWidth + 1) asPoint) rounded.

	^ (sExt * self activeDimension) + (self innerBounds extent * self inactiveDimension)! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 1/5/2000 05:46'!
totalSliderArea
	orientation = #horizontal
		ifTrue: [^backwardButton bounds topRight corner: forwardButton bounds bottomLeft]
		ifFalse: [^backwardButton bounds bottomLeft corner: forwardButton bounds topRight]! !

!PrefabScrollBar methodsFor: 'dimensions' stamp: 'cr 1/5/2000 05:47'!
usableSliderArea
	"Return the rectangle that can contain the forward edge of the slider."
	self isHorizontal
		ifTrue: [
			^backwardButton bounds topRight corner: 
					forwardButton bounds bottomLeft - (slider width @ 0)
		] ifFalse: [
			^backwardButton bounds bottomLeft
				corner: (forwardButton bounds topRight) - (0 @ slider height).
		].! !

!PrefabScrollBar methodsFor: 'construction' stamp: 'cr 7/10/2002 12:39'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^ super attributeList
		addFirst: {#orientation:. self orientation};
		yourself.


	"Orientation has to go first so that it's set before extent.  Otherwise, the scrollbar's dimensions
	 are lost.  Yes, this violates the Prefab ideal that order of settings aren't important.  However,
	 the ideal expected behaviour from a scrollbar when this happens (dimensions are swapped when
	 orientation changes--which it currently doesn't do either) doesn't support this either, so we're reduced
	 to gross hackery either way."


	 ! !

!PrefabScrollBar methodsFor: 'menu' stamp: 'cr 1/8/2000 01:54'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set orientation' target: self action: #setOrientation.! !

!PrefabScrollBar methodsFor: 'menu' stamp: 'cr 1/8/2000 01:53'!
setOrientation
	"Set orientation interactively."
	| orientations index |
	orientations := #(horizontal vertical).

	index := (PopUpMenu labels: 'horizontal\vertical' withCRs)
				startUpWithCaption: 'Pick an orientation'.

	self orientation: (orientations at: index).! !

!PrefabScrollBar methodsFor: 'others' stamp: 'cr 7/10/2003 22:47'!
isHorizontal
	^orientation == #horizontal! !

!PrefabScrollBar methodsFor: 'others' stamp: 'cr 7/10/2003 22:47'!
isVertical	
	^orientation == #vertical! !

!PrefabScrollBar methodsFor: 'private' stamp: 'cr 3/20/2005 16:27'!
moveSliderToPoint: aPoint
	"Position slider at aPoint."	
	| ft |

	self isVertical
		ifTrue: [
			ft := self innerBounds left @ aPoint y.
		] ifFalse: [
			ft := aPoint x @ self innerBounds top.
		].
	slider position: ft.
	self updateFractionalPosition.

! !

!PrefabScrollBar methodsFor: 'private' stamp: 'cr 12/31/1999 00:14'!
sliderPosition: anInteger
	"Position slider based on anInteger."	
	
	| area p |
	area := self usableSliderArea.
	p := (self activeDimension * anInteger) + area origin adhereTo: area.

	self moveSliderToPoint: p
! !

!PrefabScrollBar methodsFor: 'private' stamp: 'cr 5/4/2002 05:22'!
updateFractionalPosition
	| area divisor |
	"Synchronize 'fractionalPosition' to the actual position of the slider."

	self ratio >= 1
		ifTrue: [
			fractionalPosition := 0.0.
			^self.
		].

	area := self usableSliderArea.

	divisor := area extent dotProduct: self activeDimension.
	divisor = 0
		ifTrue: [
			fractionalPosition := 0.0.
			^self.
		].

	fractionalPosition := (self isHorizontal
							ifTrue: [(slider left - area left) asFloat / divisor]
							ifFalse: [(slider top - area top) asFloat / divisor]).! !

!PrefabScrollBar methodsFor: 'private' stamp: 'cr 1/2/2000 15:45'!
updateSliderBounds
	"Configure the slider size to reflect the current state of things."
	slider bounds: (self totalSliderArea origin extent: self sliderExtent).

! !


!PrefabScrollBar class methodsFor: 'parts bin' stamp: 'nk 3/23/2003 18:13'!
descriptionForPartsBin
	^self partName: 'PrefabScrollBar'
		categories: #('Prefab')
		documentation: 'A scrollbar'! !


!PrefabScrollableWrapper methodsFor: 'initialize' stamp: 'cr 9/1/2002 03:59'!
buildAndSetResizer
	"hand-hacked version of generated buildOn:."
	| mainExtent |
	self resizer: FixedDistanceResizer new.

	mainExtent := 400@200.
	self
		extent: mainExtent;
		minSize: 10@10;
		maxSize: 1073741823@1073741823.

	self addClient: (scroller := PrefabScrollBar new
		height: mainExtent y;
		orientation: #vertical;
		yourself)
		atRelPosition: (mainExtent x - scroller width - 1) @ 0.

	self addClient: (payload := self payloadClass new
		extent: mainExtent - (scroller width @ 0);
		yourself)
		atRelPosition: 0@0.

	self resizer
		fixLeftAndRightOf: scroller;
		fixBottomOf: scroller;

		fixRightOf: payload;
		fixBottomOf: payload.

	payload vScrollBar: scroller.! !

!PrefabScrollableWrapper methodsFor: 'initialize' stamp: 'cr 7/9/2002 22:22'!
initialize
	| |
	"hand-hacked version of generated buildOn:."

	super initialize.
	self isAtomic: false.

	self buildAndSetResizer.! !

!PrefabScrollableWrapper methodsFor: 'API' stamp: 'cr 10/3/2004 21:10'!
payload
	^payload! !

!PrefabScrollableWrapper methodsFor: 'API' stamp: 'cr 11/26/2001 01:00'!
payloadTag
	^payload tag! !

!PrefabScrollableWrapper methodsFor: 'API' stamp: 'cr 11/26/2001 01:00'!
payloadTag: aSymbol
	payload tag: aSymbol! !

!PrefabScrollableWrapper methodsFor: 'API' stamp: 'cr 11/26/2001 01:00'!
scrollbarTag
	^scroller tag! !

!PrefabScrollableWrapper methodsFor: 'API' stamp: 'cr 11/26/2001 01:00'!
scrollbarTag: aSymbol
	scroller tag: aSymbol! !

!PrefabScrollableWrapper methodsFor: 'subclass details' stamp: 'cr 11/26/2001 00:57'!
payloadClass
	^self subclassResponsibility! !

!PrefabScrollableWrapper methodsFor: 'construction' stamp: 'cr 11/26/2001 01:05'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely.  All that we care about here are client tags."

	^super attributeList
		add: {#payloadTag:. self payloadTag};
		add: {#scrollbarTag:. self scrollbarTag};
		yourself.
! !


!PrefabEditScrollableWrapper methodsFor: 'as yet unclassified' stamp: 'cr 1/4/2002 23:33'!
payloadClass
	^PrefabEdit
! !


!PrefabListBoxScrollableWrapper methodsFor: 'all' stamp: 'cr 11/26/2001 01:10'!
payloadClass
	^PrefabListBox
! !


!PrefabScrollableWrapper class methodsFor: 'new morph menu' stamp: 'cr 11/26/2001 01:09'!
includeInNewMorphMenu
	"Subclasses should be visible but this class not."
	^self ~= PrefabScrollableWrapper ! !


!PrefabEditScrollableWrapper class methodsFor: 'parts bin' stamp: 'cr 4/27/2003 07:17'!
descriptionForPartsBin
	^self partName: 'EditScroller'
		categories: #('Prefab-Managers')
		documentation: 'An editor with scrollbar'! !


!PrefabListBoxScrollableWrapper class methodsFor: 'as yet unclassified' stamp: 'cr 4/27/2003 07:16'!
descriptionForPartsBin
	^self partName: 'ListBoxScroller'
		categories: #('Prefab-Managers')
		documentation: 'A listbox with scrollbar'! !


!PrefabScrollingManager methodsFor: 'initialization' stamp: 'cr 7/14/2003 19:39'!
initialize
	super initialize.

	self addMorph: (contentTransform := TransformMorph new
						color: Color transparent;
						bounds: self innerBounds;
						yourself).

	self addMorph: (vScrollBar := PrefabScrollBar new
						orientation: #vertical;
						action: #fractionalYPosition: ;
						target: self;
						yourself).

	self addMorph: (hScrollBar := PrefabScrollBar new
						orientation: #horizontal;
						action: #fractionalXPosition: ;
						target: self;
						yourself).

	self extentPadding: Prefab defaultScrollingManagerExtentPadding.

	self resizeSubmorphs.

	resizer window: contentTransform.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/14/2003 19:31'!
addClient: aMorph onFailure: aBlock
	"Attempt to add aMorph to the manager's collection of clients.  It is assumed that the morph
	 is correctly positioned relative to the manager.  Evaluate aBlock on failure."

	aMorph position: (aMorph position - self logicalOrigin) + contentTransform offset.
	super addClient: aMorph onFailure: aBlock.

	self resizeSubmorphs.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 2/27/2005 21:53'!
clientAreaBounds
	| ib |
	ib := self innerBounds.
	^ib origin extent: ib extent - self scrollBarWidth.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 2/23/2005 02:29'!
extent: aPoint
"Transcript nextPutAll: 'extent: ', aPoint printString;  cr; endEntry."
"self halt."
	super extent: aPoint.
	self resizeSubmorphs.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/14/2003 19:35'!
extentPadding
	"The distance by which we want to the logical client area to extend beyond
	 the bounds of the outermost clients."
	^extentPadding! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/14/2003 19:34'!
extentPadding: aPoint
	"The distance by which we want to the logical client area to extend beyond
	 the bounds of the outermost clients."
	
	extentPadding := aPoint.
	self repositionScrollbars.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/14/2003 19:17'!
fractionalPosition: fractionPoint
	contentTransform offset: (self offsetRange * fractionPoint) rounded! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/14/2003 19:18'!
fractionalXPosition: fraction
	self fractionalPosition: fraction @ vScrollBar fractionalPosition.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/14/2003 19:19'!
fractionalYPosition: fraction
	self fractionalPosition: hScrollBar fractionalPosition @ fraction.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/14/2003 22:36'!
logicalClientAreaExtent
	^self minimumBoundsContainingClients + extentPadding

! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 3/20/2005 20:52'!
offset
	^contentTransform offset
! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 6/11/2003 21:20'!
resizer: newResizer
	"Correct behaviour depends on the resizer not changing anything."
	self shouldNotImplement.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/12/2003 23:36'!
scrollBarWidth
	^vScrollBar width! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/12/2003 23:38'!
scrollBarWidth: newWidth
	vScrollBar width: newWidth.
	hScrollBar height: newWidth.
	self resizeSubmorphs.! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 7/12/2003 16:29'!
scrollToShow: point
	"Scroll the contents so that the region at 'point' is as close as possible to the logical center of the
	 visible part of this Manager."

	contentTransform offset: (self extent // -2) + point.
! !

!PrefabScrollingManager methodsFor: 'API' stamp: 'cr 2/28/2005 13:35'!
scrollToShow: clientPoint withThreshold: threshold
	"Scroll the contents so that the region at 'clientPoint' is as close as possible to the logical center of the
	 visible part of this Manager UNLESS it is already within extent*threshold of the center."

	((self clientAreaResizedBy: threshold) containsPoint: clientPoint + self clientToWorldCoordOffset)
		ifFalse: [self scrollToShow: clientPoint]
! !

!PrefabScrollingManager methodsFor: 'tests' stamp: 'cr 6/8/2003 23:27'!
needsResizer
	^false.
! !

!PrefabScrollingManager methodsFor: 'accessing' stamp: 'cr 7/14/2003 19:04'!
clientAreaExtent
	^self innerBounds extent - self scrollBarWidth

! !

!PrefabScrollingManager methodsFor: 'accessing' stamp: 'cr 6/8/2003 23:32'!
logicalOrigin
	^self innerBounds origin - contentTransform offset.
! !

!PrefabScrollingManager methodsFor: 'accessing' stamp: 'cr 7/14/2003 19:09'!
offsetRange
	^ (self logicalClientAreaExtent - self clientAreaExtent) max: 0@0.! !

!PrefabScrollingManager methodsFor: 'geometry' stamp: 'cr 2/28/2005 13:07'!
clientAreaResizedBy: fraction
	^self clientAreaBounds shrunkByFraction: fraction
! !

!PrefabScrollingManager methodsFor: 'geometry' stamp: 'cr 2/28/2005 13:31'!
clientToWorldCoordOffset
	^self bounds origin + self offset negated
! !

!PrefabScrollingManager methodsFor: 'geometry' stamp: 'cr 2/28/2005 13:18'!
normalizedClientAreaResizedBy: fraction
	^(0@0 extent: self clientAreaBounds extent) shrunkByFraction: fraction
! !

!PrefabScrollingManager methodsFor: 'resizing' stamp: 'cr 7/14/2003 19:40'!
adjustScroller: aScroller

	| selfProxy |
	selfProxy := self adjusterOrientedTo: aScroller.

	aScroller adjuster
		position: (selfProxy xOffsetForScroller: aScroller) @ 0 relativeTo: self;
		height: selfProxy height - aScroller adjuster width.

	aScroller ratio:
		(selfProxy yFor: 
			(self innerBounds extent - aScroller adjuster width) / self logicalClientAreaExtent);
		fractionalPosition: aScroller fractionalPosition.
! !

!PrefabScrollingManager methodsFor: 'resizing' stamp: 'cr 7/14/2003 19:34'!
repositionScrollbars
	self adjustScroller: hScrollBar.
	self adjustScroller: vScrollBar.
! !

!PrefabScrollingManager methodsFor: 'resizing' stamp: 'cr 7/14/2003 19:34'!
resizeSubmorphs
	"Rename to layoutChanged once debugged."

	self resizeTransform.
	self repositionScrollbars.! !

!PrefabScrollingManager methodsFor: 'resizing' stamp: 'cr 7/10/2003 22:29'!
resizeTransform
	contentTransform extent: self innerBounds extent - (vScrollBar width @ hScrollBar height).
! !

!PrefabScrollingManager methodsFor: 'construction' stamp: 'cr 7/15/2003 21:50'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		add: {#scrollBarWidth:. self scrollBarWidth};
		add: {#extentPadding:. self extentPadding};
		yourself.
! !

!PrefabScrollingManager methodsFor: 'menu' stamp: 'cr 7/15/2003 22:09'!
addMoreCustomMenuItems: aCustomMenu
	super addMoreCustomMenuItems: aCustomMenu.
	
	aCustomMenu
		addLine;
		add: 'Set scroll-bar width' 	target: self 	action: #setScrollerWidth;
		add: 'Set extent padding' 	target: self	action: #setExtentPadding.

	! !

!PrefabScrollingManager methodsFor: 'menu' stamp: 'cr 7/15/2003 22:26'!
setExtentPadding
	self extentPadding: ((self class queryPoint: self extentPadding named: 'extent padding') max: 0 asPoint).! !

!PrefabScrollingManager methodsFor: 'menu' stamp: 'cr 7/15/2003 22:25'!
setScrollerWidth
	self scrollBarWidth: (self class queryNumber: self scrollBarWidth named: 'scroller width').! !


!PrefabScrollingManager class methodsFor: 'as yet unclassified' stamp: 'cr 7/14/2003 20:45'!
descriptionForPartsBin
	^self partName: 'PrefabScrollableManager'
		categories: #('Prefab-Managers')
		documentation: 'A Manager in which the contents can be scrolled through.'! !


!PrefabSeparator methodsFor: 'initialization' stamp: 'cr 11/4/2002 20:57'!
initialize
	super initialize.

	self borderWidth: Prefab defaultSeparatorThickness.

	self relief: #inset.
	
	orientation := #horizontal.
	adjuster := OrientationAdjuster on: self.

	self extent: self extent.

! !

!PrefabSeparator methodsFor: 'API' stamp: 'cr 11/4/2002 20:57'!
extent: aPoint
	"Set extent, keeping a constant thickness."

	super extent: (adjuster dimensions: aPoint withLogicalWidth: self borderWidth * 2)	! !

!PrefabSeparator methodsFor: 'API' stamp: 'cr 11/4/2002 20:07'!
orientation
	"Orientation is one of #vertical or #horizontal and determines on which axis this scroll bar lies."
	^orientation! !

!PrefabSeparator methodsFor: 'API' stamp: 'cr 11/4/2002 20:57'!
orientation: aSymbol
	"Orientation is one of #vertical or #horizontal and determines on which axis this scroll bar lies."
	| e |
	(#(horizontal vertical) includes: aSymbol)
		ifFalse: [self error: 'Orientation must be one of #horizontal or #vertical'].

	e := adjuster extent.
	orientation := aSymbol.
	self extent: (adjuster maybeTranspose: e).
! !

!PrefabSeparator methodsFor: 'API' stamp: 'cr 3/25/2001 20:43'!
relief
	"Return relief.  Must be one of #raised or #inset."
	^self borderColor.! !

!PrefabSeparator methodsFor: 'API' stamp: 'cr 3/25/2001 20:44'!
relief: aSymbol
	"Set relief.  Must be one of #raised or #inset."
	(#(raised inset) includes: aSymbol)
		ifFalse: [self error: 'relief must be on of #raised or #inset.'].

	self borderColor: aSymbol! !

!PrefabSeparator methodsFor: 'menu' stamp: 'cr 3/25/2001 21:41'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	
	aCustomMenu add: 'Set orientation' target: self action: #setOrientation.
	aCustomMenu add: 'Set relief' target: self action: #setRelief.! !


!PrefabSeparator class methodsFor: 'parts bin' stamp: 'cr 4/27/2003 07:14'!
descriptionForPartsBin
	^self partName: 'PrefabSeparator'
		categories: #('Prefab')
		documentation: 'A separating groove'! !


!PrefabSlicedFrame methodsFor: 'initialization' stamp: 'cr 11/24/2002 21:28'!
initialize

	clientList := SlicedFrameClientList on: self.

	orientation := #vertical.  "Orientation is defined by direction of stacking."
	minSlice := Prefab defaultMinimumSliceSize.
	adjuster := OrientationAdjuster on: self.
	
	super initialize.


! !

!PrefabSlicedFrame methodsFor: 'API-client management' stamp: 'cr 11/12/2002 21:55'!
addClient: client afterIndex: index
	"Add client after the slot pointed to by 'index'.  It is assumed that self is big enough to
	 hold all clients you try to put in it.  If not, Bad (or at least Ugly) Things could happen."

	self addMorph: client.
	clientList addClient: client afterIndex: index.

	self adjustSizes.! !

!PrefabSlicedFrame methodsFor: 'API-client management' stamp: 'cr 11/17/2002 00:35'!
addClient: client onFailure: aBlock
	"Attempt to add aMorph to the manager's collection of clients.  It is assumed that the morph
	 is correctly positioned relative to the manager.  Evaluate aBlock on failure.

	 PrefabSlicedFrame repositions its clients, so the original
	 position is not relevant in this case.

	 Note: aBlock is never evaluated by this method.  This *might* be a bug."

	self addClient: client afterIndex: clientList size.! !

!PrefabSlicedFrame methodsFor: 'API-client management' stamp: 'cr 11/19/2002 20:47'!
clients
	"Return a Collection of this Manager's clients.  Note that the clients of nested Managers are not
	 in the list, although the Manager itself is."
	^clientList clients
! !

!PrefabSlicedFrame methodsFor: 'API-client management' stamp: 'cr 11/22/2002 03:39'!
hasClient: aMorph
	"Test if aMorph is a client.  Note that this tests only if 'aMorph' is referenced by this
	 Manager's Resizer, not if it's a submorph of self.  (It's a rather sloppy invariant that a
	 Prefab is a client if and only if it's a submorph.)"

	^clientList hasClient: aMorph.! !

!PrefabSlicedFrame methodsFor: 'API-client management' stamp: 'cr 11/12/2002 23:24'!
removeClient: client

	client delete.
! !

!PrefabSlicedFrame methodsFor: 'API-client management' stamp: 'cr 11/12/2002 23:24'!
removeClientAt: index
	clientList removeClientAt: index.	! !

!PrefabSlicedFrame methodsFor: 'API-client management' stamp: 'cr 12/9/2001 00:32'!
resizer: aResizer
	"PrefabSlicedPane does its own resizing."
	^self shouldNotImplement.! !

!PrefabSlicedFrame methodsFor: 'API-client management' stamp: 'cr 11/19/2002 20:48'!
sortedClientList
	"Return a list of clients, sorted in the order they should be created.
	 In this case, placeholders are also filtered out.  (I don't know if this is good design and so
	 may change at some point.)"

	^ clientList clients.! !

!PrefabSlicedFrame methodsFor: 'API' stamp: 'cr 11/13/2002 22:40'!
color: aColor
	super color: aColor.

	clientList dividers do: [ :div  | div color: aColor].! !

!PrefabSlicedFrame methodsFor: 'API' stamp: 'cr 2/22/2005 15:39'!
extent: aPoint
	"Call adjustSizes after a resize."
	super extent: aPoint.
	self adjustSizes.! !

!PrefabSlicedFrame methodsFor: 'API' stamp: 'cr 12/14/2001 23:18'!
minSlice
	"Return the minimum size (in the resized direction) of a slice."
	^minSlice
! !

!PrefabSlicedFrame methodsFor: 'API' stamp: 'cr 11/19/2002 20:52'!
minSlice: size
	"Set the minimum size (in the resized direction) of a slice."

	minSlice < size
		ifTrue: [
			clientList clientAdjusters do: [ :cl |
				cl width < size
					ifTrue: [cl width: size]
			].
			self adjustSizes.
		].

	minSlice := size.

	
! !

!PrefabSlicedFrame methodsFor: 'API' stamp: 'cr 11/18/2001 19:57'!
orientation
	"Return orientation."
	^orientation! !

!PrefabSlicedFrame methodsFor: 'API' stamp: 'cr 2/22/2003 14:28'!
orientation: newOrientation
	"Set orientation."

	"If no change, just bail and save us a few uSec of CPU time."
	newOrientation = orientation
		ifTrue: [^self].

	"Keep the value of orientation sane, otherwise the user will drown in debug windows."
	(#(horizontal vertical) includes: newOrientation)
		ifFalse: [self error: 'Orientation must be one of #horizontal or #vertical'].

	clientList clientAdjusters do: [ :clAdj | clAdj extent: clAdj extent transposed].

	orientation := newOrientation.

	clientList dividers do: [ :div | div orientation: newOrientation].
	
	self adjustSizes.
! !

!PrefabSlicedFrame methodsFor: 'API' stamp: 'cr 2/23/2003 07:14'!
sliceProportions
	"Return the proportional sizes of the slices to the elements of sizes.  The result is an
	 array of floats which sum to 1.0 such that each entry represents the height of that
	 parcel as a fraction of the total height.  (By height here, I mean the dimension in
	 which the divider moves when dragged.)  The divider is considered part of the parcel
	 below/left of it for the purpose of this operation."

	| heights sep total |
	heights := clientList clientAdjusters collect: [ :ca |
				(sep := clientList dividerAdjusterForClient: ca client) notNil
					ifTrue: [ca height + sep height]
					ifFalse: [ca height].
				].

	total := heights sum asFloat.

	^ heights collect: [ :h | h / total ].! !

!PrefabSlicedFrame methodsFor: 'API' stamp: 'cr 2/22/2003 15:12'!
sliceProportions: sizes
	| sizeList |
	"Set the proportional sizes of the slices to the elements of sizes.  Sizes is expected to be a
	 SequencableCollection of fractions with one element per slice with a total value of 1.  If
	 the number of elements is one less than the number of slices, the last element is assumed
	 to be the remainder.  If 'sizes' is a single value, it is promoted to a collection first.  That way,
	 sending #sliceSizes: with a single float is a handy shortcut for setting the proportional size of
	 the upper slice of a two-slice manager."

	"Promote to an array if necessary."
	(sizes isKindOf: Number)
		ifTrue: [sizeList := Array with: sizes]
		ifFalse: [sizeList := sizes.].

	"Add a final element if necessary."
	sizeList size = (clientList size - 1)
		ifTrue: [sizeList := sizeList, {1.0 - sizeList sum}].

	"Now, run some checks on the input:"

	"Do the element counts match?"
	sizeList size = clientList size
		ifFalse: [^self error: 'Need one element per slice.'].

	"All all elements positive?"
	sizeList do: [ :elem | elem < 0 ifTrue: [^self error: 'Negative element found.']].

	"Do they sum up to 1.0?"
	(sizeList sum closeTo: 1)
		ifFalse: [^self error: 'Elements of a sizes list must sum up to 1.0.'].


	"Okay, let's do the deed."
	clientList clientAdjusters with: sizeList
		do: [ :adj :sz | clientList atClientAdjuster: adj setHeight: (sz * adjuster height) rounded].

	"...and clean up the resulting mess."
	self adjustSizes.! !

!PrefabSlicedFrame methodsFor: 'accessing' stamp: 'cr 11/13/2002 23:09'!
adjuster
	^adjuster! !

!PrefabSlicedFrame methodsFor: 'dragging/dropping' stamp: 'cr 12/13/2001 02:23'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add submorphs just by dropping them on this morph."
	self isConstruction
		ifTrue: [self addClient: aMorph afterIndex: (self indexForBounds: aMorph bounds)].
! !

!PrefabSlicedFrame methodsFor: 'dragging/dropping' stamp: 'cr 11/12/2002 23:23'!
privateRemoveMorph: aMorph
	"If aMorph is a prefab, things may need to be readjusted.."

	(aMorph isPrefab and: [clients hasClientOrDivider: aMorph])
		ifTrue: [

			"If the item being removed is a slice divider (and it hasn't been taken out of 'clients' first)
			 this is a Bad Thing, presumably an incorrect pick-up.  We handle this by creating a copy
			 of the removed morph and plunking in in place of the one being removed.  

			 (This is probably not a good UI design decision but it gives me a certain amount of childish
			 amusement.)"
			(aMorph isKindOf: SliceDivider)
				ifTrue: [clientList bodysnatchDivider: aMorph]
				ifFalse: [clientList removeClient: aMorph].
		].

	super privateRemoveMorph: aMorph.! !

!PrefabSlicedFrame methodsFor: 'menu' stamp: 'cr 5/7/2002 00:59'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.

	aCustomMenu addLine;
		add: 'Set separator orientation' target: self action: #setOrientation.

	self isConstruction
		ifTrue: [
			aCustomMenu add: 'Insert a placeholder' target: self action: #insertPlaceholder;
				add: 'Remove all placeholders' target: self action: #confirmAndRemovePlaceholders.			
		].! !

!PrefabSlicedFrame methodsFor: 'menu' stamp: 'cr 1/4/2002 03:14'!
confirmAndRemovePlaceholders
	"Prompt for confirmation and, if granted, remove all placeholders."

	(self hasPlaceholders and: [nil confirm: 'Delete all placeholders?'])
		ifTrue: [
			self removeAllPlaceholders
		].



! !

!PrefabSlicedFrame methodsFor: 'menu' stamp: 'cr 11/22/2002 03:40'!
insertPlaceholder
	| labels items choice |
	"Prompt the user for a position and insert a placeholder there."

	labels := WriteStream on: (Array new: 10).
	labels nextPut: 'First'.
	
	1 to: clientList size - 1 do: [ :ndx |
		labels nextPut: 'Between ', ndx printString, ' and ', (ndx + 1) printString.
	].

	clientList isEmpty
		ifFalse: [labels nextPut: 'Last'].
	labels nextPut: 'Cancel'.

	items := labels contents.
	choice := (PopUpMenu labelArray: items lines: {items size - 1})
				startUpWithCaption: 'Where do you want the new placeholder?'.

	"If cancel was selected, quit."
	choice > items size
		ifTrue: [^self].

	self addPlaceholderAt: choice - 1.! !

!PrefabSlicedFrame methodsFor: 'placeholders' stamp: 'cr 1/4/2002 03:09'!
addPlaceholderAt: index
	| ph |
	ph := SlicePlaceholder new.
	self addClient: ph afterIndex: index.! !

!PrefabSlicedFrame methodsFor: 'placeholders' stamp: 'cr 11/19/2002 20:47'!
hasPlaceholders
	^(clientList clients select: [ :cl | cl isKindOf: SlicePlaceholder]) isEmpty not.! !

!PrefabSlicedFrame methodsFor: 'placeholders' stamp: 'cr 11/19/2002 20:48'!
removeAllPlaceholders
	| ph |

	"We create a temporary array first, since it appears that deleting an element from clients
	 while itterating through it breaks things."
	ph := clientList clients select: [ :cl | cl isKindOf: SlicePlaceholder].
	ph do: [ :cl | self removeClient: cl].! !

!PrefabSlicedFrame methodsFor: 'event handling' stamp: 'cr 2/23/2003 06:51'!
divider: aDivider draggedTo: aPoint
	"Shift around 'aDivider' to where it's been dragged (within reason).  aPoint is physical, not logical."
	| ndx relPoint divAdj lowerClientAdj lcCorner |

	ndx :=  clientList indexOfClientForDivider: aDivider.
	relPoint := (adjuster maybeRotate: aPoint - self topLeft)
					adhereTo: (clientList slideRangeOfDivider: aDivider).

	"Adjust the top window and move the slider."
	(clientList clientAdjusterAt: ndx - 1) height: relPoint y.
	(divAdj := clientList adjusterForDivider: aDivider) position: 0 @ relPoint y
														relativeTo: self.

	"The bottom one is a bit more work."
	lowerClientAdj := clientList clientAdjusterAt: ndx.
	lcCorner := lowerClientAdj bottomRight.
	lowerClientAdj
		position: 0 @ (relPoint y + divAdj height) relativeTo: self.
	lowerClientAdj client extent: (lcCorner - lowerClientAdj topLeft) abs.
! !

!PrefabSlicedFrame methodsFor: 'construction' stamp: 'cr 2/23/2003 07:24'!
attributeList
	"Return a collection of pairs of (attributeName: value) that can be used to reconstruct
	 this prefab completely."
	^super attributeList
		addFirst: {#orientation:. self orientation};		"Added to front to make this cleaner."
		yourself.
! !

!PrefabSlicedFrame methodsFor: 'tests' stamp: 'cr 11/25/2001 23:03'!
isContainer
	"PrefabSlicedFrame automatically resizes its submorphs."
	^true.	! !

!PrefabSlicedFrame methodsFor: 'tests' stamp: 'cr 11/25/2001 23:09'!
isHollow
	"This class is not hollow, as it manages its submorphs itself."
	^false! !

!PrefabSlicedFrame methodsFor: 'tests' stamp: 'cr 12/8/2001 22:20'!
needsResizer
	"This class handles resizing all by itself."
	^false
! !

!PrefabSlicedFrame methodsFor: 'private' stamp: 'cr 2/22/2003 14:07'!
adjustSizes
	"Readjust the slices if necessary after a resize or reorient."

	| relativeTop |
	clientList resizeClientsToFit: adjuster height.

	relativeTop := 0.
	clientList clientAndDividerAdjustersInOrder do: [ :adj |

		"Note: width needs to be set *first* because we can't guarantee
		 (due to the adjuster) that it will be where we want it to be afterward."
		adj width: adjuster width;
			position: 0@relativeTop relativeTo: self.

		relativeTop := relativeTop + adj height.
	].	


! !

!PrefabSlicedFrame methodsFor: 'private' stamp: 'cr 11/22/2002 03:41'!
indexForBounds: rect
	"Given a rectangle 'rect' dropped inside my bounds, figure out where in the client
	 list it should go."

	clientList clients withIndexDo: [ :client :index |
		(client bounds containsPoint: rect origin)
			ifTrue: [^index].
	].

	clientList dividers do: [ :div |
		(div bounds containsPoint: rect origin)
			ifTrue: [^ clientList indexOfClientForDivider: div].
	].
		
	"If we get this far, just tack it onto the end.  The user had it coming."
	^clientList size
! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/10/2002 21:44'!
addSeparatorForClientAt: index
	| sep si |
	"Create a separator (if necessary) and place it between the item at 'index' and the thing
	 next to it."

	clients size <= 1
		ifTrue: [^self].

	sep := SliceDivider new
		color: self color;
		orientation: orientation;
		extent: self extent;
		yourself.

	self addMorph: sep.
	

	"The separator goes before the new item UNLESS it's the first."
	index = 1
		ifTrue: [clients add: sep afterIndex: 1]
		ifFalse: [
			si := index.
			si even
				ifTrue: [si := si - 1].

			clients add: sep afterIndex: si
		].
! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/18/2001 22:20'!
adjustForOrientation: aPoint inBox: box paddedBy: padValue
	"Pvt. Return aPoint, rotated around box's center if necessary and adhering to its inside."
	| point |

	point := (orientation = #horizontal
				ifTrue: [aPoint]
				ifFalse: [aPoint rotateBy: #right centerAt: self innerBounds center]).
	^box left @ (point adhereTo: (box insetBy: padValue)) y.
! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 5/7/2002 00:31'!
adjustSizesTo: sizeList
	"Readjust the slices (if necessary) with 'lengths' of clients determined by the elements of sizeList."
	| sizes index edge top ext pos |

	clients isEmpty
		ifFalse: [
			sizes := self fixLengthsOf: sizeList toFit: self lengthDim.

			index := 1.

			orientation = #horizontal
				ifTrue: [
					edge := self innerBounds left.
					top := self innerBounds top.
				] ifFalse: [
					edge := self innerBounds top.
					top := self innerBounds left.
				].

			clients do: [ :client |

				ext := self innerWidthDim @ (sizes at: index).
				pos := edge @ top.
				orientation = #horizontal
					ifFalse: [
						ext := ext transposed.
						pos := pos transposed.
					].

				client extent: ext;
					position: pos.

				top := top + sizes at: index.
				index := index + 1.
			].
	].

! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/19/2002 20:50'!
enlargeClientTo: size
	"Make sure all clients are at least 'size' pixels in size in the resized direction."

	clientList clientAdjusters do: [ :cl |
		cl width < size
			ifTrue: [cl width: size]
	].

! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/8/2001 01:29'!
fakeIndexFor: index
	"Given the index of a non-separator in 'clients', return its count (i.e. the index not counting
	 separators)."
	index = 0
		ifTrue: [^0].
	^(index // 2) + 1.
! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 12/16/2001 20:50'!
fixLengthsOf: lengths toFit: max
	"Pvt. Given an array of numbers (the widths/heights, depending on orientation, of the clients), adjust
	 them so that they reach a total of 'max'.  We start from the bottom/right and compress our way back
	 from there."
	| total index retval newSize |

	total := lengths sum.
	retval := lengths copy.

	"Case 1: we need to grow the bottom item."
	total <= max
		ifTrue: [
			retval at: retval size put: (max - total) + retval last.
			^retval
		].

	"Case 2: we need to shrink things."

	"Work backward from end, shrinking entries until total = max (or we run out of items)."
	index := retval size.
	[index > 0 and: [total > max]]
		whileTrue: [
			(index odd and: [(retval at: index) > minSlice])
				ifTrue: [
					newSize := minSlice max: (retval at: index) - (total - max).
					total := total - (lengths at: index) + newSize.
					retval at: index put: newSize.
				].
			index := index - 1.
		].
		
	^retval.
! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 7/14/2002 20:29'!
getBoxForDivider: index
	"Pvt. Return the rectangle containing the divider at 'index' plus the parcels above and below it.
	 If horizontal, rotate the box to vertical."
	| box |

	box := (clients at: index - 1) topLeft corner: (clients at: index + 1) bottomRight.

	orientation = #horizontal
		ifFalse: [
			^ box rotateBy: #right centerAt: self innerBounds center.
		].

	^box! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 7/14/2002 23:36'!
getMaximumBoxFrom: aRect forDivider: index
	"Return a copy of 'aRect' with the top and bottom borders shrunk to keep its vertical height within a
	 range that keeps it from being shrunk below its minSize."
	| before after topLimit bottomLimit |

	before := clients at: index - 1.
	after := clients at: index + 1.


	"Figure out the extra size limits imposed on us by minSize."
	orientation = #horizontal
		ifTrue: [
			topLimit := before minSize y.
			bottomLimit := after minSize y.
		] ifFalse: [
			topLimit := before minSize x.
			bottomLimit := after minSize x.
		].


	^(aRect withTop: aRect top + topLimit) withBottom: aRect bottom - bottomLimit.

! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 12/14/2001 23:40'!
hasClientSmallerThanMinSlice
	| msg |
	"Return true if a client is smaller than the set minimum."

	clients isEmpty
		ifTrue: [^false].
	
	orientation = #horizontal
		ifTrue: [msg := #height]
		ifFalse: [msg := #width].

	1 to: clients size by: 2
		do: [ :n | ((clients at: n) perform: msg) < minSlice and: [^true]].

	^false! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/18/2001 20:05'!
innerWidthDim
	"Return the size of self's inner bounds in whichever dimension the dividers DO NOT move."
	
	orientation = #horizontal
		ifTrue: [^self innerBounds width]
		ifFalse: [^self innerBounds height].


! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/18/2001 20:03'!
lengthDim
	"Return the size of self's inner bounds in whichever dimension the dividers move."
	
	orientation = #horizontal
		ifTrue: [^self height]
		ifFalse: [^self width].


! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/19/2002 21:20'!
lengthList
	"Return a list of pane 'lengths'--that is, the size of the object in whichever dimension
	 the dividers move."
	
	^clientList clientAdjusters collect: [ :cl | cl width].
! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/12/2002 22:08'!
privateRemoveClientAt: index
	"Remove the named client from the clients list and remove a divider if necessary.  DO NOT remove
	 the client itself as this must be handled by the caller.  Finally, force a layout redo."

	clientList removeClientAt: index.
	self adjustSizes.! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/11/2001 23:36'!
privateRemoveDividerAt: index

	| div |
	div := clients at: index.
	clients := clients copyWithout: div.
	div delete.! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/4/2001 00:44'!
privateRemoveFromClientList: client
	| index |
	(client isKindOf: SliceDivider)
		ifTrue: [^self].

	index := clients indexOf: client.

	clients size > 1
		ifTrue: [
			self privateRemoveDividerAt: (index = clients size ifTrue: [index - 1] ifFalse: [index + 1]).
		].

	clients := clients copyWithout: client! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/11/2001 23:36'!
privateReplaceDividerAt: index
	| div clone |
	"Clone the divider at 'index' and put it there in place of that one.  Should be called from 
	#privateRemoveMorph:."
	
	div := clients at: index.
	clone := SliceDivider new
				orientation: orientation;
				color: div color;
				yourself.
				
	clients at: index put: clone.
	self addMorph: clone.

	self adjustSizes.

	! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/8/2001 00:50'!
realIndexFor: index
	"Index in clients collection for index'th client (separators don't count)."
	index = 0
		ifTrue: [^0].
	^(index * 2) - 1.
! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 10/26/2001 01:15'!
splitBox: box at: dividerPos

	| dtop dbottom |
	dtop := dividerPos - (Prefab sliceDividerWidth / 2) rounded.
	dbottom := dividerPos + (Prefab sliceDividerWidth / 2) rounded.

	^ {box topLeft corner: box right @ (dtop - 1).
		box left @ dtop corner: box right @ dbottom.
		box left @ (dbottom + 1) corner: box bottomRight.}! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 11/18/2001 20:05'!
widthDim
	"Return the size of self's bounds in whichever dimension the dividers DO NOT move."
	
	orientation = #horizontal
		ifTrue: [^self width]
		ifFalse: [^self height].


! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 12/13/2001 02:25'!
xxxaddClient: client
	"Add client to self as a client.  PrefabSlicedFrame repositions its clients so the original
	 position is not relevant in this case."
	self addClient: client afterIndex: (self fakeIndexFor: clients size).! !

!PrefabSlicedFrame methodsFor: 'junk-delete' stamp: 'cr 1/18/2002 00:25'!
xxxwantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a
	 hand in response to the given event."

	^ aMorph isPrefab and: [(self innerBounds containsRect: aMorph bounds)
		and: [self manager isNil or: [self manager isConstruction]]].! !


!PrefabSlicedFrame class methodsFor: 'as yet unclassified' stamp: 'nk 3/24/2003 08:08'!
descriptionForPartsBin
	^self partName: 'SlicedFrame'
		categories: #('Prefab-Managers')
		documentation: 'A sliced frame'! !


!Rectangle methodsFor: 'Prefab-rectangle functions' stamp: 'cr 7/22/2003 22:41'!
bestFitIn: outerRect
	"Return a copy scaled to the largest size that can fit inside aRect without changing aspect ratio."

	self tallness > outerRect tallness
		ifTrue:	[^self heightKeepingShape: outerRect height]
		ifFalse:	[^self widthKeepingShape: outerRect width].
! !

!Rectangle methodsFor: 'Prefab-rectangle functions' stamp: 'cr 7/22/2003 22:48'!
heightKeepingShape: newHeight
	^self  scaleBy: newHeight / self height.
	! !

!Rectangle methodsFor: 'Prefab-rectangle functions' stamp: 'cr 7/19/2003 19:26'!
tallness
	^self height / self width! !

!Rectangle methodsFor: 'Prefab-rectangle functions' stamp: 'cr 7/22/2003 22:44'!
widthKeepingShape: newWidth
	^self scaleBy: newWidth / self width.
	! !


!RubberSheetResizer methodsFor: 'resize policy' stamp: 'cr 6/2/2002 22:27'!
convertRect: aMorph
	"Transform aMorph's bounds to one with coordinates as fractions of the
	 manager's dimensions."
	^(aMorph bounds translateBy: window innerBounds origin negated) scaleBy: 1 / window innerBounds extent.! !

!RubberSheetResizer methodsFor: 'resize policy' stamp: 'cr 7/17/1999 23:09'!
newSizesDo: aBlock
	"Evaluate aBlock, a two-argument block, over all parcels where arg1 is the morph and
	 arg2 is the parcel scaled to fit the current size of the window.  This gets called when
	 clients need to be resized."

	| parcel |
	parcels associationsDo: [ :assoc |
		parcel := (assoc value scaleBy: window innerBounds extent)
					translateBy: window innerBounds origin.
		aBlock value: assoc key value: parcel rounded.
	].
! !


!SliceDivider methodsFor: 'initialization' stamp: 'cr 11/25/2002 01:33'!
initialize
	super initialize.

	adjuster := OrientationAdjuster on: self.

	self borderWidth: 0.
	lineWrapper := OrientationAdjuster on: PrefabSeparator new orientedTo: self.
	knobWrapper := OrientationAdjuster on: (SliceDividerKnob new
												color: self color;
												yourself).

	self addAllMorphs: {lineWrapper client. knobWrapper client}.

	knobWrapper client
		on: #mouseStillDown send: #knobDragged: to: self;
		on: #mouseDown send: #mouseDownInKnob: to: self;
		on: #mouseUp send: #mouseUpInKnob: to: self.

	self orientation: #horizontal.

	"Force extent to meet constraints imposed in #extent:".
	self extent: self extent.

	"Force correct layout."
	self fixLayout.

	! !

!SliceDivider methodsFor: 'accessing' stamp: 'cr 11/9/2002 23:56'!
color: aColor
	lineWrapper 
		ifNotNil: [lineWrapper client color: aColor].

	knobWrapper
		ifNotNil: [knobWrapper client color: aColor].

	super color: aColor.! !

!SliceDivider methodsFor: 'accessing' stamp: 'cr 11/25/2002 01:09'!
extent: aPoint

	super extent: (adjuster dimensions: aPoint withLogicalHeight: Prefab sliceDividerWidth).
! !

!SliceDivider methodsFor: 'accessing' stamp: 'cr 11/4/2002 19:11'!
orientation
	^orientation! !

!SliceDivider methodsFor: 'accessing' stamp: 'cr 2/22/2003 14:29'!
orientation: o
	"Set orientation.  Note that orientation (now) matches the orientation of
	 PrefabSlicedFrame."
	| e |
	e := adjuster extent.

	orientation := o.
	lineWrapper client orientation: adjuster oppositeOrientation.
	knobWrapper client orientation: o.

	self extent: (adjuster maybeTranspose: e).

	"If currently embedded in a PrefabSlicedFrame, adjust to fit."
	(self owner isKindOf: PrefabSlicedFrame)
		ifTrue: [adjuster width: (adjuster widthFor: self owner)].

	self fixLayout.! !

!SliceDivider methodsFor: 'accessing' stamp: 'cr 11/26/2001 00:17'!
tag
	"SliceDividers are supposed to be invisible, so we don't let people set their tags or get a non-nil value back."
	^nil! !

!SliceDivider methodsFor: 'accessing' stamp: 'cr 11/26/2001 00:17'!
tag: aSymbol
	"SliceDividers are supposed to be invisible, so we don't let people set their tags or get a non-nil value back."
! !

!SliceDivider methodsFor: 'private' stamp: 'cr 11/25/2002 01:40'!
fixLayout
	"Rearrange submorphs into a proper layout given the current dimensions.  Usually called by
	 layoutChanged."
	| offset |

	"Adjust the center line."
	offset := Prefab sliceDividerEndPadding @ ((adjuster height - lineWrapper height) // 2).

	lineWrapper
		width: adjuster width - ((3 * Prefab sliceDividerEndPadding) + knobWrapper width);
		position: offset relativeTo: self.

	"Adjust the button."
	knobWrapper
		position: (adjuster width - Prefab sliceDividerEndPadding - knobWrapper width)
					@ ((adjuster height - knobWrapper height) // 2)
		relativeTo: self.

! !

!SliceDivider methodsFor: 'event handling' stamp: 'cr 2/22/2005 15:58'!
knobDragged: evt

[	'X' displayAt: (self translatedToOrigin: evt targetPoint).].


	(self owner isKindOf: PrefabSlicedFrame)
		ifTrue: [self owner divider: self draggedTo: evt targetPoint].
! !

!SliceDivider methodsFor: 'event handling' stamp: 'cr 11/9/2002 22:48'!
mouseDownInKnob: evt
	knobWrapper client borderColor: #inset

! !

!SliceDivider methodsFor: 'event handling' stamp: 'cr 11/9/2002 22:51'!
mouseUpInKnob: evt
	knobWrapper client borderColor: #raised.
! !

!SliceDivider methodsFor: 'layout' stamp: 'cr 11/9/2002 23:35'!
layoutChanged
	
	fullBounds ifNil: [^self].

	self fixLayout.

	^super layoutChanged.
! !

!SliceDivider methodsFor: 'geometry' stamp: 'cr 1/6/2003 23:35'!
translatedToOrigin: evtPoint
	"Return evtPoint translated so that for subsequent calculations, the mouse drag appears to
	 have hit the ACTUAL origin of this divider.  (The hand will have already translated the
	 point to the origin of the knob.).  Input and output coordinates are actual, not logical."


	| absPt |
	absPt := evtPoint - (knobWrapper client topLeft - self topLeft).

	^absPt! !


!SliceDividerKnob methodsFor: 'initialization' stamp: 'cr 11/9/2002 22:57'!
initialize
	super initialize.

	self	borderColor: #raised;
		borderWidth: 1.

	self orientation: #vertical.! !

!SliceDividerKnob methodsFor: 'accessing' stamp: 'cr 11/9/2002 22:46'!
orientation
	^orientation.! !

!SliceDividerKnob methodsFor: 'accessing' stamp: 'cr 11/25/2002 01:17'!
orientation: o

	orientation := o.

	orientation = #vertical
		ifTrue: [self extent: Prefab sliceHandleExtent transposed]
		ifFalse: [self extent: Prefab sliceHandleExtent].

! !


!SlicePlaceholder methodsFor: 'as yet unclassified' stamp: 'cr 1/4/2002 02:46'!
initialize
	super initialize.
	self color: Color yellow;
		text: 'Placeholder';
		font: 'NewYork-24';		"I don't like this one, but I know it's here."
		borderWidth: 0.
		! !


!SlicedFrameClientList methodsFor: 'initialization' stamp: 'cr 11/10/2002 23:57'!
initializeOn: theOwner
	frame := theOwner.
	clients := OrderedCollection new.
	separators := IdentityDictionary new.
			! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 7/10/2003 21:26'!
addClient: client afterIndex: index
	"Add a client into the slot after the one referenced by the index.  0 is a valid index for the front spot."
	
	| separatorTarget sep |
	clients add: client adjusterOrientedToOwner afterIndex: index.

	"If this is the only client, we don't need to add a separator."
	clients size = 1
		ifTrue: [^self].

	"If the new client goes in the front, the separator must be associated with the *second* client.  Otherwise,
	 it belongs to the first."
	index = 0
		ifTrue: [separatorTarget := 2]
		ifFalse: [separatorTarget := index + 1].

	"Add the separator."
	frame addMorph: (sep := self newDivider).
	separators at: (clients at: separatorTarget) client put: sep adjuster.

! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 2/22/2003 15:12'!
atClientAdjuster: clAdj setHeight: height
	"Set the height of the slice occupied by the given client and its separator to height,
	 (or as close as is possible given the current constraints.)"
	|  h |

	h := height - (separators at: clAdj client ifAbsent: [0@0 extent: 0@0]) height.
	clAdj height: (h max: frame minSlice).! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 11/24/2002 22:01'!
atSlice: index setHeight: height
	"Set the height of the slice occupied by the indexed client and its separator are height,
	 (or as close as is possible given the current constraints.)"
	
	self atClientAdjuster: (clients at: index) setHeight: height.! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 11/16/2002 19:24'!
clientAdjusterAt: index
	^clients at: index.! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 11/19/2002 20:49'!
clientAdjusters
	^clients asArray.! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 11/13/2002 22:50'!
clientAt: index
	^(clients at: index) client.! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 11/19/2002 20:46'!
clients
	"Return a (copy of) the non-separator client list."

	^clients collect: [ :wrapper | wrapper client]	.! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 11/12/2002 23:22'!
indexOf: aPrefab
	"Return the index of aPrefab or zero if not found."

	clients withIndexDo: [ :index :wrapper | wrapper == aPrefab ifTrue: [^index]].
	^0.! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 11/12/2002 23:22'!
removeClient: aPrefab
	"Remove the given client."

	self removeClientAt: (self indexOf: aPrefab).! !

!SlicedFrameClientList methodsFor: 'clients' stamp: 'cr 11/13/2002 22:51'!
removeClientAt: index
	"Remove the client at index and any associated separators."
	| cl sep |
	cl := self clientAt: index.

	(sep := separators at: cl ifAbsent: [nil])
		ifNotNil: [
			sep delete.
			separators removeKey: cl.
		].! !

!SlicedFrameClientList methodsFor: 'clients-collection' stamp: 'cr 11/22/2002 03:40'!
isEmpty
	^clients isEmpty! !

!SlicedFrameClientList methodsFor: 'clients-collection' stamp: 'cr 11/13/2002 22:46'!
size
	^clients size! !

!SlicedFrameClientList methodsFor: 'dividers' stamp: 'cr 11/16/2002 19:30'!
adjusterForDivider: aDivider
	"Return the adjuster wrapped around 'aDivider'."

	separators valuesDo: [ :adj |
		adj client == aDivider
			ifTrue: [^adj].
	].

	^nil.! !

!SlicedFrameClientList methodsFor: 'dividers' stamp: 'cr 11/24/2002 23:50'!
bodysnatchDivider: aDivider
	"Replace the entry for 'aDivider' with a duplicate, then place this in the original's
	 slot and make it into a client of the owner.  This is here solely to handle the case
	 where a separator is accidentally ripped out of a PrefabSlicedFrame during construction.
	 I don't want to interfere with the removal because that's deep in the guts of Morphic so 
	 I just painlessly replace it."

	| sep |
	sep := self newDivider.

	separators at: (self clientForDivider: aDivider) put: sep adjuster.
	frame addMorph: sep.! !

!SlicedFrameClientList methodsFor: 'dividers' stamp: 'cr 11/24/2002 22:03'!
clientAdjusterForDivider: aDivider
	"Return the client associated with 'aDivider' or nil if not found.  Probably slow."

	^clients at: (self indexOfClientForDivider: aDivider) ifAbsent: [nil].	! !

!SlicedFrameClientList methodsFor: 'dividers' stamp: 'cr 11/24/2002 22:03'!
clientForDivider: aDivider
	"Return the client associated with 'aDivider' or nil if not found.  Probably slow."

	| cl |
	(cl := self clientAdjusterForDivider: aDivider)
		ifNotNil: [^cl client].
	^nil.! !

!SlicedFrameClientList methodsFor: 'dividers' stamp: 'cr 2/23/2003 07:06'!
dividerAdjusterForClient: client
	"Return the divider owned by the given client or nil if there is none."
	^separators at: client ifAbsent: [^nil].! !

!SlicedFrameClientList methodsFor: 'dividers' stamp: 'cr 2/23/2003 07:06'!
dividerForClient: client
	"Return the divider owned by the given client or nil if there is none."
	^(separators at: client ifAbsent: [^nil]) client.! !

!SlicedFrameClientList methodsFor: 'dividers' stamp: 'cr 11/13/2002 22:40'!
dividers
	"Return a list of dividers.  Order is (currently) undefined."
	^separators values collect: [ :wr | wr client].! !

!SlicedFrameClientList methodsFor: 'dividers' stamp: 'cr 11/25/2002 00:28'!
indexOfClientForDivider: aDivider
	"Return the index of the client associated with 'aDivider' or 0 if not found.  Slow."

	clients withIndexDo: [ :clAdj :index |
		(separators at: clAdj client ifAbsent: [OrientationAdjuster new]) client == aDivider
			ifTrue: [^index].
	].

	^0.
	! !

!SlicedFrameClientList methodsFor: 'clients and dividers' stamp: 'cr 11/24/2002 23:54'!
clientAndDividerAdjustersInOrder
	"Return a list of the adjusters for the clients and dividers in logical left-to-right order."
	| result sep |
	result := WriteStream on: (Array new: self size * 2).

	self clientAdjusters do: [ :adj |
		sep := separators at: adj client ifAbsent: [nil].
		sep
			ifNotNil: [result nextPut: sep].
		result nextPut: adj.
	].

	^result contents		! !

!SlicedFrameClientList methodsFor: 'geometry' stamp: 'cr 11/24/2002 23:46'!
heightList
	"Return a list of pane (logical) heights, including the height of any associated separators."

	^clients collect: [ :cl | cl height + (separators at: cl ifAbsent: [0@0 extent: 0@0]) height].! !

!SlicedFrameClientList methodsFor: 'geometry' stamp: 'cr 11/24/2002 23:51'!
heightListOfAll
	"Return an array of of the heights of all clients and separators in the order in which they appear."
	^self clientAndDividerAdjustersInOrder collect: [ :x | x height].! !

!SlicedFrameClientList methodsFor: 'geometry' stamp: 'cr 11/25/2002 02:15'!
slideRangeOfDivider: aDivider
	"Return the box along whose vertical axis the divider may be dragged."
	| topBox bottomBox ndx box |

	ndx := self indexOfClientForDivider: aDivider.
	topBox := clients at: ndx - 1.
	bottomBox := clients at: ndx.

	"Calculate the box, absolute on the vertical and relative on the horizontal."
	box := 0 @ (topBox top + (topBox minHeight max: frame minSlice))
		corner: frame adjuster width @ (bottomBox bottom - (bottomBox minHeight max: frame minSlice)
											- (self adjusterForDivider: aDivider) height).

	"...and now we shift it down to make it completely relative."
	box := box translateBy: 0 @ frame adjuster top negated.

	^box.! !

!SlicedFrameClientList methodsFor: 'geometry' stamp: 'cr 11/24/2002 23:44'!
totalClientHeight
	"Return the total height of all clients."
	
	| wl |
	wl := self heightListOfAll.
	wl isEmpty
		ifTrue: [^0].

	^wl sum.! !

!SlicedFrameClientList methodsFor: 'client resizing' stamp: 'cr 11/24/2002 23:45'!
resizeClientsToFit: newHeight
	"Adjust clients (right to left) so that total width = newHeight."
	
	| current diff desiredNewHeight |
	current := self totalClientHeight.
	diff := newHeight - current.

	"Working right to left, we attempt to adjust the width of the client so that the cumulative width is the same as
	 'newHeight'.  Since size limitations on clients may keep this from being sufficient, we keep on adjusting until
	 either the entire difference has been absorbed or we run out of clients."
	clients reversed do: [ :client |
		desiredNewHeight := client height + diff.
		client height: (desiredNewHeight max: frame minSlice).

		diff := desiredNewHeight - client height.

		diff = 0
			ifTrue: [^self].
	].! !

!SlicedFrameClientList methodsFor: 'presence tests' stamp: 'cr 11/12/2002 22:06'!
hasClient: aMorph
	"Return true if aMorph is one of the clients herein."

	"Yes, this is order-n.  I could use a Dictionary but I doubt n will ever be big enough to warrent it."
	clients do: [ :wrapper | 
		wrapper client == aMorph
			ifTrue: [^true].
	].

	^false.! !

!SlicedFrameClientList methodsFor: 'presence tests' stamp: 'cr 11/12/2002 22:41'!
hasClientOrDivider: aMorph
	"Return true if aMorph is a client or separator referenced by this object."
	^ (self hasDivider: aMorph) or: [self hasClient: aMorph].! !

!SlicedFrameClientList methodsFor: 'presence tests' stamp: 'cr 11/12/2002 23:06'!
hasDivider: aDivider
	"Return true if aDivider is one of the slice dividers held by self."
	
	^ (self clientForDivider: aDivider) notNil.! !

!SlicedFrameClientList methodsFor: 'private' stamp: 'cr 11/25/2002 01:48'!
newDivider
	"Create a new separator on self."
	
	^ SliceDivider new
			color: frame color;
			orientation: frame orientation;
			extent: frame extent;
			yourself.! !


!SlicedFrameClientList class methodsFor: 'instance creation' stamp: 'cr 11/10/2002 23:51'!
on: aPrefabSlicedFrame
	^self basicNew initializeOn: aPrefabSlicedFrame.! !


!String methodsFor: 'Prefab-converting' stamp: 'cr 3/3/2002 21:38'!
asPrefabKeystroke
	"Assuming self is a valid keystroke description string, return that PrefabKeystroke."
	^PrefabKeystroke fromDescriptionString: self.! !


!StringMorph methodsFor: 'Prefab-contents size' stamp: 'cr 7/20/2003 17:13'!
contentsNarrowerThan: desiredWidth

	| total count |
	total := 0.
	count := 0.

	self contents do: [ :thisChar |
		(total + (self font widthOf: thisChar)) > desiredWidth
			ifTrue: [^self contents copyFrom: 1 to: count+1].

		total := total + (self font widthOf: thisChar).
		count := count + 1.
	].

	^self contents.! !

!StringMorph methodsFor: 'Prefab-contents size' stamp: 'cr 7/21/2003 22:50'!
narrowToFitContents
	self width: (self measureContents x).! !

!StringMorph methodsFor: 'Prefab-contents size' stamp: 'cr 7/21/2003 22:45'!
trimContentsAndAppend: truncatedIndicator
	| desiredWidth |

	self measureContents x > self width
		ifTrue: [
			desiredWidth := self width - (self font widthOfString: truncatedIndicator).
			self contents: (self contentsNarrowerThan: desiredWidth), '...'.
		].
! !


!SwitchElement methodsFor: 'appearances' stamp: 'cr 3/24/2002 01:00'!
click
	"Make button be drawn selected."

	self borderColor: #inset.
	self color: clickedColor.
! !

!SwitchElement methodsFor: 'appearances' stamp: 'cr 7/18/1999 19:00'!
correctLook
	isClicked
		ifTrue: [self click]
		ifFalse: [self unClick].! !

!SwitchElement methodsFor: 'appearances' stamp: 'cr 3/24/2002 00:58'!
incorrectLook
	"Set look to be the opposite of clicked state."
	isClicked
		ifFalse: [self click]
		ifTrue: [self unClick].

	self color: highlightColor.
! !

!SwitchElement methodsFor: 'appearances' stamp: 'cr 3/24/2002 01:00'!
unClick
	"Make button be drawn deselected."

	self borderColor: #raised.
	self color: unclickedColor.
! !

!SwitchElement methodsFor: 'event handling' stamp: 'cr 3/24/2002 00:18'!
mouseDown: evt

	clickedIn := true.

	self actPressed.! !

!SwitchElement methodsFor: 'event handling' stamp: 'cr 3/24/2002 00:23'!
mouseMove: evt
	"If the pointer was moved out of the button's perimeter without the blue button being
	 released, unpress the button without performing the action."

	(self containsPoint: evt cursorPoint)
		ifFalse: [
			clickedIn := false.
			self actCancelled.
		].

! !

!SwitchElement methodsFor: 'event handling' stamp: 'cr 3/24/2002 00:18'!
mouseUp: evt

	clickedIn
		ifFalse: [^self].

	clickedIn := false.

	self actReleased.! !

!SwitchElement methodsFor: 'private' stamp: 'cr 7/18/1999 18:17'!
swapColors
	"Swap color and otherColor."
	| old |
	old := self color.
	self color: otherColor.
	otherColor := old.
! !

!SwitchElement methodsFor: 'initialization' stamp: 'cr 3/24/2002 00:53'!
initialize
	super initialize.
	isClicked := false.

	clickedColor := Color blue.  "Changed by owner."
	unclickedColor := self color.
	highlightColor := clickedColor twiceLighter.

	toggleMode := true.

	"Get rid of the label."
	labelMorph delete.
	labelMorph := nil.
	labelMorphMaxSize := nil.
! !

!SwitchElement methodsFor: 'state' stamp: 'cr 7/18/1999 18:12'!
isClicked
	^isClicked.
! !

!SwitchElement methodsFor: 'state' stamp: 'cr 7/25/1999 00:23'!
isClicked: aBoolean
	isClicked := aBoolean.
	self correctLook.! !

!SwitchElement methodsFor: 'attributes' stamp: 'cr 3/24/2002 00:08'!
clickedColor: aColor
	clickedColor := aColor.
	isClicked
		ifTrue: [self color: aColor]
! !

!SwitchElement methodsFor: 'attributes' stamp: 'cr 3/24/2002 00:55'!
highlightColor: aColor
	"Set the color to use when the element has been clicked but released.  (i.e. indicates that it's noticed
	 the keystroke but hasn't made a state change yet."

	highlightColor := aColor.! !

!SwitchElement methodsFor: 'attributes' stamp: 'cr 7/25/1999 16:39'!
toggleMode: aBoolean
	"If true, clicking on a SwitchElement twice restores it to its original stat.  Otherwise,
	 it sticks in clicked state until reset.  Hence the difference between a check button
	 and a radio button."

	toggleMode := aBoolean.! !

!SwitchElement methodsFor: 'attributes' stamp: 'cr 3/24/2002 00:08'!
unclickedColor: aColor

	unclickedColor := aColor.
	isClicked not
		ifFalse: [self color: aColor].! !

!SwitchElement methodsFor: 'focus' stamp: 'cr 3/23/2002 23:03'!
neverGetsFocus
	^false

	"Just in case..."! !

!SwitchElement methodsFor: 'private-event handling' stamp: 'cr 3/24/2002 00:22'!
actCancelled
	self correctLook.
! !

!SwitchElement methodsFor: 'private-event handling' stamp: 'cr 3/24/2002 00:18'!
actPressed
	self incorrectLook.
! !

!SwitchElement methodsFor: 'private-event handling' stamp: 'cr 3/24/2002 00:18'!
actReleased

	(isClicked and: [toggleMode not])
		ifTrue: [^self correctLook].
	
	isClicked := isClicked not.
	self correctLook.

	response invoke.		"Ick!! Direct access to superclass's instant variable."
! !


!TabOrder methodsFor: 'all' stamp: 'cr 2/17/2002 19:54'!
initialize
	tabOrder := #().

! !

!TabOrder methodsFor: 'all' stamp: 'cr 2/16/2002 22:30'!
manager
	^manager
! !

!TabOrder methodsFor: 'all' stamp: 'cr 2/16/2002 22:31'!
manager: aManager
	manager := aManager.
! !

!TabOrder methodsFor: 'all' stamp: 'cr 2/17/2002 19:07'!
nextClient
	"Return the next client in the tab order or nil if there is none."
	
	
	tabOrder isEmpty
		ifTrue: [^nil].

	^self findNextClient.! !

!TabOrder methodsFor: 'all' stamp: 'cr 2/18/2002 20:46'!
setDefaultTabOrder
	| order |
	"Put all tabbable clients in the tab-order."

	"This could be smarter.  Ideally, it ought to sort things by position so that the tab order is reasonably
	 sane/logical.  But for the moment, we do it the easy way."
	order := manager allAtomicClients asSortedCollection: [ :x :y | x center y <= y center y].
	self setTabOrder: order.! !

!TabOrder methodsFor: 'all' stamp: 'cr 2/17/2002 19:54'!
setTabOrder: clientCollection
	| cc |
	"Set the tab order to clientCollection.  Elements may be references to clients or their tags."

	"Replace any names with control references."
	cc := clientCollection collect: [ :cl | (cl isKindOf: Symbol) 
										ifTrue: [manager clientWithTag: cl]
										ifFalse: [cl]].

	tabOrder := cc asArray.
! !

!TabOrder methodsFor: 'private' stamp: 'cr 2/17/2002 19:40'!
findClientWithFocus
	
	tabOrder withIndexDo: [ :cl :index  | cl hasLogicalFocus ifTrue: [^index]].
	^nil.! !

!TabOrder methodsFor: 'private' stamp: 'cr 2/17/2002 19:54'!
findNextClient
	| current cndx candidate |
	"Return the next object in the tab-order."

	"Get the current focussed item.  If none has the focus, we pick the last one so that the next is
	 as early as possible in the tab order."
	current := self findClientWithFocus.
	current ifNil: [current := tabOrder size].

	cndx := current + 1.

	tabOrder size timesRepeat: [
		"wrap around if necessary."
		cndx > tabOrder size
			ifTrue: [cndx := 1].

		candidate := tabOrder at: cndx.

		candidate wantsFocus
			ifTrue: [^candidate].

		cndx := cndx + 1.
	].

	^nil.

		 ! !


!TabOrder class methodsFor: 'as yet unclassified' stamp: 'cr 1/13/2002 23:30'!
new
	^self basicNew initialize! !


!TabbingTest methodsFor: 'as yet unclassified' stamp: 'cr 1/9/2004 21:58'!
buildOn: aManager
	"Caution--automatically-generated method."
	| rootManager |

	rootManager := aManager.

	rootManager
		extent: 448@608;
		color: (Color r: 1.0 g: 0.839 b: 0.742);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		minSize: 10@10;
		maxSize: 1073741823@1073741823;
		yourself.


	rootManager addClient: (PrefabFrame new
		extent: 152@120;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		borderType: #raised;
		yourself)
		atRelPosition: 272@272.

	rootManager addClient: (PrefabFrame new
		extent: 141@121;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		borderType: #inset;
		yourself)
		atRelPosition: 24@272.

	rootManager addClient: (PrefabEntry new
		extent: 400@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		yourself)
		atRelPosition: 24@120.

	rootManager addClient: (PrefabCheckButton new
		extent: 121@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Impatience';
		contentOrientation: #left;
		font: 'NewYork10-12';
		yourself)
		atRelPosition: 280@320.

	rootManager addClient: (PrefabCheckButton new
		extent: 121@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Hubris';
		contentOrientation: #left;
		font: 'NewYork10-12';
		yourself)
		atRelPosition: 280@280.

	rootManager addClient: (PrefabEntry new
		extent: 400@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		yourself)
		atRelPosition: 24@24.

	rootManager addClient: (PrefabButton new
		extent: 142@26;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #Clicky;
		text: 'Clicky';
		contentOrientation: #centered;
		font: 'NewYork10-12';
		yourself)
		atRelPosition: 24@400.

	rootManager addClient: (PrefabEntry new
		extent: 400@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		yourself)
		atRelPosition: 24@248.

	rootManager addClient: (PrefabRadioButton new
		extent: 129@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Miney';
		contentOrientation: #left;
		font: 'NewYork10-12';
		yourself)
		atRelPosition: 30@354.

	rootManager addClient: (PrefabEntry new
		extent: 400@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		yourself)
		atRelPosition: 24@152.

	rootManager addClient: (PrefabRadioButton new
		extent: 129@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Meeny';
		contentOrientation: #left;
		font: 'NewYork10-12';
		yourself)
		atRelPosition: 30@314.

	rootManager addClient: (PrefabEntry new
		extent: 400@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		yourself)
		atRelPosition: 24@184.

	rootManager addClient: (PrefabEntry new
		extent: 400@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		yourself)
		atRelPosition: 24@56.

	rootManager addClient: (PrefabEntry new
		extent: 400@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		yourself)
		atRelPosition: 24@216.

	rootManager addClient: (PrefabRadioButton new
		extent: 129@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Eeeny';
		contentOrientation: #left;
		font: 'NewYork10-12';
		yourself)
		atRelPosition: 30@274.

	rootManager addClient: (PrefabCheckButton new
		extent: 121@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Laziness';
		contentOrientation: #left;
		font: 'NewYork10-12';
		yourself)
		atRelPosition: 280@360.

	rootManager addClient: (PrefabEntry new
		extent: 400@18;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		yourself)
		atRelPosition: 24@88.

	rootManager addClient: (PrefabEdit new
		extent: 240@184;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #editPanel;
		yourself)
		atRelPosition: 184@400.

! !

!TabbingTest methodsFor: 'as yet unclassified' stamp: 'cr 3/7/2002 23:06'!
clicky
	morph color: Color random! !

!TabbingTest methodsFor: 'as yet unclassified' stamp: 'cr 3/7/2002 23:07'!
initialize
	
	| b |
	morph := PrefabManager new.
	self buildOn: morph.
	morph tabOrder setDefaultTabOrder.

	morph target: self forShortcuts: #('ALT+f' #sproing: 'foo').

	b := morph clientWithTag: #Clicky.
	b action: #clicky;
		target: self.


	morph openInWorld.! !

!TabbingTest methodsFor: 'as yet unclassified' stamp: 'cr 3/6/2002 22:55'!
sproing: letter
	nil inform: letter printString, ' pressed.'! !


!TabbingTest class methodsFor: 'as yet unclassified' stamp: 'cr 3/3/2002 21:59'!
new
	^self basicNew initialize.! !


!TempNameSet methodsFor: 'all' stamp: 'cr 12/9/2001 21:40'!
addSymbol: aSymbol
	"Add 'aSymbol' to the list of variables belonging to the namespace."

	names add: aSymbol asSymbol.
! !

!TempNameSet methodsFor: 'all' stamp: 'cr 12/9/2001 20:39'!
declarationString
	| result |
	"Return a string containing the Smalltalk declaration of all of these variable."

	result := WriteStream on: (String new: 100).

	result tab; 
		nextPutAll: '| '.

	names do: [ :name | 	result nextPutAll: name asString; space].

	result nextPut: $|; cr.

	^result contents.
! !

!TempNameSet methodsFor: 'all' stamp: 'cr 12/9/2001 20:32'!
generatedSymbol
	"Return a new symbol guaranteed not to already exist in this namespace."
	| symbol |
	lastGen := lastGen + 1.

	[	symbol := ('temp', lastGen asString) asSymbol.
		names includes: symbol
	] whileTrue: [
		lastGen := lastGen + 1
	].
		
	names add: symbol.
	^symbol.! !

!TempNameSet methodsFor: 'all' stamp: 'cr 12/9/2001 20:25'!
initialize
	names := Set new.
	lastGen := 0.
! !


!TempNameSet class methodsFor: 'instance creation' stamp: 'cr 12/9/2001 21:39'!
new
	^ super new initialize! !


!TestWidget methodsFor: 'as yet unclassified' stamp: 'cr 12/11/2001 03:34'!
buildOn: aManager
	"Caution--automatically-generated method."

	aManager
		extent: 567@443;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		minSize: 10@10;
		maxSize: 1073741823@1073741823.

	aManager addClient: (PrefabFrame new
		extent: 115@160;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		borderStyle: #inset;
		yourself)
		atRelPosition: 11@183.

	aManager addClient: (PrefabFrame new
		extent: 227@160;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		borderStyle: #inset;
		yourself)
		atRelPosition: 11@11.

	aManager addClient: (PrefabFrame new
		extent: 71@60;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		tag: #innermost;
		borderStyle: #inset;
		yourself)
		atRelPosition: 149@22.

	aManager addClient: (PrefabCheckButton new
		extent: 77@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Hubris';
		contentOrientation: #left;
		yourself)
		atRelPosition: 19@227.

	aManager addClient: (PrefabLabel new
		extent: 82@16;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Bitmap';
		contentOrientation: #left;
		yourself)
		atRelPosition: 27@39.

	aManager addClient: (PrefabLabel new
		extent: 66@24;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Checklist';
		contentOrientation: #left;
		yourself)
		atRelPosition: 27@207.

	aManager addClient: (PrefabCheckButton new
		extent: 93@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Impatience';
		contentOrientation: #left;
		yourself)
		atRelPosition: 19@255.

	aManager addClient: (PrefabLabel new
		extent: 46@48;
		color: (Color r: 0.844 g: 0.844 b: 0.844);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		image: #question;
		contentOrientation: #centered;
		yourself)
		atRelPosition: 158@25.

	aManager addClient: (PrefabRadioButton new
		extent: 131@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'info';
		contentOrientation: #left;
		yourself)
		atRelPosition: 23@131.

	aManager addClient: (PrefabCheckButton new
		extent: 85@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'Laziness';
		contentOrientation: #left;
		yourself)
		atRelPosition: 19@283.

	aManager addClient: (PrefabRadioButton new
		extent: 87@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'question';
		contentOrientation: #left;
		yourself)
		atRelPosition: 23@83.

	aManager addClient: (PrefabRadioButton new
		extent: 71@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'bang';
		contentOrientation: #left;
		yourself)
		atRelPosition: 23@59.

	aManager addClient: (PrefabListBox new
		extent: 155@160;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		elementHeight: 12;
		selectColor: (Color r: 0.71 g: 0.71 b: 0.71);
		selectForeground: (Color r: 1.0 g: 0.0 b: 0.0);
		selectionMode: #single;
		yourself)
		atRelPosition: 251@11.

	aManager addClient: (PrefabRadioButton new
		extent: 95@30;
		color: (Color r: 0.851 g: 0.851 b: 0.851);
		foregroundColor: (Color r: 0.0 g: 0.0 b: 0.0);
		text: 'doNotEnter';
		contentOrientation: #left;
		yourself)
		atRelPosition: 23@107.
! !

!TestWidget methodsFor: 'as yet unclassified' stamp: 'cr 3/26/2000 20:15'!
initialize
	super initialize.
	self buildOn: self.! !


!XPMReadWriter methodsFor: 'stream access' stamp: 'cr 9/10/1999 20:06'!
cr
	^stream cr.! !

!XPMReadWriter methodsFor: 'stream access' stamp: 'cr 9/10/1999 20:06'!
space
	^stream space! !

!XPMReadWriter methodsFor: 'stream access' stamp: 'cr 9/10/1999 20:06'!
tab
	^stream tab.! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 10/17/1999 20:27'!
extension
	"Extension data.  This will be an array of strings containing the complete, raw extension
	 data.  Parsing is up to you."
	^extension! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 10/17/1999 20:26'!
extension: aStringArray
	"Specify an array of strings to be tacked onto the end of an XPM as an extension.
	 The strings must be syntactically correct XPM extensions, including the final XPMEXTEND."

	extension := aStringArray.
	hasExtension := true.! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 9/4/1999 13:42'!
hotspot
	"Hotspot coordinates or nil if not provided."
	^hotspot! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 10/17/1999 20:27'!
hotspot: aPoint
	"Hotspot coordinates."
	hotspot := aPoint.! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 11/27/1999 04:07'!
nextImage
	"Read in the next xbm image from the stream."
	| form |

	stream reset.
	stream ascii.

	self readHeader.
	self readColorMap.

	colorMap size <= 255
		ifTrue: [
			form := ColorForm extent: width@height depth: 8.
			form colors: colorMap asArray.
		]
		ifFalse: [form := Form extent: width@height depth: 16].

	self readDataToForm: form.

	hasExtension
		ifTrue: [self readExtension].

	^form.

! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 10/7/1999 21:20'!
nextPutImage: aForm
	"Write 'aForm' to the stream."
	stream reset; text.

	hasExtension := extension notNil.
	width := aForm extent x.
	height := aForm extent y.
	
	self nextPutAll: '/* XPM */'; cr;
		nextPutAll: 'static char* ';
		nextPutAll: varName;
		nextPutAll: '[] = {'; cr.

	"Create the colormap.  This initializes all of the relevant header information."
	self createColorMapFromForm: aForm.

	"Write the header."
	self nextPutAll: '/* width height ncolors chars_per_pixel */'; cr.
	self nextPut: $"; space;
		nextPutAll: width storeString; space;
		nextPutAll: height storeString; space;
		nextPutAll: numColors storeString; space;
		nextPutAll: charsPerPixel storeString.
	hotspot ifNotNil: [
		self space;
			nextPutAll: hotspot x storeString; space;
			nextPutAll: hotspot y storeString.
	].
	hasExtension
		ifTrue: [self space;	nextPutAll: 'XPMEXT'].
	self nextPutAll: '",'; cr.

	"Write the color table."
	self nextPutAll: '/* colors */'; cr.
	self writeColorMap.
	
	"Write the pixels."
	self nextPutAll: '/* pixels */'; cr.
	self writeDataFromForm: aForm.

	"To do: Write extension if necessary."
	hasExtension
		ifTrue: [
			extension do: [ :string | 
				stream cr;
					nextPut: $";
					nextPutAll: string;
					nextPutAll: '",'.
			].
		].
	
	"Finish it off."
	self nextPutAll: '};'; cr.
	

	 
! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 10/17/1999 20:02'!
setName: aString toColor: aColor
	"Set a symbolic color.  These are pixel values that can be modified at load time.  Part
	 of the standard."
	symbolicColors at: aString put: aColor.! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 9/6/1999 16:15'!
understandsImageFormat
	"Test to see if the image stream format is understood by this decoder.	"
	| first |
	first := (self next: 9) asString.
	^ (first = '/* XPM */')
! !

!XPMReadWriter methodsFor: 'accessing' stamp: 'cr 10/17/1999 20:21'!
varName: aString
	"Set varName (the name of the variable to declare in C code).  Defaults to 'xpm_image'.
	 Should be a valid C variable name.  (If you don't know C, a valid Smalltalk variable
	 name will be sufficient.)"
	varName := aString.! !

!XPMReadWriter methodsFor: 'private' stamp: 'cr 11/27/1999 04:14'!
readDataToForm: aForm
	"Read in the data and store it in 'aForm'."
	| thisLine color |

	0 to: height - 1 do: [ :y | 
		thisLine := ReadStream on: self nextStringEntry.
		0 to: width - 1 do: [ :x |
			color := thisLine next: charsPerPixel.
			aForm colorAt: x@y put: (colorMap at: color).
		].
	].! !

!XPMReadWriter methodsFor: 'private' stamp: 'cr 10/7/1999 21:12'!
readExtension
	| ext line |
	"Read extension data."

	ext := WriteStream on: (Array new: 20).

	[
		line := self nextStringEntry.
		ext nextPut: line.
		line = 'XPMENDEXT'
	] whileFalse.

	extension := ext contents.
! !

!XPMReadWriter methodsFor: 'private' stamp: 'cr 9/7/1999 22:35'!
readHeader
	| header |
		
	"Header has format: 'width height colors chars-per-pixel [hotspot-x hotspot-y] [XPMEXT]'."
	header := (self nextStringEntry) substrings.
	
	width := header first asNumber.
	height := header second asNumber.
	numColors := header third asNumber.
	charsPerPixel := header fourth asNumber.
	
	header size >= 7
		ifTrue: [
			hotspot := header fifth asNumber @ header sixth asNumber.
		].

	
	hasExtension := (header size = 7).
	! !

!XPMReadWriter methodsFor: 'private' stamp: 'cr 9/6/1999 16:57'!
requiredDepth
	"Return the pixel depth required to handle the given number of colors.  If more than 255,
	 defaults to 16-bit."

	| sz depth |
	sz := colorMap size.
	sz > 255	ifTrue: [^16].

	depth := 1.
	[sz := sz >> 1.  sz > 0] whileTrue: [depth := depth + 1].		

	^depth.! !

!XPMReadWriter methodsFor: 'private' stamp: 'cr 11/27/1999 04:17'!
writeDataFromForm: aForm
	"Write out the contents of aForm as XPM data."

	| c |
	0 to: height - 1 do: [ :y |
		self nextPut: $".
		0 to: width - 1 do: [ :x |
			c := aForm colorAt: x@y.
			self nextPutAll: (writeColorMap at: c).
		].
	
		"If there's no extension, omit the last comma."
		(y = height and: [hasExtension not])
			ifTrue: [self nextPut: $"]
			ifFalse: [self nextPutAll: '",'].
		self cr.
	].

! !

!XPMReadWriter methodsFor: 'private-color map' stamp: 'cr 9/6/1999 16:30'!
colorMapPairs: aString
	"Tokenize aString into an array of strings consisting of pairs (arrays) of type (one of 'c', 'g', 'g4' 
	 's' and 'm') and the corresponding color described as a string.  The result is then sorted by key
	 into order of desirability."
	| result source type color sortOrder |

	result := WriteStream on: (Array new: 10).
	source := ReadStream on: aString substrings.

	[
		type := source next.
		color := source next.
	
		"Named colors may contain spaces but none have 1-letter names, so if the next token is
		 more than one char long, it's part of the color name."
		[source atEnd not and: [source peek size > 1]] 
			whileTrue: [color := color, ' ', source next].

		result nextPut: {type. color}.

		source atEnd not
	] whileTrue.

	"Sort in order of most information."
	sortOrder := #('s' 'c' 'g' 'g4' 'm').
	^ result contents asSortedCollection: [ :l :r | (sortOrder indexOf: l first) <= (sortOrder indexOf: r first)].



! !

!XPMReadWriter methodsFor: 'private-color map' stamp: 'cr 10/21/1999 02:26'!
colorNamed: aString
	"Return the color named by 'aString', which may be in a variety of formats."

	| numbers nstr rgb cw maxColor triplet |

	"Case 1: Transparent colors"
	(aString asLowercase = 'none' or: [aString asLowercase = 'transparent'])  "ee does the latter."
		ifTrue: [^Color transparent].

	"Case 2: Numeric color, either RGB or HSV."
	(aString first = $# or: [aString first = $%])
		ifTrue: [
			numbers := aString allButFirst asUppercase.	
			cw := numbers size / 3.
			maxColor := (1 << (cw * 4)) - 1.0.

			nstr := ReadStream on: numbers.
			rgb := (1 to: 3) collect: [ :x | (('16r', (nstr next: cw)) asNumber) / maxColor].

			"Create the color.  red, green and blue may actually contain HSV values."
			aString first = $#
				ifTrue: [^Color fromRgbTriplet: rgb]
				ifFalse: [^Color h: rgb first s: rgb second v: rgb third].
		].

	"Case 3: A symbolic name."
	(RGBNames includesKey: aString)
		ifTrue: [
			triplet := RGBNames at: aString
		] ifFalse: [
			triplet := RGBNames at: aString asLowercase 
							ifAbsent: [^self error: 'Unknown color named ''', aString, ''''].
		].
	^ Color fromRgbTriplet: triplet / 255.0.
	



		! !

!XPMReadWriter methodsFor: 'private-color map' stamp: 'cr 10/17/1999 21:19'!
createColorMapFromForm: aForm
	"Examine 'aForm' to determine color usage and use the results to create a colormap (stored
	 in 'writeColorMap') and set numColors and charsPerPixel correctly."
	| colors c |
	writeColorMap := Dictionary new.
	colors := Set new.
	
	"Catalog the colors used."
	1 to: width do: [ :x |
		1 to: height do: [ :y |
			colors add: (aForm colorAt: x@y).
		]
	].

	"Set numColors and charsPerPixel."
	numColors := colors size.
	charsPerPixel := (numColors log: self class keyChars size) truncated + 1.
	
	"Fill colorMap with colors keyed by combinations of keyArray.  Return once colors
	 is empty (we'll probably have more combinations than required and there's no way
	 to bail out of an enumeration."
	self class keyChars combinations: charsPerPixel atATimeDo: [ :key |
		colors isEmpty
			ifTrue: [^self].

		c := colors someElement.
	
		"writeColorMap at: c put: key asString."
		"Alas, asString does not do the intuitive thing when sent to an array.  I
		 sent off a fix to Squeak Central but I can't really assume that it'll be
		 included in the next release, so here's a workaround.  Remove when/if
		 asString does the (IMHO) right thing."
		writeColorMap at: c put: (key inject: '' into: [ :old :new | old, new asString]).

		colors remove: c.
	].










! !

!XPMReadWriter methodsFor: 'private-color map' stamp: 'cr 9/6/1999 16:31'!
parseColorMapEntry: entryString
	"Split an XPM color map entry into key and color and store in colorMap.  If multiple values
	 are provided, we take the one with the most colors."
	| pixelChars bestEntry entries color |

	pixelChars := entryString copyFrom: 1 to: charsPerPixel.
	entries := self colorMapPairs: (entryString copyFrom: charsPerPixel + 1 to: entryString size).

	bestEntry := entries first.

	"If we have a symbolic entry here, see if it's defined and if not, pick the next one."
	bestEntry first = 's'
		ifTrue: [
			 (symbolicColors includesKey: bestEntry second)
				ifTrue: [color := symbolicColors at: bestEntry second]
				ifFalse: [
					entries size = 1
						ifTrue: [
							^self error: 'Symbolic color ''', bestEntry second, ''' is undefined and ',
											'has no alternate definition.'
						].
					bestEntry := entries second.
				].	
		].

	color := self colorNamed: bestEntry second.

	colorMap at: pixelChars put: color.



! !

!XPMReadWriter methodsFor: 'private-color map' stamp: 'cr 9/6/1999 16:21'!
readColorMap
	"Read in the color map."

	colorMap := Dictionary new.
	1 to: numColors do: [ :n |
		self parseColorMapEntry: self nextStringEntry.
	].! !

!XPMReadWriter methodsFor: 'private-color map' stamp: 'cr 9/11/1999 00:48'!
writeColorMap
	"Write out the color map stored in 'colorMap'."
	| color |
	writeColorMap associationsDo: [ :assoc |
		self nextPut: $";
			nextPutAll: assoc value;	
			space;
			nextPut: $c;
			space.

		color := assoc key.
		color isTranslucent
			ifTrue: [
				self nextPutAll: 'None'
			] ifFalse: [
				self nextPutAll: (color x11ColorString: 3).
			].

		self nextPutAll: '",'; cr.
	].
				! !

!XPMReadWriter methodsFor: 'private-input laundry' stamp: 'cr 10/17/1999 21:26'!
advanceToQuote
	"Advance to the beginning of the next string (assumes we're not in the middle of a string right
	 now)."
	| q |

	[q := self nextNonWhiteSpace. q = $/ or: [q = $"]]
		whileFalse: [self atEnd ifTrue: [self error: 'Unexpected end of file.']].

	q = $/
		ifTrue: [
			self next = $*
				ifTrue: [
					self skip: -2.
					self skipComment.
					^self advanceToQuote.
				] ifFalse: [
					self skip: -1.
					^self advanceToQuote.
				].
		].

	self skip: -1.				"Back up to just before quote."! !

!XPMReadWriter methodsFor: 'private-input laundry' stamp: 'cr 9/7/1999 23:31'!
nextNonWhiteSpace
	"Read the next character from the stream.  If the character is whitespace, eat it
	 and all subsequent whitespace and return a single space.  Otherwise, just return the character."
	
	| s |

	[s := self next.  self atEnd not and: [s isSeparator]] whileTrue.
	^s.! !

!XPMReadWriter methodsFor: 'private-input laundry' stamp: 'cr 10/17/1999 21:27'!
nextStringEntry
	"Return the contents of the next line which is a C string (begins with double quote, ends with
	 quote-comma) if not at end of file.  Skips all comments."

	| result |
	self advanceToQuote.

	self next.		"Eat leading quote."

	"This could be a lot simpler but I want to handle the case where an xpm contains
	 an escaped quote."
	result := stream upTo: $".
	[result last = $\]
		whileTrue: [
			result := result allButLast, (stream upTo: $").
		].

	self next.		"Eat trailing quote."
	
	^result.
! !

!XPMReadWriter methodsFor: 'private-input laundry' stamp: 'cr 9/7/1999 23:34'!
skipComment
	"Skip a C-style comment in the input stream."

	| start |
	start := self next: 2.
	start = '/*' or: [self error: 'Not a C comment.'].

	[stream upTo: $*. self next = $/]
		whileFalse: [
			stream skip: -1.  "put back the lookahead character."

			self atEnd
				ifTrue: [self error: 'Invalid file--unterminated comment.'].
		].	! !

!XPMReadWriter methodsFor: 'initialization' stamp: 'cr 9/6/1999 20:56'!
initialize
	"Create the symbolic color table."
	symbolicColors := Dictionary new.
	varName := 'xpm_image'.! !


!XPMReadWriter class methodsFor: 'class initialization' stamp: 'cr 9/6/1999 20:08'!
initialize
	"Initialize RGBNames to a dictionary of rgb tuples keyed on names.  This corresponds to the X11
	 rgb.txt file."

	RGBNames := Dictionary new.
	self colorList do: [ :item |
		RGBNames at: item first put: item second
	].

	self colorList do: [ :item |
		(RGBNames includesKey: item first asLowercase)
			ifFalse: [RGBNames at: item first asLowercase put: item second].
	].

	"XPMReadWriter initialize"! !

!XPMReadWriter class methodsFor: 'constants' stamp: 'cr 9/4/1999 18:43'!
colorList
	"Array mapping names to rgb values."

	"This is taken from the file rgb.txt included with XFree86 and is thus derived from X11 as
	 allowed by the X11 license."

	^#(	('snow' (255 250 250))
		('ghost white' (248 248 255))
		('GhostWhite' (248 248 255))
		('white smoke' (245 245 245))
		('WhiteSmoke' (245 245 245))
		('gainsboro' (220 220 220))
		('floral white' (255 250 240))
		('FloralWhite' (255 250 240))
		('old lace' (253 245 230))
		('OldLace' (253 245 230))
		('linen' (250 240 230))
		('antique white' (250 235 215))
		('AntiqueWhite' (250 235 215))
		('papaya whip' (255 239 213))
		('PapayaWhip' (255 239 213))
		('blanched almond' (255 235 205))
		('BlanchedAlmond' (255 235 205))
		('bisque' (255 228 196))
		('peach puff' (255 218 185))
		('PeachPuff' (255 218 185))
		('navajo white' (255 222 173))
		('NavajoWhite' (255 222 173))
		('moccasin' (255 228 181))
		('cornsilk' (255 248 220))
		('ivory' (255 255 240))
		('lemon chiffon' (255 250 205))
		('LemonChiffon' (255 250 205))
		('seashell' (255 245 238))
		('honeydew' (240 255 240))
		('mint cream' (245 255 250))
		('MintCream' (245 255 250))
		('azure' (240 255 255))
		('alice blue' (240 248 255))
		('AliceBlue' (240 248 255))
		('lavender' (230 230 250))
		('lavender blush' (255 240 245))
		('LavenderBlush' (255 240 245))
		('misty rose' (255 228 225))
		('MistyRose' (255 228 225))
		('white' (255 255 255))
		('black' (0 0 0))
		('dark slate gray' (47 79 79))
		('DarkSlateGray' (47 79 79))
		('dark slate grey' (47 79 79))
		('DarkSlateGrey' (47 79 79))
		('dim gray' (105 105 105))
		('DimGray' (105 105 105))
		('dim grey' (105 105 105))
		('DimGrey' (105 105 105))
		('slate gray' (112 128 144))
		('SlateGray' (112 128 144))
		('slate grey' (112 128 144))
		('SlateGrey' (112 128 144))
		('light slate gray' (119 136 153))
		('LightSlateGray' (119 136 153))
		('light slate grey' (119 136 153))
		('LightSlateGrey' (119 136 153))
		('gray' (190 190 190))
		('grey' (190 190 190))
		('light grey' (211 211 211))
		('LightGrey' (211 211 211))
		('light gray' (211 211 211))
		('LightGray' (211 211 211))
		('midnight blue' (25 25 112))
		('MidnightBlue' (25 25 112))
		('navy' (0 0 128))
		('navy blue' (0 0 128))
		('NavyBlue' (0 0 128))
		('cornflower blue' (100 149 237))
		('CornflowerBlue' (100 149 237))
		('dark slate blue' (72 61 139))
		('DarkSlateBlue' (72 61 139))
		('slate blue' (106 90 205))
		('SlateBlue' (106 90 205))
		('medium slate blue' (123 104 238))
		('MediumSlateBlue' (123 104 238))
		('light slate blue' (132 112 255))
		('LightSlateBlue' (132 112 255))
		('medium blue' (0 0 205))
		('MediumBlue' (0 0 205))
		('royal blue' (65 105 225))
		('RoyalBlue' (65 105 225))
		('blue' (0 0 255))
		('dodger blue' (30 144 255))
		('DodgerBlue' (30 144 255))
		('deep sky blue' (0 191 255))
		('DeepSkyBlue' (0 191 255))
		('sky blue' (135 206 235))
		('SkyBlue' (135 206 235))
		('light sky blue' (135 206 250))
		('LightSkyBlue' (135 206 250))
		('steel blue' (70 130 180))
		('SteelBlue' (70 130 180))
		('light steel blue' (176 196 222))
		('LightSteelBlue' (176 196 222))
		('light blue' (173 216 230))
		('LightBlue' (173 216 230))
		('powder blue' (176 224 230))
		('PowderBlue' (176 224 230))
		('pale turquoise' (175 238 238))
		('PaleTurquoise' (175 238 238))
		('dark turquoise' (0 206 209))
		('DarkTurquoise' (0 206 209))
		('medium turquoise' (72 209 204))
		('MediumTurquoise' (72 209 204))
		('turquoise' (64 224 208))
		('cyan' (0 255 255))
		('light cyan' (224 255 255))
		('LightCyan' (224 255 255))
		('cadet blue' (95 158 160))
		('CadetBlue' (95 158 160))
		('medium aquamarine' (102 205 170))
		('MediumAquamarine' (102 205 170))
		('aquamarine' (127 255 212))
		('dark green' (0 100 0))
		('DarkGreen' (0 100 0))
		('dark olive green' (85 107 47))
		('DarkOliveGreen' (85 107 47))
		('dark sea green' (143 188 143))
		('DarkSeaGreen' (143 188 143))
		('sea green' (46 139 87))
		('SeaGreen' (46 139 87))
		('medium sea green' (60 179 113))
		('MediumSeaGreen' (60 179 113))
		('light sea green' (32 178 170))
		('LightSeaGreen' (32 178 170))
		('pale green' (152 251 152))
		('PaleGreen' (152 251 152))
		('spring green' (0 255 127))
		('SpringGreen' (0 255 127))
		('lawn green' (124 252 0))
		('LawnGreen' (124 252 0))
		('green' (0 255 0))
		('chartreuse' (127 255 0))
		('medium spring green' (0 250 154))
		('MediumSpringGreen' (0 250 154))
		('green yellow' (173 255 47))
		('GreenYellow' (173 255 47))
		('lime green' (50 205 50))
		('LimeGreen' (50 205 50))
		('yellow green' (154 205 50))
		('YellowGreen' (154 205 50))
		('forest green' (34 139 34))
		('ForestGreen' (34 139 34))
		('olive drab' (107 142 35))
		('OliveDrab' (107 142 35))
		('dark khaki' (189 183 107))
		('DarkKhaki' (189 183 107))
		('khaki' (240 230 140))
		('pale goldenrod' (238 232 170))
		('PaleGoldenrod' (238 232 170))
		('light goldenrod yellow' (250 250 210))
		('LightGoldenrodYellow' (250 250 210))
		('light yellow' (255 255 224))
		('LightYellow' (255 255 224))
		('yellow' (255 255 0))
		('gold' (255 215 0))
		('light goldenrod' (238 221 130))
		('LightGoldenrod' (238 221 130))
		('goldenrod' (218 165 32))
		('dark goldenrod' (184 134 11))
		('DarkGoldenrod' (184 134 11))
		('rosy brown' (188 143 143))
		('RosyBrown' (188 143 143))
		('indian red' (205 92 92))
		('IndianRed' (205 92 92))
		('saddle brown' (139 69 19))
		('SaddleBrown' (139 69 19))
		('sienna' (160 82 45))
		('peru' (205 133 63))
		('burlywood' (222 184 135))
		('beige' (245 245 220))
		('wheat' (245 222 179))
		('sandy brown' (244 164 96))
		('SandyBrown' (244 164 96))
		('tan' (210 180 140))
		('chocolate' (210 105 30))
		('firebrick' (178 34 34))
		('brown' (165 42 42))
		('dark salmon' (233 150 122))
		('DarkSalmon' (233 150 122))
		('salmon' (250 128 114))
		('light salmon' (255 160 122))
		('LightSalmon' (255 160 122))
		('orange' (255 165 0))
		('dark orange' (255 140 0))
		('DarkOrange' (255 140 0))
		('coral' (255 127 80))
		('light coral' (240 128 128))
		('LightCoral' (240 128 128))
		('tomato' (255 99 71))
		('orange red' (255 69 0))
		('OrangeRed' (255 69 0))
		('red' (255 0 0))
		('hot pink' (255 105 180))
		('HotPink' (255 105 180))
		('deep pink' (255 20 147))
		('DeepPink' (255 20 147))
		('pink' (255 192 203))
		('light pink' (255 182 193))
		('LightPink' (255 182 193))
		('pale violet red' (219 112 147))
		('PaleVioletRed' (219 112 147))
		('maroon' (176 48 96))
		('medium violet red' (199 21 133))
		('MediumVioletRed' (199 21 133))
		('violet red' (208 32 144))
		('VioletRed' (208 32 144))
		('magenta' (255 0 255))
		('violet' (238 130 238))
		('plum' (221 160 221))
		('orchid' (218 112 214))
		('medium orchid' (186 85 211))
		('MediumOrchid' (186 85 211))
		('dark orchid' (153 50 204))
		('DarkOrchid' (153 50 204))
		('dark violet' (148 0 211))
		('DarkViolet' (148 0 211))
		('blue violet' (138 43 226))
		('BlueViolet' (138 43 226))
		('purple' (160 32 240))
		('medium purple' (147 112 219))
		('MediumPurple' (147 112 219))
		('thistle' (216 191 216))
		('snow1' (255 250 250))
		('snow2' (238 233 233))
		('snow3' (205 201 201))
		('snow4' (139 137 137))
		('seashell1' (255 245 238))
		('seashell2' (238 229 222))
		('seashell3' (205 197 191))
		('seashell4' (139 134 130))
		('AntiqueWhite1' (255 239 219))
		('AntiqueWhite2' (238 223 204))
		('AntiqueWhite3' (205 192 176))
		('AntiqueWhite4' (139 131 120))
		('bisque1' (255 228 196))
		('bisque2' (238 213 183))
		('bisque3' (205 183 158))
		('bisque4' (139 125 107))
		('PeachPuff1' (255 218 185))
		('PeachPuff2' (238 203 173))
		('PeachPuff3' (205 175 149))
		('PeachPuff4' (139 119 101))
		('NavajoWhite1' (255 222 173))
		('NavajoWhite2' (238 207 161))
		('NavajoWhite3' (205 179 139))
		('NavajoWhite4' (139 121 94))
		('LemonChiffon1' (255 250 205))
		('LemonChiffon2' (238 233 191))
		('LemonChiffon3' (205 201 165))
		('LemonChiffon4' (139 137 112))
		('cornsilk1' (255 248 220))
		('cornsilk2' (238 232 205))
		('cornsilk3' (205 200 177))
		('cornsilk4' (139 136 120))
		('ivory1' (255 255 240))
		('ivory2' (238 238 224))
		('ivory3' (205 205 193))
		('ivory4' (139 139 131))
		('honeydew1' (240 255 240))
		('honeydew2' (224 238 224))
		('honeydew3' (193 205 193))
		('honeydew4' (131 139 131))
		('LavenderBlush1' (255 240 245))
		('LavenderBlush2' (238 224 229))
		('LavenderBlush3' (205 193 197))
		('LavenderBlush4' (139 131 134))
		('MistyRose1' (255 228 225))
		('MistyRose2' (238 213 210))
		('MistyRose3' (205 183 181))
		('MistyRose4' (139 125 123))
		('azure1' (240 255 255))
		('azure2' (224 238 238))
		('azure3' (193 205 205))
		('azure4' (131 139 139))
		('SlateBlue1' (131 111 255))
		('SlateBlue2' (122 103 238))
		('SlateBlue3' (105 89 205))
		('SlateBlue4' (71 60 139))
		('RoyalBlue1' (72 118 255))
		('RoyalBlue2' (67 110 238))
		('RoyalBlue3' (58 95 205))
		('RoyalBlue4' (39 64 139))
		('blue1' (0 0 255))
		('blue2' (0 0 238))
		('blue3' (0 0 205))
		('blue4' (0 0 139))
		('DodgerBlue1' (30 144 255))
		('DodgerBlue2' (28 134 238))
		('DodgerBlue3' (24 116 205))
		('DodgerBlue4' (16 78 139))
		('SteelBlue1' (99 184 255))
		('SteelBlue2' (92 172 238))
		('SteelBlue3' (79 148 205))
		('SteelBlue4' (54 100 139))
		('DeepSkyBlue1' (0 191 255))
		('DeepSkyBlue2' (0 178 238))
		('DeepSkyBlue3' (0 154 205))
		('DeepSkyBlue4' (0 104 139))
		('SkyBlue1' (135 206 255))
		('SkyBlue2' (126 192 238))
		('SkyBlue3' (108 166 205))
		('SkyBlue4' (74 112 139))
		('LightSkyBlue1' (176 226 255))
		('LightSkyBlue2' (164 211 238))
		('LightSkyBlue3' (141 182 205))
		('LightSkyBlue4' (96 123 139))
		('SlateGray1' (198 226 255))
		('SlateGray2' (185 211 238))
		('SlateGray3' (159 182 205))
		('SlateGray4' (108 123 139))
		('LightSteelBlue1' (202 225 255))
		('LightSteelBlue2' (188 210 238))
		('LightSteelBlue3' (162 181 205))
		('LightSteelBlue4' (110 123 139))
		('LightBlue1' (191 239 255))
		('LightBlue2' (178 223 238))
		('LightBlue3' (154 192 205))
		('LightBlue4' (104 131 139))
		('LightCyan1' (224 255 255))
		('LightCyan2' (209 238 238))
		('LightCyan3' (180 205 205))
		('LightCyan4' (122 139 139))
		('PaleTurquoise1' (187 255 255))
		('PaleTurquoise2' (174 238 238))
		('PaleTurquoise3' (150 205 205))
		('PaleTurquoise4' (102 139 139))
		('CadetBlue1' (152 245 255))
		('CadetBlue2' (142 229 238))
		('CadetBlue3' (122 197 205))
		('CadetBlue4' (83 134 139))
		('turquoise1' (0 245 255))
		('turquoise2' (0 229 238))
		('turquoise3' (0 197 205))
		('turquoise4' (0 134 139))
		('cyan1' (0 255 255))
		('cyan2' (0 238 238))
		('cyan3' (0 205 205))
		('cyan4' (0 139 139))
		('DarkSlateGray1' (151 255 255))
		('DarkSlateGray2' (141 238 238))
		('DarkSlateGray3' (121 205 205))
		('DarkSlateGray4' (82 139 139))
		('aquamarine1' (127 255 212))
		('aquamarine2' (118 238 198))
		('aquamarine3' (102 205 170))
		('aquamarine4' (69 139 116))
		('DarkSeaGreen1' (193 255 193))
		('DarkSeaGreen2' (180 238 180))
		('DarkSeaGreen3' (155 205 155))
		('DarkSeaGreen4' (105 139 105))
		('SeaGreen1' (84 255 159))
		('SeaGreen2' (78 238 148))
		('SeaGreen3' (67 205 128))
		('SeaGreen4' (46 139 87))
		('PaleGreen1' (154 255 154))
		('PaleGreen2' (144 238 144))
		('PaleGreen3' (124 205 124))
		('PaleGreen4' (84 139 84))
		('SpringGreen1' (0 255 127))
		('SpringGreen2' (0 238 118))
		('SpringGreen3' (0 205 102))
		('SpringGreen4' (0 139 69))
		('green1' (0 255 0))
		('green2' (0 238 0))
		('green3' (0 205 0))
		('green4' (0 139 0))
		('chartreuse1' (127 255 0))
		('chartreuse2' (118 238 0))
		('chartreuse3' (102 205 0))
		('chartreuse4' (69 139 0))
		('OliveDrab1' (192 255 62))
		('OliveDrab2' (179 238 58))
		('OliveDrab3' (154 205 50))
		('OliveDrab4' (105 139 34))
		('DarkOliveGreen1' (202 255 112))
		('DarkOliveGreen2' (188 238 104))
		('DarkOliveGreen3' (162 205 90))
		('DarkOliveGreen4' (110 139 61))
		('khaki1' (255 246 143))
		('khaki2' (238 230 133))
		('khaki3' (205 198 115))
		('khaki4' (139 134 78))
		('LightGoldenrod1' (255 236 139))
		('LightGoldenrod2' (238 220 130))
		('LightGoldenrod3' (205 190 112))
		('LightGoldenrod4' (139 129 76))
		('LightYellow1' (255 255 224))
		('LightYellow2' (238 238 209))
		('LightYellow3' (205 205 180))
		('LightYellow4' (139 139 122))
		('yellow1' (255 255 0))
		('yellow2' (238 238 0))
		('yellow3' (205 205 0))
		('yellow4' (139 139 0))
		('gold1' (255 215 0))
		('gold2' (238 201 0))
		('gold3' (205 173 0))
		('gold4' (139 117 0))
		('goldenrod1' (255 193 37))
		('goldenrod2' (238 180 34))
		('goldenrod3' (205 155 29))
		('goldenrod4' (139 105 20))
		('DarkGoldenrod1' (255 185 15))
		('DarkGoldenrod2' (238 173 14))
		('DarkGoldenrod3' (205 149 12))
		('DarkGoldenrod4' (139 101 8))
		('RosyBrown1' (255 193 193))
		('RosyBrown2' (238 180 180))
		('RosyBrown3' (205 155 155))
		('RosyBrown4' (139 105 105))
		('IndianRed1' (255 106 106))
		('IndianRed2' (238 99 99))
		('IndianRed3' (205 85 85))
		('IndianRed4' (139 58 58))
		('sienna1' (255 130 71))
		('sienna2' (238 121 66))
		('sienna3' (205 104 57))
		('sienna4' (139 71 38))
		('burlywood1' (255 211 155))
		('burlywood2' (238 197 145))
		('burlywood3' (205 170 125))
		('burlywood4' (139 115 85))
		('wheat1' (255 231 186))
		('wheat2' (238 216 174))
		('wheat3' (205 186 150))
		('wheat4' (139 126 102))
		('tan1' (255 165 79))
		('tan2' (238 154 73))
		('tan3' (205 133 63))
		('tan4' (139 90 43))
		('chocolate1' (255 127 36))
		('chocolate2' (238 118 33))
		('chocolate3' (205 102 29))
		('chocolate4' (139 69 19))
		('firebrick1' (255 48 48))
		('firebrick2' (238 44 44))
		('firebrick3' (205 38 38))
		('firebrick4' (139 26 26))
		('brown1' (255 64 64))
		('brown2' (238 59 59))
		('brown3' (205 51 51))
		('brown4' (139 35 35))
		('salmon1' (255 140 105))
		('salmon2' (238 130 98))
		('salmon3' (205 112 84))
		('salmon4' (139 76 57))
		('LightSalmon1' (255 160 122))
		('LightSalmon2' (238 149 114))
		('LightSalmon3' (205 129 98))
		('LightSalmon4' (139 87 66))
		('orange1' (255 165 0))
		('orange2' (238 154 0))
		('orange3' (205 133 0))
		('orange4' (139 90 0))
		('DarkOrange1' (255 127 0))
		('DarkOrange2' (238 118 0))
		('DarkOrange3' (205 102 0))
		('DarkOrange4' (139 69 0))
		('coral1' (255 114 86))
		('coral2' (238 106 80))
		('coral3' (205 91 69))
		('coral4' (139 62 47))
		('tomato1' (255 99 71))
		('tomato2' (238 92 66))
		('tomato3' (205 79 57))
		('tomato4' (139 54 38))
		('OrangeRed1' (255 69 0))
		('OrangeRed2' (238 64 0))
		('OrangeRed3' (205 55 0))
		('OrangeRed4' (139 37 0))
		('red1' (255 0 0))
		('red2' (238 0 0))
		('red3' (205 0 0))
		('red4' (139 0 0))
		('DeepPink1' (255 20 147))
		('DeepPink2' (238 18 137))
		('DeepPink3' (205 16 118))
		('DeepPink4' (139 10 80))
		('HotPink1' (255 110 180))
		('HotPink2' (238 106 167))
		('HotPink3' (205 96 144))
		('HotPink4' (139 58 98))
		('pink1' (255 181 197))
		('pink2' (238 169 184))
		('pink3' (205 145 158))
		('pink4' (139 99 108))
		('LightPink1' (255 174 185))
		('LightPink2' (238 162 173))
		('LightPink3' (205 140 149))
		('LightPink4' (139 95 101))
		('PaleVioletRed1' (255 130 171))
		('PaleVioletRed2' (238 121 159))
		('PaleVioletRed3' (205 104 137))
		('PaleVioletRed4' (139 71 93))
		('maroon1' (255 52 179))
		('maroon2' (238 48 167))
		('maroon3' (205 41 144))
		('maroon4' (139 28 98))
		('VioletRed1' (255 62 150))
		('VioletRed2' (238 58 140))
		('VioletRed3' (205 50 120))
		('VioletRed4' (139 34 82))
		('magenta1' (255 0 255))
		('magenta2' (238 0 238))
		('magenta3' (205 0 205))
		('magenta4' (139 0 139))
		('orchid1' (255 131 250))
		('orchid2' (238 122 233))
		('orchid3' (205 105 201))
		('orchid4' (139 71 137))
		('plum1' (255 187 255))
		('plum2' (238 174 238))
		('plum3' (205 150 205))
		('plum4' (139 102 139))
		('MediumOrchid1' (224 102 255))
		('MediumOrchid2' (209 95 238))
		('MediumOrchid3' (180 82 205))
		('MediumOrchid4' (122 55 139))
		('DarkOrchid1' (191 62 255))
		('DarkOrchid2' (178 58 238))
		('DarkOrchid3' (154 50 205))
		('DarkOrchid4' (104 34 139))
		('purple1' (155 48 255))
		('purple2' (145 44 238))
		('purple3' (125 38 205))
		('purple4' (85 26 139))
		('MediumPurple1' (171 130 255))
		('MediumPurple2' (159 121 238))
		('MediumPurple3' (137 104 205))
		('MediumPurple4' (93 71 139))
		('thistle1' (255 225 255))
		('thistle2' (238 210 238))
		('thistle3' (205 181 205))
		('thistle4' (139 123 139))
		('gray0' (0 0 0))
		('grey0' (0 0 0))
		('gray1' (3 3 3))
		('grey1' (3 3 3))
		('gray2' (5 5 5))
		('grey2' (5 5 5))
		('gray3' (8 8 8))
		('grey3' (8 8 8))
		('gray4' (10 10 10))
		('grey4' (10 10 10))
		('gray5' (13 13 13))
		('grey5' (13 13 13))
		('gray6' (15 15 15))
		('grey6' (15 15 15))
		('gray7' (18 18 18))
		('grey7' (18 18 18))
		('gray8' (20 20 20))
		('grey8' (20 20 20))
		('gray9' (23 23 23))
		('grey9' (23 23 23))
		('gray10' (26 26 26))
		('grey10' (26 26 26))
		('gray11' (28 28 28))
		('grey11' (28 28 28))
		('gray12' (31 31 31))
		('grey12' (31 31 31))
		('gray13' (33 33 33))
		('grey13' (33 33 33))
		('gray14' (36 36 36))
		('grey14' (36 36 36))
		('gray15' (38 38 38))
		('grey15' (38 38 38))
		('gray16' (41 41 41))
		('grey16' (41 41 41))
		('gray17' (43 43 43))
		('grey17' (43 43 43))
		('gray18' (46 46 46))
		('grey18' (46 46 46))
		('gray19' (48 48 48))
		('grey19' (48 48 48))
		('gray20' (51 51 51))
		('grey20' (51 51 51))
		('gray21' (54 54 54))
		('grey21' (54 54 54))
		('gray22' (56 56 56))
		('grey22' (56 56 56))
		('gray23' (59 59 59))
		('grey23' (59 59 59))
		('gray24' (61 61 61))
		('grey24' (61 61 61))
		('gray25' (64 64 64))
		('grey25' (64 64 64))
		('gray26' (66 66 66))
		('grey26' (66 66 66))
		('gray27' (69 69 69))
		('grey27' (69 69 69))
		('gray28' (71 71 71))
		('grey28' (71 71 71))
		('gray29' (74 74 74))
		('grey29' (74 74 74))
		('gray30' (77 77 77))
		('grey30' (77 77 77))
		('gray31' (79 79 79))
		('grey31' (79 79 79))
		('gray32' (82 82 82))
		('grey32' (82 82 82))
		('gray33' (84 84 84))
		('grey33' (84 84 84))
		('gray34' (87 87 87))
		('grey34' (87 87 87))
		('gray35' (89 89 89))
		('grey35' (89 89 89))
		('gray36' (92 92 92))
		('grey36' (92 92 92))
		('gray37' (94 94 94))
		('grey37' (94 94 94))
		('gray38' (97 97 97))
		('grey38' (97 97 97))
		('gray39' (99 99 99))
		('grey39' (99 99 99))
		('gray40' (102 102 102))
		('grey40' (102 102 102))
		('gray41' (105 105 105))
		('grey41' (105 105 105))
		('gray42' (107 107 107))
		('grey42' (107 107 107))
		('gray43' (110 110 110))
		('grey43' (110 110 110))
		('gray44' (112 112 112))
		('grey44' (112 112 112))
		('gray45' (115 115 115))
		('grey45' (115 115 115))
		('gray46' (117 117 117))
		('grey46' (117 117 117))
		('gray47' (120 120 120))
		('grey47' (120 120 120))
		('gray48' (122 122 122))
		('grey48' (122 122 122))
		('gray49' (125 125 125))
		('grey49' (125 125 125))
		('gray50' (127 127 127))
		('grey50' (127 127 127))
		('gray51' (130 130 130))
		('grey51' (130 130 130))
		('gray52' (133 133 133))
		('grey52' (133 133 133))
		('gray53' (135 135 135))
		('grey53' (135 135 135))
		('gray54' (138 138 138))
		('grey54' (138 138 138))
		('gray55' (140 140 140))
		('grey55' (140 140 140))
		('gray56' (143 143 143))
		('grey56' (143 143 143))
		('gray57' (145 145 145))
		('grey57' (145 145 145))
		('gray58' (148 148 148))
		('grey58' (148 148 148))
		('gray59' (150 150 150))
		('grey59' (150 150 150))
		('gray60' (153 153 153))
		('grey60' (153 153 153))
		('gray61' (156 156 156))
		('grey61' (156 156 156))
		('gray62' (158 158 158))
		('grey62' (158 158 158))
		('gray63' (161 161 161))
		('grey63' (161 161 161))
		('gray64' (163 163 163))
		('grey64' (163 163 163))
		('gray65' (166 166 166))
		('grey65' (166 166 166))
		('gray66' (168 168 168))
		('grey66' (168 168 168))
		('gray67' (171 171 171))
		('grey67' (171 171 171))
		('gray68' (173 173 173))
		('grey68' (173 173 173))
		('gray69' (176 176 176))
		('grey69' (176 176 176))
		('gray70' (179 179 179))
		('grey70' (179 179 179))
		('gray71' (181 181 181))
		('grey71' (181 181 181))
		('gray72' (184 184 184))
		('grey72' (184 184 184))
		('gray73' (186 186 186))
		('grey73' (186 186 186))
		('gray74' (189 189 189))
		('grey74' (189 189 189))
		('gray75' (191 191 191))
		('grey75' (191 191 191))
		('gray76' (194 194 194))
		('grey76' (194 194 194))
		('gray77' (196 196 196))
		('grey77' (196 196 196))
		('gray78' (199 199 199))
		('grey78' (199 199 199))
		('gray79' (201 201 201))
		('grey79' (201 201 201))
		('gray80' (204 204 204))
		('grey80' (204 204 204))
		('gray81' (207 207 207))
		('grey81' (207 207 207))
		('gray82' (209 209 209))
		('grey82' (209 209 209))
		('gray83' (212 212 212))
		('grey83' (212 212 212))
		('gray84' (214 214 214))
		('grey84' (214 214 214))
		('gray85' (217 217 217))
		('grey85' (217 217 217))
		('gray86' (219 219 219))
		('grey86' (219 219 219))
		('gray87' (222 222 222))
		('grey87' (222 222 222))
		('gray88' (224 224 224))
		('grey88' (224 224 224))
		('gray89' (227 227 227))
		('grey89' (227 227 227))
		('gray90' (229 229 229))
		('grey90' (229 229 229))
		('gray91' (232 232 232))
		('grey91' (232 232 232))
		('gray92' (235 235 235))
		('grey92' (235 235 235))
		('gray93' (237 237 237))
		('grey93' (237 237 237))
		('gray94' (240 240 240))
		('grey94' (240 240 240))
		('gray95' (242 242 242))
		('grey95' (242 242 242))
		('gray96' (245 245 245))
		('grey96' (245 245 245))
		('gray97' (247 247 247))
		('grey97' (247 247 247))
		('gray98' (250 250 250))
		('grey98' (250 250 250))
		('gray99' (252 252 252))
		('grey99' (252 252 252))
		('gray100' (255 255 255))
		('grey100' (255 255 255))
		('dark grey' (169 169 169))
		('DarkGrey' (169 169 169))
		('dark gray' (169 169 169))
		('DarkGray' (169 169 169))
		('dark blue' (0 0 139))
		('DarkBlue' (0 0 139))
		('dark cyan' (0 139 139))
		('DarkCyan' (0 139 139))
		('dark magenta' (139 0 139))
		('DarkMagenta' (139 0 139))
		('dark red' (139 0 0))
		('DarkRed' (139 0 0))
		('light green' (144 238 144))
		('LightGreen' (144 238 144))
	).
! !

!XPMReadWriter class methodsFor: 'constants' stamp: 'cr 10/17/1999 20:32'!
keyChars
	"Return the string of characters that can be used as color keys, sorted roughly in order of
	 preference.  This order, BTW, resembles what appears to be the preference of various
	 other XPM writers, though it shouldn't matter.  A really cool enhancement would be to
	 pick keys based on how closely their corresponding characters match the color's brightness.
	 This would make the XPM into a kind of ASCII art for free.  If you're bored enough to
	 actually read all the way through this comment, you've definitely got enough time on
	 your hands to do this."

	^ '#$%&''()*+,-./abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'
! !

!XPMReadWriter class methodsFor: 'instance creation' stamp: 'cr 9/5/1999 20:51'!
new
	^super new initialize.! !

XPMReadWriter initialize!

!XPMReadWriter class reorganize!
('class initialization' initialize)
('constants' colorList keyChars)
('instance creation' new)
!


!SlicedFrameClientList class reorganize!
('instance creation' on:)
!


!PrefabScrollingManager reorganize!
('initialization' initialize)
('API' addClient:onFailure: clientAreaBounds extent: extentPadding extentPadding: fractionalPosition: fractionalXPosition: fractionalYPosition: logicalClientAreaExtent offset resizer: scrollBarWidth scrollBarWidth: scrollToShow: scrollToShow:withThreshold:)
('tests' needsResizer)
('accessing' clientAreaExtent logicalOrigin offsetRange)
('geometry' clientAreaResizedBy: clientToWorldCoordOffset normalizedClientAreaResizedBy:)
('resizing' adjustScroller: repositionScrollbars resizeSubmorphs resizeTransform)
('construction' attributeList)
('menu' addMoreCustomMenuItems: setExtentPadding setScrollerWidth)
!


!PrefabEditScrollableWrapper class reorganize!
('parts bin' descriptionForPartsBin)
!


!PrefabScrollBar class reorganize!
('parts bin' descriptionForPartsBin)
!


!PrefabRadioButton class reorganize!
('parts bin' descriptionForPartsBin)
!


!PrefabMorphHolder class reorganize!
('parts bin' descriptionForPartsBin)
!


!PrefabMiddleManager class reorganize!
('parts bin' xxxxdescriptionForPartsBin)
!


!Calculator class reorganize!
('instance creation' newInSystemWindow)
!


!PrefabManager class reorganize!
('parts bin' descriptionForPartsBin)
('API-instance creation' newInSystemWindow newInSystemWindowNamed:)
!


!PrefabManager reorganize!
('initialization' initialize)
('API' borderType borderType: close extent: frameColor frameColor: isAtomic openInSystemWindow openInSystemWindowNamed: title:)
('API-client management' addClient: addClient:atRelPosition: addClient:onFailure: allAtomicClients checkTags checkTagsAndDo: clientWithTag: clients hasClient: minimumBoundsContainingClients removeAllClients removeClient: resizer resizer: sortedClientList)
('API-keyboard' focusColor focusColor: setDefaultTabOrder setTabOrder:)
('API-keyboard actions' action:onKey: args:onKey: target:forShortcuts: target:onKey:)
('change reporting' layoutChanged)
('construction' attributeList)
('menu' addCustomMenuItems:hand: addMoreCustomMenuItems: displayConstructionMethod fixSize setFixedSize setMaxSize setMinSize toggleConstruction)
('extent operations')
('tests' isConstruction isContainer isResizable needsResizer)
('events' handlesMouseDown:)
('accessing' shortcuts tabOrder)
('client tags' allClientTags logicalOrigin)
('construction--code generation' clientsInBounds constructionMethod makeSourceToBuild:fromList:on: makeSourceToPopulatePaneNamed:varNames:on: writeAttribute:on:)
('construction junk' buildFromList:indent:on: buildFromMorphCollection:on: constructionMethodSourceNamed: writeConstructionMethodBodyOn:)
('dragging and dropping' acceptDroppingMorph:event: allowSubmorphExtraction privateRemoveMorph: repelsMorph:event: wantsDroppedMorph:event:)
('keyboard shortcuts' checkForShortcut:)
('private' privateSetResizer: responseFor:)
!


!PrefabListBox class reorganize!
('parts bin' descriptionForPartsBin)
!


!PrefabListBox reorganize!
('initialization' initialize)
('API-Appearance' at:color: at:foregroundColor: clearCustomColors color: disabledColor disabledColor: disabledForeground disabledForeground: elementHeight elementHeight: extent: font font: foregroundColor: scrollPosition scrollPosition: selectColor selectColor: selectForeground selectForeground:)
('API-Selection and Position' fractionalPosition fractionalPosition: selectionMode selectionMode: vScrollBar:)
('API-Actions' actionClicked: argsClicked: targetClicked:)
('API-Contents' addLast: at: at:put: at:put:withTag: removeAll removeAt: size)
('API-Position' visibleRatio)
('API-Selection' disableAt: disabledItems enableAt: selectedItems)
('construction' attributeList)
('event handling' paneClickedEvent:onLabel:)
('misc' test)
('menu' addCustomMenuItems:hand: disableSomeEntries fillWithJunk fillWithLotsOfJunk)
('private' backgroundFor: deSelectLabel: foregroundFor: markDisabled: rowFor: scrollTo: selectLabel: updateSlider visibleLines)
!


!PrefabLabel class reorganize!
('parts bin' descriptionForPartsBin)
!

PrefabKeystroke initialize!

!PrefabIconPanel reorganize!
('initialization' initialize)
('API' allowMultipleSelect allowMultipleSelect: clearSelection elementLayout elementLayout: extent: font font: iconExtent iconExtent: maxCharsDisplayed maxCharsDisplayed: rowLength rowLength: selectedItems selectionColor selectionColor:)
('API-Contents' addItemTagged:withPicture:withText: clearContents removeItemTagged:)
('API-Actions' actionDoubleClick: actionSelect: args: target:)
('placement' elementAttributesChanged geometryChanged)
('geometry' coordsForSlot: elementParcelExtent setExtent textPartHeight textPartWidth)
('contents' addEntry: colorSelected: createElement: positionElement:atSlot:)
('events' elementClickedEvent:onElement: elementDoubleClickedEvent:onElement:)
('junk' fill:)
!


!PrefabFrame class reorganize!
('parts bin' descriptionForPartsBin)
!


!PrefabFileSelector reorganize!
('initialization' initialize)
('window construction' buildOn: createAndHookupIconPanel fixEdges openWithLabel:)
('events--buttons' cancelPressed selectPressed upDirPressed)
('events--edit widgets' dirFieldChanged fileFieldChanged maskChanged)
('control behaviour' findAndActivateComponents hookUpButtonNamed:action: hookUpButtons hookUpEntryNamed:action: hookUpTextFields)
!


!PrefabEntry reorganize!
('initialization' initialize)
('API' extent: font font: foregroundColor foregroundColor: text text:)
('API-Actions' actionReturnPressed: argsReturnPressed: targetReturnPressed:)
('API-Keyboard' tabKey:)
('events' returnHit: scrollAfterSelection:changedFrom:)
('private' lineHeight)
('focus' hasLogicalFocus logicalKeyboardFocusChange: neverGetsFocus showFocus: tabPressedEvt: takeFocusOn:)
('focus-system' keyboardFocusChange:)
!


!PrefabEdit reorganize!
('initialization' initialize)
('API' extent: font font: foregroundColor foregroundColor: isReadOnly isReadOnly:)
('API-Behaviour' fractionalPosition fractionalPosition: scrollPosition scrollPosition: text text: vScrollBar: visibleRatio)
('API-Editor' beginningOfLine cursorDown cursorLeft cursorRight cursorUp cutSelection cutToEndOfLine deleteForwards endOfLine paste point point:)
('API-Keyboard' bindKey:to: bindKeyCollection: tabKey:)
('events' handlesMouseDown: handlesMouseOver: mouseDown: mouseEnter: mouseLeave: scrollAfterSelection:changedFrom: xxxmouseEnter: xxxmouseLeave:)
('private' findBeginningOfLineIn:from: findEndOfLineIn:from: lineHeight scrollTo: updateSlider visibleLines)
('focus' hasLogicalFocus logicalKeyboardFocusChange: neverGetsFocus showFocus: tabPressedEvt: takeFocusOn:)
('focus-system' keyboardFocusChange:)
('private-focus' restoreSelection saveSelection withEditorDo:)
!

Prefab initialize!

!Prefab class reorganize!
('class initialization' initialize initializeAll loadFixedFont loadImageLibrary)
('API-image library' addForm:named: addFormFromFile:named: availableImages formFor: formNamed: formNamed:ifAbsent: loadImagesIn:)
('API-fonts' fontNamed: nameForFont:)
('misc' includeInNewMorphMenu)
('constants-defaults' activateColor backgroundColor checkButtonCheckedColor checkButtonExtent defaultBorderWidth defaultButtonActivateKey defaultButtonBorderWidth defaultEditFont defaultEditTabbingKey defaultEntryFont defaultFocusColor defaultFrameBorderWidth defaultIconPanelElementPadding defaultIconPanelFontName defaultIconPanelIconExtent defaultIconPanelMaxCharsDisplayed defaultIconPanelRowLength defaultIconPanelSelectionColor defaultInnerBorderWidth defaultLabelFont defaultListBoxDisabledColor defaultListBoxDisabledForeground defaultListBoxFont defaultListBoxSelectionColor defaultListBoxSelectionForeground defaultMenuBorderWidth defaultMinimumSliceSize defaultScrollbarLength defaultScrollbarWidth defaultScrollingManagerExtentPadding defaultSeparatorThickness defaultTabbingKey foregroundColor listBoxElementHeight managerFrameClass radioButtonCheckedColor radioButtonCheckedColour radioButtonExtent scrollbarBackgroundColor scrollbarBorderWidth scrollbarSliderColor sliceDividerEndPadding sliceDividerWidth sliceHandleExtent windowFrameBorderWidth windowFrameColor windowFrameTextColor windowFrameTitleBarHeight)
('utilities' queryNumber:named: queryPoint:named:)
!


!IconPanelElement reorganize!
('initialization' initialize)
('component assembly' addPicture:sized: configLabelWithFont: entry:font:pictureExtent:labelWidth:belowOrBeside:)
('accessing' baseIcon elementLayout: font: panelEntry pictureExtent: textContents textPartWidth:)
('appearance' color:)
('layout' arrangeContents arrangeContentsBottom arrangeContentsRight arrangeLabel horizontalGapWidth totalWidth)
('junk')
!


!PositionalBinding class reorganize!
('instance creation' for:in:)
!

OrientationAdjuster initialize!

!OrientationAdjuster class reorganize!
('instance creation' on: on:orientedTo:)
('class initialization' initialize)
!


!IconPanelEntry reorganize!
('initialization' icon:text:tag:)
('accessing' element element: icon tag text)
!

"Postscript:

Initialize the class."

XPMReadWriter initialize.
Prefab loadImageLibrary.
"Prefab loadFixedFont."!

